_FindAlphaDn    equ 4A47h
_FindAlphaUp    equ 4A44h
_RclAns         equ 4AD7h
_ChkFindSym     equ 42F1h
_DispHL         equ 4507h
_CreateTempStr  equ 4324h
OP2             equ 8483h
GraphBuf        equ 9340h
intmask         equ %00001011

;===============================================================
;Grammer Calls **These are no longer accurate D:**
;===============================================================
;These are some calls found in the jump table. Some details may
;be given here or in the source.
;===============================================================
_ProgramStart       equ 4083h ; A program calls this to allow the Grammer parser to step in
_CompatCall         equ 4086h ; Name in OP1. Loads RAM. Checks header, z is good. A=Flashpage, BC=Size, HL=Data 
_SelectedProg       equ 4089h ; call if _CompatCall returns z
_ExecOP1            equ 408Ch ; Executes the program named in OP1 as a Grammer program
_ParserNext         equ 408Fh ; 
_ParseArg           equ 4092h ; 
_ReadByte           equ 4095h ; ld bc,((hl)) \ inc ((hl))
_Input              equ 4098h ; BC=BufSize-1, HL=BufLoc. Input routine. BC points to the string
_PCycle             equ 409Bh ; BC=ParticleBuffer
_PCycleDefault      equ 409Eh ; 
_PBufInfoDef        equ 40A1h ; Output: BC=BufSize,DE=#ofParticles,HL=ParticleData
_PBufInfo           equ 40A4h ; Input: HL=ParticleBuf pointer, Output: Same as above
_NextParticle       equ 40A7h ; Input: PBufInfo, Output: HL points to new particle, nz if enough room
_AddParticle        equ 40AAh ; Input: BC=ParticlePlot, HL=ParticleLoc, Output: particle added and drawn
                              ; ld (hl),c \ inc hl \ ld (hl),b \ ret
_ShiftGraphBuf      equ 40ADh ; Input: A=Direction (use direct arrow key output), C=number of shifts
_ShiftGraphUpA      equ 40B0h ; A is the number of shifts
_ShiftGraphRightA   equ 40B3h ; ""
_ShiftGraphLeftA    equ 40B6h ; ""
_ShiftGraphDownA    equ 40B9h ; ""
_ZeroMemF           equ 40BCh ; 
_SetMemF            equ 40BFh ; 
_ZeroMemE           equ 40C2h ; 
_SetMemE            equ 40C5h ; 
_nCr                equ 40C8h ; Input: HL=n, DE=r, Output: BC=Result
_SetSpeed           equ 40CBh ; Input: C is 0=6MHz, 1=15MHz, 2=Toggle
_ZeroMem            equ 40CEh ; Input: HL=Location, BC=size
_ClrDraw            equ 40D1h ; 
_ClrHome            equ 40D4h ; 
_MaxMin             equ 40D7h ; Input: HL,BC Output: BC
_SetSmallMem        equ 40DAh ; Input: A=Value, B=Size, HL=Location
_InvSmallMem        equ 40DDh ; Input: B=Size, HL=Location
_Rand               equ 40E0h ; Input: Loads random values to the registers
_expr               equ 40E3h ; Input: BC=Location of code Output: BC is result
_lcmBC_DE           equ 40E6h ; Input: BC,DE Output: HL=BC=lcm(HL,BC)
_gcdHL_BC           equ 40E9h ; Input: HL,BC Output: BC=gcd(HL,BC)
_Pause              equ 40ECh ; Input: BC=hundredths of seconds to pause, Output: BC=input DE
_PlotPixel          equ 40EFh ; 
_Call               equ 40F2h ; Input: BC points to the call
_PutSM              equ 40F5h ; Input: HL points to the string, BC=Size
_PutSprite          equ 40F8h ; Input: A=Method, BC=(x,y), DE=Sprite, H=height, L=Width (not used yet)
_BreakProgram       equ 40FBh ; 
_ErrorJump          equ 40FEh ; 
_PutTile            equ 4101h ; Input: A=Method, B=Width, C=Height, DE=SpriteData, HL=Location
_CheckKey           equ 4104h ; Input: A=Key to check
_GetKey             equ 4107h ; Output: A,BC is the keypress
_ParseFullArg       equ 410Ah ; 
_ParseNextFullArg   equ 410Dh ; 
_ParseCondition     equ 4110h ; 
_Sine               equ 4113h ; 
_EndOfCommand       equ 4116h ; 
_EndOfArg           equ 4119h ; 
_EndOfArgNotSto     equ 411Ch ; 
_FindEndToken       equ 411Fh ; Input: HL is the address, Output: HL points to the byte after the proper End
_TokensToASCII      equ 4122h ; Input: HL=StringLoc, Output: BC=Size, DE points to string
_GetGrammerStr      equ 4125h ; Input: HL=StartLoc, Output: BC=Size
_pVarPointer        equ 4128h ; Input: A=pVar, HL=NextByte, Output: HL points to var
_EndOfLine          equ 412Bh ; Input: HL=Start, Output: HL is tyhe next line
_EndOfNumber        equ 412Eh ; Input: HL points to the number, Output: HL points to the end
_EndOfHexNum        equ 4131h ; Input: HL points to start, Output: HL points to the end
_IsHexTok           equ 4134h ; Input: DE points to byte, Output: DE is incremented, nc if hex token
_ConvRStr           equ 4137h ; Input: HL points to the number (or byte before), Output: HL points to the byte after the number, BC is the result
_HL_Times_BC        equ 413Ah ; Input: HL,BC, Output: DEHL is result, A is 0
_DE_Times_BC        equ 413Dh ; Input: DE,BC, Output: DEHL is result, A is 0
_DE_Div_BC          equ 4140h ; Input: DE,BC, Output: HL=quotient, DE is remainder
_HL_Div_BC          equ 4143h ; Input: HL,BC, Output: HL=quotient, DE is remainder
_HL_Times_A         equ 4146h ; Input: HL,A, Output: DE=original HL, HL=Product, B is 0
_DE_Times_A         equ 4149h ; Input: DE,A, Output: HL=Product, B is 0
_IsHLAtEOF          equ 414Ch ; Input: HL, Output: DE is (progEnd), c if HL is not at or past the EOF
_SearchString       equ 414Fh ; Input: BC=Size, DE=SearchStr, HL=Start, Output: cf if there was a match, HL points to match
_CheckStatus        equ 4152h ; Output: z if ON is pressed, c if 15MHz mode set
_GraphToLCD         equ 4155h ; 
_BufferToLCD        equ 4158h ; Input: HL points to the buffer
_DrawRectToGraph    equ 415Bh ; Input: A=Type, B=Height, C=Y-Coord, D=Width, E=X-Coord
_PutSS              equ 415Eh ; Input: HL points to sting, D is the byte to end at, (textRow), (textCol)
_GPutSS             equ 4161h ; Input: HL points to the zero terminated string, b=Col, c=Row
_GPutS              equ 4164h ; Input: HL points to the zero terminated string, (textRow), (textCol)
_PutSC              equ 4167h ; Input: A=char, (textRow), (textCol), Output: Updated coords
_PutFS              equ 416Ah ; Input: A=char, (textRow), (textCol)
_SqrtHL             equ 416Dh ; Input: HL, Output: E
_Circle             equ 4170h ; Input: DE=center(x,y), c=radius, a=method
_SetMem             equ 4173h ; Input: A is the fill byte, HL is the location, BC is the size
_ConvNumBase        equ 4176h ; Input: C is the base, HL is the number, Output: A=BC=#ofDigits, DE=0, HL=pointer to number string
_PrimeTest          equ 4179h ; Input: HL, Output: BC=LowestFactor, HL is the result after dividing by BC, cf if prime
_HL_Div_C           equ 417Ch ; Input: HL,C Output: A is the remainder, B is 0, HL is the quotient
_Is_2_Byte          equ 417Fh ; Input: A, Output: z if 2-byte
_Is_Var_Name        equ 4182h ; Input: A, Output: z if start of a var name
_DrawLine           equ 4185h ; Input: A=Method, BC=(x1,y1), DE=(y2,x2)
_IncHLMem1          equ 4188h ; Output: HL is incremented, if it equals 8000h, the flash page in memory bank 1 is incrmented and HL is set to 4000h
_Conv_OP1           equ 418Bh ; Output: HL is incremented by 9, DE is the value, A is the 8-bit value
_ConvDecAtHL        equ 418Eh ; Input: Hl points to the FP number to convert, Output: Same as above
_GetPixelLoc        equ 4191h ; Input: bc=(x,y), Output: HL points to the byte, A is the mask, c if on screen
_HexTok             equ 4194h ; Input: HL=Output, DE=Input (hex), BC=Output size
_DEHL_Mul_IXBC      equ 4197h ; Output: IXHLDEBC is the 64-bit result
;_NameLength         equ 419Ah ; Input: HL points to the zero terminated string, Output: same as above
_IsOP1GrammerProg   equ 419Dh ; Output: z if Grammer prog, A=flashpage of data, BC is the sixe, HL points to the data
_ReadArc            equ 41A0h ; Input: A=page, HL=Input, DE=output, BC=size
_CallError          equ 41A3h ; Input: A is the error code
_ONErr              equ 41A6h ; 
_MemErr             equ 41A9h ; 
_C_Div_L            equ 41ACh ; Output: A is the remainder, BC is the quotient
_TileMap1           equ 41AFh ; Input: DE=MapLoc, BC=TileLoc, HL=MapWidth, A=TileLogic, (TempWord2)=MapX, (TempWord3)=MapY
_HL_SDiv_BC         equ 41B2h ; Output: HL=Quotient, DE=remainder
_VPutC              equ 41B5h ; 
_RoundHL_Div_C      equ 41B8h ; Output: HL is the quotient, nc means it rounded up
_SearchLine         equ 41BBh ; Input: HL=SearchStart, BC=number of bytes to search, DE=LineNumber, A is the linebyte, Output: BC is the number of bytes left, DE points to the line, HL i sthe length of the line
_SendByte           equ 41BEh ; 
_GetByte            equ 41C1h ; 
_PutIM              equ 41C4h ; 
_GPutSI             equ 41C7h ; 
_DrawRectToGraphI   equ 41CAh ; 
_ParseFullArgI      equ 41CDh ; 
_CallI              equ 41D0h ; 
_DEHL_Mul_32Stack   equ 41D3h ; 
;===============================================================
;RAM used by Grammer:
;     108 bytes for pointer vars stored in smallEditRAM
;      10 bytes for TempWords stored in OP6 and 1 byte of OP5
;       2 bytes for text position stored in OP6
;      10 bytes for Status stored in iMathPtr1
;===============================================================
smallEditRAM        equ 90D3h            ;108 bytes
iMathPtr1           equ 84D3h            ;10 bytes
OP6                 equ 84AFh            ;11 bytes
cmdShadow           equ 966Eh            ;128 bytes
;984Dh appErr1-26 bytes
;nameBuff-12 bytes
;userMenuSA-13 bytes

ThetaPrimeVar       equ 913Dh       ;        

TempWord1           equ 84ACh       ;2       2
TempWord2           equ TempWord1+2 ;2       4
TempWord3           equ TempWord2+2 ;2       6
TempWord4           equ TempWord3+2 ;2       8
TempWord5           equ TempWord4+2 ;2      10
textRow             equ TempWord5+2 ;1      11
textCol             equ textRow+1   ;1      12
randSeed            equ textCol+1   ;2      14

TextPauseTime       equ 984Dh           ;1      
GrayBufPtr          equ TextPauseTime+1 ;2      
Ans                 equ GrayBufPtr+2    ;2      
StackCount          equ Ans+2           ;2
StackLoc            equ StackCount+2    ;2
OutputLogic         equ StackLoc+2      ;1
ErrorLoc            equ OutputLogic+1   ;2
;ForBackUp           equ ErrorLoc+2      ;2
;0 bytes left

SPSave              equ 985Ah           ;2       8
;12 bytes left
progStart           equ 965Bh           ;2       6
progPtr             equ progStart+2     ;2       2
progEnd             equ progPtr+2       ;2       4

BufPtr              equ 84E7h
parseError          equ 84EBh           ;2
FontPointer         equ parseError+2    ;2
PBufPtr             equ 9311h           ;2

IntLoc              equ 8000h   ;2
IntCount            equ 8002h   ;2  Counts down from IntMax, at zero, executes code at IntLoc, and resets to IntMax
IntMax              equ 8004h   ;2
PBufType            equ 8006h   ;1
PBufRule            equ 8007h   ;2
GrayMask            equ 8009h   ;2
GrayRotate          equ 800Bh   ;1 upper 5 bits are for text modes

ForBackUp           equ 800Ch   ;2

PBuf                equ 9872h
SetLinePix          equ 8101h
LineTypeVar         equ SetLinePix+5
interruptLoc        equ 8A8Ah
TSA                 equ 82A5h

RectData   equ 8481h
;==============================
;Flags
;==============================
InternalFlag    equ 33
SlowTextFlag    equ   0
IntActiveFlag   equ   1
FactorialFlag   equ   2
errorChecking   equ   3
grayFlag        equ   4   ;this determines the checker pattern for the next gray object drawn
bit32           equ   5   ;This determines if the output was 32-bit or not
Mod2nd          equ   6
grayMode        equ   7   ;This determines the checker pattern for grayscale mode

CursorFlags     equ 12
CursorActive    equ   3

UserFlags       equ 34
InvertTextFlag  equ   0
InvertLCDFlag   equ   1
OnBlockFlag     equ   2
baseInput       equ   3
pxlBoundsRes    equ   4
;    equ   5
;    equ   6

ParticleFlag    equ 35
Xis0            equ 0
Xis95           equ 1
Yis0            equ 2
Yis63           equ 3
OffScrn         equ 4


onFlags         equ 9        ;on key flags
onInterrupt     equ   4      ;1=on key interrupt request

curFlags        equ 12       ;Cursor
fmtEdit         equ   0      ;1=format number for editing
curAble         equ   2      ;1=cursor flash is enabled
curOn           equ   3      ;1=cursor is showing
curLock         equ   4      ;1=cursor is locked off
cmdVirgin       equ   5      ;1=nothing has been typed in cmd bfr
;----------------------------------------------------------------------
indicFlags        equ 18         ;Indicator flags
indicRun          equ   0        ;1=run indicator ON
shiftFlags        equ 18         ;[2nd] and [ALPHA] flags
shift2nd          equ   3        ;1=[2nd] has been pressed
shiftAlpha        equ   4        ;1=[ALPHA] has been pressed
shiftLwrAlph      equ   5        ;1=lower case, 0=upper case
shiftALock        equ   6        ;1=alpha lock has been pressed
shiftKeepAlph     equ   7        ;1=cannot cancel alpha shift
