;Grammer
;================:
;\\     /\       :
; \\   //\\      :
;  \\ //  \\     :
;   \\/----\\    :
;   //\----//\   :
;  // \\  // \\  :
; //   \\//   \\ :
;//     \/     \\:
;================:
;Project.........Grammer
;Program.........Grammer
;Author..........Zeda Elnara (ThunderBolt)
;E-mail..........xedaelnara@gmail.com
;Size............
;Language........English
;Programming.....Assembly
;Version.........
;Last Update.....6:45 AM 5/22/2012
.binarymode ti8xapp                 ; TI-83+ Application

.deflong bjump(label)               ; Jump macro
   call BRT_JUMP0
   .dw label
.enddeflong

.deflong bcall(label)               ; Call macro
   rst rBR_CALL
   .dw label
.enddeflong

.variablename "Grammer "

.defpage 0, 16384, $4000          ; Page 0 definition
.page 0
.block 128
.nolist
#define    TASM
#define    bcall(xxxx)     rst 28h \ .dw xxxx
#define    equ .equ
#define    ProgStart    $4080
#define    LCDDelay()   .db $DB,$10,$87,$38,$FB
#define    rotatemask() sla c \ jr nc,$+4 \ set 2,c
.include   "Grammer.inc"
#define     Coord(yy,xx)     .db 01,yy,xx
.list
     jp EndOfEntries
jumptable:
     jp ProgramAccessStart
     jp CompatCall
     jp SelectedProg
     jp ExecOP1
     jp ParserNext
     jp ParseArg
     jp g_ReadByte
     jp g_Input
     jp g_ParticleCycle
     jp DefaultBuffer
     jp PBufInfoDef
     jp PBufInfo
     jp NextParticle
     jp AddParticle
     jp ShiftGraphBuf
     jp ShiftGraphUpA
     jp ShiftGraphRightA
     jp ShiftGraphLeftA
     jp ShiftGraphDownA
     jp ZeroMemF
     jp SetMemF
     jp ZeroMemE
     jp SetMemE
     jp nCrAlgorithm
     jp SetSpeed
     jp ZeroMem
     jp g_ClrDraw
     jp g_ClrHome
     jp g_Max
     jp SetSmallMem
     jp InvertMem
     jp g_Rand
     jp expr
     jp LCM_BC_DE
     jp gcdHL_BC
     jp Pause
     jp PlotPixel
     jp g_Call
     jp PutSM
     jp DrawPixelCoordSprite
     jp BreakProgram
     jp ErrorJump
     jp DrawSpriteXxY
     jp CheckKey
     jp GetKey
     jp ParseFullArg
     jp ParseNextFullArg
     jp ParseCondition
     jp Sine
     jp EndOfCommand
     jp EndOArg
     jp EndOArgNotSto
     jp FindEndToken
     jp GetGrammerText
     jp GetGrammerStr
     jp VarPointer
     jp EndOfLine
     jp ret
     jp ret
     jp IsHexTok
     jp ConvRStr
     jp HL_Times_BC
     jp DE_Times_BC
     jp DE_Div_BC
     jp HL_Div_BC
     jp HL_Times_A
     jp DE_Times_A
     jp IsHLAtEOF
     jp SearchString
     jp CheckStatus
     jp GraphToLCD
     jp BufferToLCD-4
     jp DrawRectToGraph
     jp PutSS
     jp GPutSS
     jp GPutS
     jp PutSC
     jp PutFS
     jp SqrtHL
     jp Circle
     jp SetMem
     jp ConvNumBase
     jp PrimeTest
     jp HL_Div_C
     jp Is_2_Byte
     jp Is_Var_Name
     jp DrawLine
     jp IncHLMem1
     jp Conv_OP1
     jp ConvDecAtHL
     jp GetPixelLoc
     jp HexTok
     jp DEHL_Mul_IXBC
     jp BufferToLCD
     jp IsOP1GrammerProg
     jp ReadArc
     jp CallError
     jp ONErr
     jp ErrMem
     jp C_Div_L
     jp TileMap1
     jp HL_SDiv_BC
     jp VPutC
     jp RoundHL_Div_C
     jp SearchLine
     jp p_SendByte
     jp p_GetByte
     jp PutIM
     jp GPutSI
     jp DrawRectToGraphI
     jp ParseFullArgI
     jp CallI
     jp DEHL_Mul_32Stack
     jp CopyZStr
     jp CreateZVar
     jp ChkFindVar
     jp ChkFindVarAtDE
     jp SearchVarBC
     jp FindVarSymAtHL
     jp FindVarSymAtDE
     jp FindSym
     jp FindVar
EndOfEntries:
     call SetUpData
     call StartMenu
     call GetKey \ or a
     jr nz,$-4
     ld de,966Eh
     ld hl,8508h
     ld bc,128
     ldir
     bcall(4027h)
StartMenu:
     ld bc,0
        ld (TempWord3),a
        ld (TempWord4),bc
        ld (TempWord5),hl
;======
     call FindGVarData
     ld a,b \ or a
     jr nz,GramVarArc
       ld hl,9BAEh
       inc de \ inc de \ inc de \ inc de
       ex de,hl \ in a,(6)
       cp (hl) \ ex de,hl
       jr z,GramVarArc
       ld bc,3 \ lddr
GramVarArc:
;======
       in a,(6)
       ld hl,GrammerHook
       bcall(5026h)
;======
     ei
     ld hl,ZeroProg
     rst 20h
     ld hl,86ECh
     ld (BufPtr),hl
     ld (GrayBufPtr),hl
     ld bc,768
     call ZeroMem
     ld a,-1
     ld hl,86ECh+672
     ld b,12
     call SetSmallMem
     ld hl,58
     ld (TextRow),hl
     call GPutSI
     .db "Gram AppV Asm  Exit Hook",0

     ld bc,0838h
     ld de,111h
     ld a,4
       push af
       push bc
       push de
       ld a,1
       call DrawRectToGraph
       ld a,20
       pop de
       add a,e
       ld e,a
       pop bc
       pop af
       dec a
       jr nz,$-16
     in a,(6)
     ld hl,9BCAh
     cp (hl)
     ld bc,0739h
     jr nz,$+18
     bit 0,(iy+35h)
     jr z,$+12
       ld de,124Eh
       ld a,2
       push bc
       call DrawRectToGraph
       pop bc
     ld de,1200h
     ld a,2
     call DrawRectToGraph

     xor a \ ld (8479h+22),a
     ld (8A12h),a
     ld (8479h+44),a
     ld (8479h+52),a
     ld hl,ChooseProgText
     ld b,a \ ld c,a
     call GPutSS
     ld hl,StrVersion
     ld bc,48
     call GPutSS
     ld hl,GramHeader
     ld (8000h),hl
     ld a,3
SelectProgLoop:
     push af
     cp 3
     jr nz,$+17
FUP:
       bcall(_FindAlphaUp) \ jr c,NoMoreProgs
       ld hl,(8000h)
       call IsOP1HeaderMatch
       jr nz,$-11
       jr FoundProg
     cp 2
     jr nz,NoMoreProgs
       bcall(_FindAlphaDn) \ jr c,NoMoreProgs
       ld hl,(8000h)
       call IsOP1HeaderMatch
       jr nz,$-11
FoundProg:
     ld hl,8478h
     ld de,8478h+44
     ld bc,9 \ ldir
NoMoreProgs:
     Coord(6,3)
     ld hl,8479h+44
     call GPutSS
     ld hl,Str8Space
     call GPutS
     call GraphToLCD
     ld bc,5
     call g_Pause
     pop af
     ld h,a
     call GetKey \ cp h
     jr z,$-5
     cp 11
     jr nz,$+6
     set 2,(iy+33)
     cp 10
     jr nz,$+6
     res 2,(iy+33)
     cp 15 \ ret z
     cp 50 \ ret z
     cp 53 \ jr nz,CheckAppV
       ld a,8
       xor (iy+34)
       ld (iy+34),a
       call SetHeaderMenu
       ld de,1000h
       ld bc,0739h
       ld a,2
       call DrawRectToGraph
       xor a
       ld (8479h),a
       ld (8479h+44),a
       ld a,53 \ push af
       jp FUP
       
CheckAppV:
     cp 52 \ jr nz,CheckASM
       ld a,16
       ld hl,8478h
       xor (hl)
       ld (hl),a
       inc l
       xor a
       ld (hl),a
       ld (8479h+44),a
       ld de,1411h
       ld bc,0739h
       ld a,2
       call DrawRectToGraph
       ld a,52 \ push af
       jp FUP
CheckASM:
     cp 51 \ jr nz,CheckHook
       ld a,4
       xor (iy+34)
       ld (iy+34),a
       call SetHeaderMenu
       ld de,1326h
       ld bc,0739h
       ld a,2
       call DrawRectToGraph
       xor a
       ld (8479h+44),a
       ld (8479h),a
       ld a,51 \ push af
       jp FUP
CheckHook:
     cp 49 \ jr nz,ProgSelect
       in a,(6)
       ld hl,9BCAh
       cp (hl)
       ld hl,TokenHook
;Manually setting hook
       ld (9BC8h),hl
       ld (9BCAh),a
       jr nz,SetTokenHook
       bit 0,(iy+35h)
       jr z,SetTokenHook
       res 0,(iy+35h)
       jr $+6
SetTokenHook:
       set 0,(iy+35h)
       ld de,124Eh
       ld bc,0739h
       ld a,2
       call DrawRectToGraph
       ld hl,ChooseProgText
;       ld bc,0
       call GPutSS
       ld a,49
       push af
       jp NoMoreProgs
ProgSelect:
     cp 9
     jp nz,SelectProgLoop
SelectedProg:
     ld hl,9340h
     ld (BufPtr),hl
     ld de,8478h
     ld hl,8478h+44
     ld bc,9 \ ldir
     call FindVar
     ret c
     ld hl,9670h
     ld a,$BB
     cp (hl)
     jr nz,PIG
     inc l
     ld a,$6D
     cp (hl)
     jr nz,PIG
       push af
       push af
       push af
       push af       
       jp EndHook
PIG:
     ld a,(TempWord3)
     or a \ jr z,ExecProgNow
     ld hl,GramTempName
     rst 20h
     ld hl,(TempWord4)
     ld a,h \ or l
     ret z
     ld a,16h
     bcall(4E70h)
     inc de \ inc de
     ld a,(TempWord3)
     ld bc,(TempWord4)
     ld hl,(TempWord5)
     call ReadArc
     ld hl,8478h+33
     rst 20h
ExecProgNow:
;     pop de \ pop af
;     or a
;     jr z,ProgramAccessStart-3
;     ld hl,9BAEh           ;ParserHookPtr
;     ld bc,3
;     inc de \ inc de
;     ld a,(de) \ cp (hl)
;     jr z,ProgramAccessStart-3
;     lddr
     jp ExecOP1
ProgramAccessStart:
;        call SetUpData
        bcall(_RclAns)      ;EFD74A
        sub 4               ;D604         Check if string...
        jr z,$+15           ;280D
          ld bc,6             ;010600
          ld hl,965Bh         ;215B96
          ld de,progStart     ;11****
          ldir                ;EDB0
          jr grazh            ;18**
        ex de,hl            ;EB
        ld c,(hl)           ;4E
        inc hl              ;23
        ld b,(hl)           ;46
        inc hl              ;23
        ld de,8478h         ;117884
        ldir                ;EDB0
        ld (de),a           ;12
ExecOP1:
        ld hl,8478h
        ld de,9652h
        ld bc,9 \ ldir
        call FindVar
        ld a,b
        ret c               ;D8
        or a \ ret nz
        ex de,hl            ;EB
        ld c,(hl)           ;4E
        inc hl              ;23
        ld b,(hl)           ;46
        inc hl              ;23
        ld (965Bh),hl
        ld (progPtr),hl     ;227298
        ld (progStart),hl   ;227698
        ld h,a \ ld l,a
        ld (parseError),hl
        add hl,bc           ;09
        ld (progEnd),hl     ;227498
;        dec hl              ;2B
;        ld a,(hl)           ;7E
;        cp $D9              ;FED9       Stop token
;        ret nz              ;C0
grazh:
        call SetUpData
        ld hl,BreakProgram
        push hl
ParserNext:
        bit 1,(iy+33)
        jp nz,NoInt
        ld hl,(8000h)
        ld a,h \ or l
        jr z,NoInt
        ex de,hl
        ld hl,(8002h)
        dec l
        jr nz,NoFire
        dec h
        jr nz,NoFire
        ld hl,(progPtr)
        push hl
        ld (progPtr),de
        set 1,(iy+33)
        push bc
        call ParserNext
        pop bc
        pop hl
        ld (progPtr),hl
        ld hl,(8004h)
NoFire:
        ld (8002h),hl
        res 1,(iy+33)
NoInt:
        bit 2,(iy+34)
        call z,CheckStatus
        call z,ONErr
        ld de,ParserNext    ;11****
        push de             ;D5
ParseArg:
        ld hl,(progPtr)    ;2A7298
        bit 1,(iy+33)
        jr nz,$+3
          ei
        ld a,(hl)
        inc hl
        ld (progPtr),hl
        ld hl,CommandJumpTable
        ld e,a \ ld d,0
        add hl,de \ add hl,de
        ld e,(hl) \ inc hl \ ld d,(hl)
        push de
        ld hl,(progPtr)    ;2A7298
        ret
NewLine:
        ld (Ans),bc
IncPtr:
ErrbadToken:
Ret:
        ret
FracToken:
       ld h,b \ ld l,c
       call PrimeTest
       ld (ThetaPrimeVar),bc
       ld b,h \ ld c,l
       ret
OutputToken:
       ld a,(hl)
       cp 11
       jr nz,$+10
         call ParseNextFullArg
         ld a,c
         ld (OutputLogic),a
         ret
       call ParseFullArg
       ld de,GrayRotate
       ex de,hl
       ld a,%11100111
       and (hl)
       ld (hl),a
       ld a,c
       and 3
       bit 0,a
       ld bc,vFont
       jr nz,$+5
       ld bc,FontSet
       rlca
       rlca \ rlca
       or (hl)
       ld (hl),a
       ld a,(de)
       cp 2Bh \ call z,ParseNextFullArg
       ld (FontPointer),bc
       ret
augment:
       call ParseFullArg
       ld h,b \ ld l,c
       bcall(42FDh)
       jp c,ErrMem
       push de
       call ParseNextFullArg
       push bc
       ld hl,(progPtr)
       inc hl
       ld (progPtr),hl
       call GetVarInfo
       jp c,Pop2Exit
       or a \ jp nz,Pop2Exit
     ld hl,(progPtr)
     ld (965Dh),hl
     ex de,hl
     ld c,(hl) \ inc hl
     ld b,(hl)
     ld (TempWord1),hl
       pop de \ pop hl
InsertData:
       push hl
       add hl,bc
       ld b,h \ ld c,l
       ld hl,(TempWord1)
       ld (hl),b \ dec hl
       ld (hl),c \ inc hl \ inc hl
       add hl,de
       pop de
;hl points to where to insert data
;de is the number of bytes to insert
       push de \ push hl
       ld a,h \ or l
       jr z,$+6
       ex de,hl
       bcall(42F7h)
       ld hl,(965Dh)
       ld (progPtr),hl
       pop hl \ pop bc
       ld d,h \ ld e,l
       jp ZeroMem
PtChange:
       call ParseFullArg       ;To get the tilemap routine correct
       call ParseNextFullArg   ;Map Data
       push bc
       call ParseNextFullArg   ;Tile Data
       push bc
       call ParseNextFullArg   ;MapWidth
       push bc
       call ParseNextFullArg   ;MapX offset
       ld (TempWord2),bc
       call ParseNextFullArg   ;MapY offset
       ld (TempWord3),bc
       call ParseNextFullArg   ;Sprite Method
       push bc
       ld bc,(BufPtr)
       ld (TempWord5),bc
       cp 2Bh
       call z,ParseNextFullArg
       ld (BufPtr),bc
       pop bc
       ld a,c
       pop hl
       pop bc
       pop de
       call TileMap1
       ld hl,(TempWord5)
       ld (BufPtr),hl
       ret
solveSet:
       ld a,(hl) \ inc hl \ ld (progPtr),hl
       sub 30h \ ld b,a
       ld a,(hl)
       jr nz,CopyDataUp
         inc hl \ ld (progPtr),hl
         call GetVarInfo2 \ ret c
         push af \ push hl \ push bc
         ld hl,(progPtr)
         inc hl \ ld (progPtr),hl
         call GetVarInfo
         jr c,$+5
           bcall(4FC6h)

         ld hl,(progPtr)
         ld a,2Bh \ cp (hl)
         pop bc
         call z,ParseNextFullArg
         push bc
         ld bc,0
         ld a,(hl)
         cp 2Bh
         call z,ParseNextFullArg
         pop de \ pop hl
         add hl,bc \ push hl
         push de
         ex de,hl


         ld a,(8478h)
         and 1fh
     bcall(42FDh)       ;EnoughMem
     jp c,ErrMEM
     ex de,hl
         bcall(4E70h)
         inc de \ inc de
         pop bc \ pop hl \ pop af
         push de \ push bc
         call TSA
         pop hl \ ld (ThetaPrimeVar),hl
         pop bc \ ret
CopyDataUp:
       djnz CopyDataDown
         push bc
         call ParseNextFullArg
         push bc
         call ParseNextFullArg
         push bc
         call ParseNextFullArg
         pop de \ pop hl
         ldir
         pop bc
         ret
CopyDataDown:
       djnz ErrorHandle
         push bc
         call ParseNextFullArg
         push bc
         call ParseNextFullArg
         push bc
         call ParseNextFullArg
         pop de \ pop hl
         lddr
         pop bc
         ret
ErrorHandle:
       djnz CallError
         call ParseNextFullArg
         ld (ParseError),bc
         ret
CallError:
       djnz WritePort
         call ParseNextFullArg
         ld a,c
         cp 2
         jr nz,HandleError
          call ParseNextFullArg
          ld h,b \ ld l,c
          call GetGrammerText
          ld hl,13 \ or a
          sbc hl,bc
          jr nc,$+5
CustomError:
            ld bc,13
          ex de,hl
          ld de,984Dh
          ldir
          xor a
          ld (de),a
          ld a,2
HandleError:
         jp GramHandl
WritePort:
     djnz ReadPort
     call ParseNextFullArg
     push bc
     ld c,0
     cp 2Bh
     call z,ParseNextFullArg
     pop de
     out (c),e
     ret
ReadPort:
     djnz EndSolveSet
     ld c,0
     cp 2Bh
     call z,ParseNextFullArg
     in c,(c)
     ld b,0
EndSolveSet:
     ret
ISToken:
       ld a,(hl) \ inc hl
       call VarPointer
       ret nc
       ld (progPtr),de
g_ReadByte:
       ld e,(hl) \ inc (hl) \ inc hl \ ld d,(hl)
       jr nz,$+3
         inc (hl)
       ex de,hl
       ld c,(hl)
       ld b,0
       dec de \ ex de,hl
       ret
AnsToken:
       ld bc,(Ans) \ ret
InputToken:
       ld bc,Str8Space+7
       ld a,(hl)
       call EndOArg
       jr z,SetInputStr
         call ParseFullArg
         ld h,b
         ld l,c
         ld de,8478h
         call GetGrammerText+3
         ld h,b
         ld l,c
         add hl,de
         ld (hl),20h
         inc l
         ld (hl),0
         ld b,d
         ld c,e
SetInputStr:
       ld (TempWord5),bc
       ld hl,966Eh
       ld bc,127
g_Input:
       res 0,(iy+35)
       xor a
       out (0),a
       ld (TempWord3),hl
       add hl,bc
       ld (TempWord4),hl
       ld hl,(textRow)
       ld (TempWord2),hl
       set 3,(iy+33)
       ld hl,(TempWord5)
       call GPutS
       call GraphToLCD
;ClearP:
       ld hl,(TempWord2)
       ld (textRow),hl
       ld hl,(TempWord3)
       ld (hl),3Eh \ inc hl
       ld (hl),3Fh
       ld (TempWord1),hl
InputLoop:
       res 4,(iy+9)
       bcall(500Bh)
; jr $
       cp 5 \ jp z,EnterP
       cp 9 \ jr z,ClearP
       cp 10 \ jr z,DelP
       bcall(4A02h)
       jp po,InputLoop
       ld hl,(TempWord1)
       ld bc,(TempWord4) \ or a
       sbc hl,bc \ add hl,bc
       jr nc,InputLoop
       ld a,d \ or a
       jr z,$+4
         ld (hl),d \ inc hl
       ld (hl),e \ inc hl
       ld (TempWord1),hl
       ld (hl),3Fh
       call DispInputString
       jr InputLoop
ClearP:
DelP:
       call DelInput
       jr InputLoop
DelInput:
       ld bc,0
       ld hl,(TempWord1)
       ld de,(TempWord3) \ inc de \ inc de
; jr $
       or a \ sbc hl,de
       add hl,de
       jr c,DelDone
       dec hl \ dec hl
       ld a,(hl) \ call Is_2_Byte
       jr z,$+3
       inc hl
       ld (TempWord1),hl
       bcall(4594h)
DelDone:
       ld (hl),3Fh
       ld a,b
       or c
       jr z,$+7
       push bc
       set 0,(iy+35)
DispInputString:
       ld hl,(TempWord3)
       call GetGrammerText
       ld hl,(TempWord2)
       ld (TextRow),hl
       ex de,hl
       cpi
       ld a,1
       xor (iy+34)
       ld (iy+34),a
       call PutSM
       ld a,1
       xor (iy+34)
       ld (iy+34),a
       ld hl,(textRow)         
       push hl
       bit 0,(iy+35)
       jr z,NoDelToken
         res 0,(iy+35)
         pop hl
         pop bc
         push hl
         push bc
         ld a,20h
         call PutSC
         pop bc
         cpi
         jp pe,$-9
         ld hl,(TempWord5)
       push hl
       ld a,20h
       call PutSC
       pop hl
       ld a,(hl)
       inc hl
       or a
       jr nz,$-10
         pop hl
         ld (textRow),hl
         push hl
NoDelToken:
       ld hl,(TempWord5)
       call GPutS
       pop hl
       ld (textRow),hl
;DE points to string
;BC is the size
       jp GraphToLCD
EnterP:
       ld hl,(TempWord2)
       ld (TextRow),hl
       ld hl,966Fh
       call TokenTextLoop
       ld bc,(TempWord3) \ inc bc
       res 3,(iy+33)
       ret
seqToken:
CopyHex:
     ex de,hl
     ld h,b \ ld l,c
CopyHexLoop:
       call PutHexFromDE
       jr z,ExitHexLoop
       call PutHexFromDE
       jr z,ExitHexLoop-3
       inc hl
       jr CopyHexLoop
       xor a
       rld
ExitHexLoop:
       ld (progPtr),de
       ld b,h \ ld c,l
       ret
PutHexFromDE:
       inc de
       ld a,(de)
       cp 3Fh
       ret z
       cp 3Ah
       jr c,$+4
         sub 7
       rld
       ret
SetData:
        ld a,(hl)
        cp 16 \ jr z,CopyHex
        ld e,-1
        cp 6 \ jr nz,$+5
        inc e \ jr $+6
        dec hl
        ld (progPtr),hl
        ld h,b \ ld l,c
SetDataLoop:
          push hl
          push de
          call ParseNextFullArg
          pop de
          rlc e
          jr nc,$+7
            dec hl
            ld a,(hl)
            cp 11
            inc hl
          ld a,(hl)
          pop hl
          ld (hl),c \ inc hl
          jr nz,$+4
          ld (hl),b \ inc hl
          cp 2Bh \ jr z,SetDataLoop
          ld b,h
          ld c,l
          ret
VarName:
     ld e,a
     ld d,(hl)
     inc d
     call GetNextVarNum
     dec d
     ld (progPtr),hl
     ld (8479h),de
     xor a \ ld (847Bh),a
     rst 10h
     jp VarTokenStepIn
FuncToken:
        call ParseFullArg
        ld (8000h),bc
        ld bc,80h
        cp 2Bh
        call z,ParseNextFullArg
        dec bc \ inc b \ inc c
        ld (8004h),bc
        ld (8002h),bc
;        ld (8A8Ah+IprogPtr-interrupt),bc
        ret
SendToken:
        ld a,(hl)
        cp $AE
        jr nz,NotSendByte
;timer,byte
;success or fail
          call ParseNextFullArg
          push bc
          call ParseNextFullArg
          pop de
          jp SendByte
NotSendByte:
        call ParseFullArg
        push bc               ;Size of the var
          inc hl \ ld (progPtr),hl
          call GetVarName
          ex de,hl
          ld de,8478h
          ldir
          xor a
          ld (de),a
          call FindVar
          pop hl
          jr nc,PToRy-5
VarDoesNotExistYet:
          ld a,(8478h)
          and 1fh
     bcall(42FDh)       ;EnoughMem
     jp c,ErrMEM
     ex de,hl
          push hl
          bcall(4E70h)
          pop bc
          ld h,d \ ld l,e \ inc hl \ inc hl
          xor a
          call SetMem
          inc de \ inc de
          ld c,e \ ld b,d
        ret
PToRy:
     call ParseFullArg
     cp 2Bh
     ld (PBufType),bc
     ld bc,%01100001
     jr nz,GetRuleNum+3
     inc hl
     ld a,(hl)
     cp 2Ah
     jr nz,GetRuleNum
     ld b,h
     ld c,l
     sbc hl,hl
ConvRuleLoop:
       inc bc
       ld a,(bc)
       call EndOArg
       jr nz,$+25
         cp 2Bh
         jr z,$+17
         ld a,h \ and $F0
         jr nz,$+8
           add hl,hl
           add hl,hl
           add hl,hl
           add hl,hl
           jr $-9
         ld (PBufRule),hl
         ret
         add hl,hl
         add hl,hl
         add hl,hl
         add hl,hl
       cp 'U'
       jr nz,$+4
       set 3,l
       cp 'R'
       jr nz,$+4
       set 2,l
       cp 'L'
       jr nz,$+4
       set 1,l
       cp 'D'
       jr nz,$+4
       set 0,l
       jr ConvRuleLoop
GetRuleNum:
       call ParseNextFullArg
     ld a,b
     rlca \ rlca \ rlca \ rlca
     ld (PBufRule),a
     ld a,c
     rlca \ rlca \ rlca \ rlca
     ld (PBufRule+1),a
     ret
RToPr:
     ld hl,(PBufPtr)
     inc hl \ inc hl
     ld (hl),0 \ inc hl
     ld (hl),0 \ inc hl
     ret
;===============================================================
RToPTheta:
;===============================================================
;This executes one particle cycle
;===============================================================
     ld a,(hl)
     call EndOArg
     jr z,DefaultBuffer
       call ParseFullArg
g_ParticleCycle:
       ld (PBufPtr),bc
DefaultBuffer:
     ld hl,(PBufPtr)
     ld a,(PBufType)
     ld de,(PBufRule)
     or a
     jr nz,$+5
     ld de,%0001011000000000
     dec a
     jr nz,$+5
     ld de,%0001011010000000
     ld (TempWord1),de
;RuleSet=DE
     inc hl
     inc hl
     ld (TempWord4),hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     ld a,b
     or c
     ret z
     inc hl
;BC now is the number of particles
;HL now points to the particles
;(TempWord1) is the ruleset
     ld (TempWord2),bc
     add hl,bc
     add hl,bc
     dec hl
     ld (TempWord3),hl
     inc hl
     sbc hl,bc
     sbc hl,bc
;TempWord2 contians the number of particles left in the buffer
;TempWord3 points to the last particle
;TempWord4 points to the particle size bytes
ParticleDrawLoop:
     push bc
     push hl
     call EraseParticle
     push hl
     pop ix
     ld hl,(TempWord1)
     push af
     xor a
     ld (8A13h),a
     ld a,b
     or a
     jr nz,PLeft
       set 0,(iy+35)
       jr PUpDown
PLeft:
     sub 95
     jr c,PUpDown
       set 1,(iy+35)
PUpDown:
     ld a,c
     or a
     jr nz,PDown
       set 2,(iy+35)
       jr PPPp
PDown:
     sub 63
     jr c,PPPp
       set 3,(iy+35)
PPPp:
     pop bc
     ld c,0
ParticleTestLoop:
     add hl,hl
     jr nc,CheckPRight
       ld a,b
       and (ix-12)
       jr nz,CheckPRight
       ld c,8
       bit 2,(iy+35)
       jr z,$+6
       set 4,(iy+35)
CheckPRight:
     add hl,hl
     jr nc,CheckPLeft
       ld a,b
       rrca
       jr c,$+7
         and (ix)
         jr $+5
       and (ix+1)
       jr nz,CheckPLeft
       ld a,c
       or a
       jr z,$+8
         ld a,r
         bit 4,a
         jr nz,$+4
       ld c,4
       bit 1,(iy+35)
       jr z,$+6
       set 4,(iy+35)
CheckPLeft:
     add hl,hl
     jr nc,CheckPDown
       ld a,b
       rlca
       jr c,$+7
         and (ix)
         jr $+5
       and (ix-1)
       jr nz,CheckPDown
       ld a,c
       or a
       jr z,$+8
         ld a,r
         bit 4,a
         jr nz,$+4
       ld c,2
       bit 0,(iy+35)
       jr z,$+6
       set 4,(iy+35)
CheckPDown:
     add hl,hl
     jr nc,PChecked
       ld a,b
       and (ix+12)
       jr nz,PChecked
       ld a,c
       or a
       jr z,$+8
         ld a,r
         bit 4,a
         jr nz,$+4
       ld c,1
       bit 3,(iy+35)
       jr z,$+6
       set 4,(iy+35)
PChecked:
      ld a,c
      or a
      jr nz,MoveP
      ld a,h
      or l
      jp nz,ParticleTestLoop
MoveP:
      pop hl
      ld a,c
      or a
      jr z,MovedP
      ld a,b
      cpl
      and (ix)
      ld (ix),a
      bit 4,(iy+35)
      jr nz,RemoveParticle
      ld a,b
      rrc c
      jr nc,$+11
        or (ix+12)
        ld (ix+12),a
        inc (hl)
        jr MovedP
      rrc c
      jr nc,$+23
        rlca
        jr nc,$+10
          or (ix-1)
          ld (ix-1),a
          jr $+8
          or (ix)
          ld (ix),a
        inc hl
        dec (hl)
        jr MovedP+1
      rrc c
      jr nc,$+23
        rrca
        jr nc,$+10
          or (ix+1)
          ld (ix+1),a
          jr $+8
          or (ix)
          ld (ix),a
        inc hl
        inc (hl)
        jr MovedP+1
      or (ix-12)
      ld (ix-12),a
      dec (hl)
MovedP:
     inc hl
     pop bc
     cpi
     jp pe,ParticleDrawLoop
     ret
RemoveParticle:
;HL points to particle data
;TempWord2 contains the number of particles left in the buffer
;TempWord3 points to the last particle
;TempWord4 points to the particle size bytes
     res 4,(iy+35)
     ld bc,(TempWord2)
     cpi
     ex de,hl
     push af
     ld hl,(TempWord3)
     ld (TempWord2),bc
     ldd
     ldd
     ld (TempWord3),hl
     ld hl,(TempWord4)
     inc bc
     inc bc
     ld (hl),c
     inc hl
     ld (hl),b
     ex de,hl
     pop af
     pop bc
     ret po
     cpi
     jp pe,ParticleDrawLoop
     ret
;===============================================================

PBufInfoDef:
     ld hl,(PBufPtr)
PBufInfo:
     ld c,(hl) \ inc hl
     ld b,(hl) \ inc hl
     ld e,(hl) \ inc hl
     ld d,(hl) \ inc hl
     ret
NextParticle:
     sra b \ rr c \ dec bc
     ex de,hl
     sbc hl,bc \ ret z
     add hl,bc
     inc hl
     ex de,hl
     ld (TempWord1),hl
     dec hl \ ld (hl),d
     dec hl \ ld (hl),e
     ex de,hl
     add hl,hl
     add hl,de
     or 1
     ret
PartConv:
; jr $
     push bc
     call ParseNextFullArg
     push bc
     call ParseNextFullArg
     ld a,c
     pop bc \ ld b,a
     push bc
     call ParseNextFullArg
     push bc
     call ParseNextFullArg
     ld a,c
     pop bc \ ld b,a
     pop hl \ ld (TempWord3),hl
     add hl,bc \ dec h \ dec l
     ld (TempWord2),bc
;HL contains the lower-left coordinates
PartConvLoop:
     push hl
     push bc
       ld (TempWord4),hl
       ld b,h \ ld c,l
       call GetPixelLoc
       jr nc,FinishPartAdd
       and (hl) \ jr z,FinishPartAdd
       call PBufInfoDef
       call NextParticle \ jr z,PConvComplete
       ld bc,(TempWord4)
       ld (hl),c \ inc hl \ ld (hl),b
FinishPartAdd:
     pop bc \ pop hl
;TempWord2 is the size of the reqion
;TempWord3 is is the upper right coordinate
     dec h \ djnz PartConvLoop
     ld hl,(TempWord3)
     ld bc,(TempWord2) \ dec c
     add hl,bc
     jr nz,PartConvLoop-6
     pop bc \ ret
PConvComplete:
     pop bc \ pop hl \ pop bc \ ret
FillPart:
     ret
PToRX:
     ld a,(hl) \ cp $AE
     jr z,PartConv
     cp 11 \ jr z,FillPart
     call PBufInfoDef
;BC=Max number of particles
;DE=Current number of particles
;HL=particle pointer
     call NextParticle
     ld de,(TempWord1)
     push de
     push hl
;HL points to where particle data gets written
     call ParseFullArg
     push bc
     call ParseNextFullArg 
     ld a,c
     pop bc \ ld b,a
     pop hl \ pop de
AddParticle:
       ld (hl),c \ inc hl
       ld (hl),b
       call GetPixelLoc
       or (hl) \ ld (hl),a
       ld b,d \ ld c,e
       ret
FixToken:
          ld a,(hl)
          cp 93h
          jr nz,SetMode
            call ParseNextFullArg
            ld a,c
            ld (TextPauseTime),a
            ret
SetMode:
        ld bc,(8A12h)
        ld b,0
        call ParseFullArg
        ld a,c
        ld (8A12h),a
        ret
OSVarToken:
          ld a,(hl)
          inc hl
          ld (progPtr),hl
          ld hl,0
          ld (847Ah),hl
          ld (8479h),a
          rst 10h
          jr nc,$+6
            ld bc,0
            ret
          ex de,hl
          call ConvDecAtHL
          ld b,d \ ld c,e
          ret
TangentToken:
          call ParseFullArg   
          xor a \ ld b,a
          or c
          ret z
          push bc
          call ParseNextFullArg 
          ld a,c
          pop bc
          or a \ ret z
          push af
          push bc
          ld a,(hl)
          cp 2Bh
          ld bc,(BufPtr)
          call z,ParseNextFullArg
          ld (TempWord1),bc
          pop bc
          pop af
ShiftGraphBuf:
       ld b,4
        push bc
        rrca
        push af
        ld a,c
       call c,ShiftGraphDownA
       pop af
       pop bc
        push bc
        rrca
        push af
        ld a,c
       call c,ShiftGraphLeftA
       pop af
       pop bc
        push bc
        rrca
        push af
        ld a,c
       call c,ShiftGraphRightA
       pop af
       pop bc
        rrca
        ld a,c
       ret nc
ShiftGraphUpA:
     ld e,a
     ld l,a
     ld h,0
     ld d,h
     add hl,hl
     add hl,de
     add hl,hl
     add hl,hl
     push hl
     ld a,h
     inc a
     cpl
     and 3
     ld b,a
     ld a,l
     dec a
     cpl
     ld c,a
     ld de,(TempWord1)
     add hl,de
     ldir
     pop bc
ZeroMemF:
     xor a
SetMemF:
     ld (de),a
     ld h,d \ ld l,e
     inc de
     ldir
     ret
ShiftGraphRightA:
     rrca
     push af
     call c,ShiftRight1
     pop af
     rrca
     push af
     call c,ShiftRight2
     pop af
     rrca
     push af
     call c,ShiftRight4
     pop af
     rrca
     push af
     call c,ShiftRight8
     pop af
     rrca
     push af
     call c,ShiftRight16
     pop af
     rrca
     push af
     call c,ShiftRight32
     pop af
     rrca
     ret nc
ShiftRight64:
     ld hl,(TempWord1)
     ld a,l
     sub 9
     jr nc,$+3
     dec h
     ld l,a
     ld a,4
     jr ShiftRight8OrMore
ShiftRight32:
     ld hl,(TempWord1)
     ld a,l
     sub 5
     jr nc,$+3
     dec h
     ld l,a
     ld a,8
     jr ShiftRight8OrMore
ShiftRight16:
     ld hl,(TempWord1)
     dec hl \ dec hl \ dec hl
     ld a,10
ShiftRight8OrMore:
     inc h
     inc h
     inc h
     ld b,0
     ld c,a
     ld (TempWord3),bc
     sub 13
     cpl
     ld (TempWord2+1),a
     ld b,64
     ld de,(TempWord1)
     inc d \ inc d \ inc d
     dec de
SR8OMLoop:
;TempWord2==number of bytes to clear
;TempWord3==number of bytes to shift
;b=64
       push bc
       ld bc,(TempWord3)
       lddr
       ld bc,(TempWord2)
       xor a
         ld (de),a
         dec de
         dec hl
         djnz $-3
       pop bc
       djnz SR8OMLoop
     ret
ShiftRight8:
     ld hl,(TempWord1)
     ld d,64
       xor a
       ld b,12
         ld c,(hl)
         ld (hl),a
         inc hl
         ld a,c
         djnz $-4
       dec d
       jr nz,$-10
     ret
ShiftRight2:
     call ShiftRight1
ShiftRight1:
     ld hl,(TempWord1)
     ld c,64
       xor a
       ld b,12
         .dw 1ECBh
         inc hl
         djnz $-3
       dec c
       jr nz,$-9
       ret
ShiftRight4:
     ld hl,(TempWord1)
     ld c,64
       xor a
       ld b,12
         .dw 67EDh
         inc hl
         djnz $-3
       dec c
       jr nz,$-9
       ret
ShiftGraphLeftA:
     rrca
     push af
     call c,ShiftLeft1
     pop af
     rrca
     push af
     call c,ShiftLeft2
     pop af
     rrca
     push af
     call c,ShiftLeft4
     pop af
     rrca
     push af
     call c,ShiftLeft8
     pop af
     rrca
     push af
     call c,ShiftLeft16
     pop af
     rrca
     push af
     call c,ShiftLeft32
     pop af
     rrca
     ret nc
ShiftLeft64:
     ld hl,(TempWord1)
     ld a,8
     add a,l
     jr c,$+3
     inc hl
     ld l,a
     ld a,4
     jr ShiftLeft8OrMore
ShiftLeft32:
     ld hl,(TempWord1)
     inc hl \ inc hl
     inc hl \ inc hl
     ld a,8
     jr ShiftLeft8OrMore
ShiftLeft16:
     ld hl,(TempWord1)
     inc hl \ inc hl
     ld a,10
ShiftLeft8OrMore:
     ld b,0
     ld c,a
     ld (TempWord3),bc
     sub 13
     cpl
     ld (TempWord2+1),a
     ld b,64
     ld de,(TempWord1)
SL8OMLoop:
       push bc
       ld bc,(TempWord3)
       ldir
       ld bc,(TempWord2)
       xor a
         ld (de),a
         inc de
         inc hl
         djnz $-3
       pop bc
       djnz SL8OMLoop
     ret
ShiftLeft8:
     ld hl,(TempWord1)
     inc h \ inc h \ inc h
     dec hl
     ld d,64
       xor a
       ld b,12
         ld c,(hl)
         ld (hl),a
         dec hl
         ld a,c
         djnz $-4
       dec d
       jr nz,$-10
     ret
ShiftLeft2:
     call ShiftLeft1
ShiftLeft1:
     ld hl,(TempWord1)
     inc h \ inc h \ inc h
     dec hl
     ld c,64
       xor a
       ld b,12
         .dw 16CBh
         dec hl
         djnz $-3
       dec c
       jr nz,$-9
       ret
ShiftLeft4:
     ld hl,(TempWord1)
     inc h \ inc h \ inc h
     dec hl
     ld c,64
       xor a
       ld b,12
         .dw 6FEDh
         dec hl
         djnz $-3
       dec c
       jr nz,$-9
       ret
ShiftGraphDownA:
     ld e,a
     ld l,a
     ld h,0
     ld d,h
     add hl,hl
     add hl,de
     add hl,hl
     add hl,hl
     push hl
     ld a,h
     inc a
     cpl
     and 3
     ld b,a
     ld a,l
     dec a
     cpl
     ld c,a
     ld hl,(TempWord1)
     dec hl
     add hl,bc
     ld de,(TempWord1)
     inc d \ inc d \ inc d
     dec de
     lddr
     pop bc
ZeroMemE:
     xor a
SetMemE:
     ld (de),a
     ld h,d \ ld l,e
     dec de
     lddr
     ret
PiToken:
ConvHexStr:
          ex de,hl
          ld hl,0
ConvHexStrLoop:
            call IsHexTok
            jr c,EndOfPi
            add hl,hl
            add hl,hl
            add hl,hl
            add hl,hl
            or l
            ld l,a
            jr ConvHexStrLoop
EndOfPi:
          dec de
          ld (progPtr),de
          ld b,h \ ld c,l
          ex de,hl
          ret

nCrToken:
          push bc
          call ParseFullArg   
          pop hl
          ld d,b \ ld e,c
;===============================================================
nCrAlgorithm:
;===============================================================
;Inputs:
;     hl is "n"
;     de is "r"
;Outputs:
;     interrupts off
;     a is 0
;     bc is the result
;     de is "n"
;     hl is the result
;     a' is not changed
;     bc' is "r"+1
;     de' is an intermediate calculation
;     hl' is "r" or the compliment, whichever is smaller
;===============================================================
     or a                     ;reset carry flag
     sbc hl,de
     ret c                    ;r should not be bigger than n
     di
     sbc hl,de \ add hl,de
     jr nc,$+3
       ex de,hl              ;hl is R

     push de
     ld bc,1                 ;A
     exx
     pop de                  ;N
     ld bc,1                 ;C
     ld h,b \ ld l,c         ;D
nCrLoop:
     push de
     push hl
     call DE_Times_BC
     push hl \ exx \ pop de
     push hl
     call DE_Div_BC
     pop de
     push hl \ ex de,hl \ exx \ pop hl
     ld b,h \ ld c,l
     pop de \ add hl,de
     pop de \ inc de
     exx
     inc bc
     or a \ sbc hl,bc \ add hl,bc
     exx
     jr nc,nCrLoop
     ld b,h \ ld c,l
     ret
ForToken:
          push bc
          ld a,(hl)
          inc hl
          call VarPointer
          jr c,$+16
            ld hl,ForBackUp
            push hl
            ld (hl),1
            inc l
            ld (hl),0
            call ParseFullArg
            jr StartForLoop-4
          ld (progPtr),de
          push hl
          call ParseNextFullArg   
          pop hl
          push  hl
          ld (hl),c \ inc hl
          ld (hl),b
          call ParseNextFullArg 
          ld e,c
          ld d,b
          pop hl
          pop bc
StartForLoop:
          push de              ;UpperBound
          push hl              ;varPointer
          ld hl,(progPtr)
          push hl
          call ParserNext
          pop hl
          ld (TempWord2),hl
          ld (TempWord1),bc
          pop hl                ;points to var data
          pop de                ;upper bound
          ld c,(hl)
          inc hl
          ld b,(hl)
          inc bc
          ld (hl),b
          dec hl
          ld (hl),c
          ex de,hl
          or a
          sbc hl,bc
          add hl,bc
          ld bc,(TempWord1)
          ret c
          push hl
          ld hl,(TempWord2)
          ld (progPtr),hl
          pop hl
          ex de,hl
          jr StartForLoop
FullToken:
          ld a,(hl)
          ld c,1
          call EndOArg
          call nz,ParseFullArg
SetSpeed:
          in a,(20h)
          ld b,a
          bit 1,c
          jr z,$+6
            cpl
            and 1
            ld c,a
          
          in a,(2)
          rlca
          and c
          out (20h),a
          ld c,b
          ld b,0
          ret
ClrDrawToken:
        ld a,(hl)
        call EndOArg
        jr z,g_ClrDraw
        call ParseFullArg
        ld h,b \ ld l,c
        ld d,b \ ld e,c
        jp ZeroMem-3
g_ClrDraw:
          ld de,0
          ld (textRow),de
          push bc
          ld hl,(BufPtr)
          pop de
          ld bc,768
ZeroMem:
          ld a,b \ or c \ ld a,0
          push de
          call nz,SetMem
          pop bc
          ret
ClrHomeToken:
g_ClrHome:
          ld hl,0
          ld (844Bh),hl
          push bc
          ld bc,128
          ld hl,8508h \ ld a,20h
          call SetMem
          pop bc
          ret
minToken:
maxToken:
          push af
          call ParseFullArg   
          push bc          
          call ParseNextFullArg 
          pop hl
          pop af
g_max:
          or a
          sbc hl,bc
          add hl,bc
          bit 0,a
          jr nz,$+3
            ccf
          ret c
          ld b,h
          ld c,l
          ret
factorialToken:
          ld a,(hl)
          call IsConditional \ jr z,$+9
          ld de,0 \ push de
          jp factorialStepIn
          set 2,(iy+33)
          ret
FillToken:
          call ParseFullArg
          ld hl,(BufPtr)
          ld a,c
          ld bc,300h
          ld e,-1
FillBufOR:
          or a \ jr nz,FillBufInv
              ld a,e \ or (hl) \ ld (hl),a
              cpi
              jp pe,$-5     ;save a byte:    ret po
              ret           ;                jr $-4       ;makes over 5300 cycles slower
FillBufInv:
          dec a \ jr nz,Checker1
            ld a,e \ xor (hl) \ ld (hl),a
            cpi
            jp pe,$-5
            ret
Checker1:
          dec a \ jr nz,Checker2
            ld a,$AA
            ld c,64
            ld b,12 \ ld (hl),a \ inc hl
            djnz $-2
            cpl \ dec c
            jr nz,$-8
            ret
Checker2:
          dec a \ jr nz,LoadBytePatternOR
          ld a,55h \ jr Checker1+5
LoadBytePatternOR:
          cp 22 \ jr nc,NotArg
          push af \ push bc \ push hl
          call ParseNextFullArg
          ld d,b \ ld e,c \ pop hl \ pop bc \ pop af 
NotArg:
          dec a \ jr z,FillBufOR+3
LoadBytePatternXOR:
          dec a \ jr z,FillBufInv+3
LoadBytePatternAND:
          dec a \ jr nz,LoadBytePatternErase
FillBufAND:
            ld a,e \ and (hl) \ ld (hl),a
            cpi
            jp pe,FillBufAND
            ret
LoadBytePatternErase:
          dec a \ jr nz,BufCopy
FillBufErase:
            ld a,e \ cpl \ and (hl) \ ld (hl),a
            cpi
            jp pe,FillBufErase
            ret
BufCopy:
          dec a \ jr nz,BufOR
            ldir \ ret
BufOR:
          dec a \ jr nz,BufAND
            ld a,(de) \ inc de
            or (hl) \ ld (hl),a
            cpi \ jp pe,BufOR+3
            ret
BufAND:
          dec a \ jr nz,BufXOR
            ld a,(de) \ inc de
            and (hl) \ ld (hl),a
            cpi \ jp pe,BufAND+3
            ret
BufXOR:
          dec a \ jr nz,BufErase
            ld a,(de) \ inc de
            xor (hl) \ ld (hl),a
            cpi \ jp pe,BufXOR+3
            ret
BufErase:
          dec a \ jr nz,BufSwap
            ld a,(de) \ inc de
            cpl \ and (hl) \ ld (hl),a
            cpi \ jp pe,BufErase+3
            ret
BufSwap:
          dec a \ jr nz,CopyDown
            ld a,(de)
            push af \ ld a,(hl) \ ld (de),a
            pop af \ ld (hl),a
            inc de
            cpi \ jp pe,BufSwap+3
            ret
CopyDown:
;If Copy Down
            cp 5 \ jr nc,CopyDownOR
            add hl,bc \ dec hl
            push hl
            ld h,d \ ld l,e
            add hl,hl \ add hl,de
            add hl,hl \ add hl,hl
            pop de \ push de \ push hl \ ex de,hl
            sbc hl,de \ ex de,hl
            ld h,b \ ld l,c \ pop bc \ sbc hl,bc
            ld b,h \ ld c,l
            pop hl
CopyDownOR:
          dec a \ jr nz,CopyDownAND
            ld a,(de)
            or (hl)
            ld (hl),a
            dec de \ cpd
            jp pe,$-6
            ret
CopyDownAND:
          dec a \ jr nz,CopyDownXOR
            ld a,(de)
            and (hl)
            ld (hl),a
            dec de \ cpd
            jp pe,$-6
            ret
CopyDownXOR:
          dec a \ jr nz,CopyDownErase
            ld a,(de)
            xor (hl)
            ld (hl),a
            dec de \ cpd
            jp pe,$-6
            ret
CopyDownErase:
          dec a \ jr nz,CopyUp
            ld a,(de)
            cpl
            and (hl)
            ld (hl),a
            dec de \ cpd
            jp pe,$-7
            ret
CopyUp:
;If Copy Up
            cp 5 \ jr nc,CopyUpOr
;de is number of pixels down to copy to
;bc is 768
;hl points to the buffer
            push hl
            ld h,d \ ld l,e
            add hl,de \ add hl,de
            add hl,hl \ add hl,hl
            ld b,h \ ld c,l
            pop de \ add hl,de
;DE points to main buffer
;HL points to offset
            push hl
            ld hl,768 \ sbc hl,bc
            ld b,h \ ld c,l
            pop hl
            ex de,hl
CopyUpOR:
          dec a \ jr nz,CopyUpAND
            ld a,(de)
            or (hl)
            ld (hl),a
            inc de \ cpi
            jp pe,$-6
            ret
CopyUpAND:
          dec a \ jr nz,CopyUpXOR
            ld a,(de)
            and (hl)
            ld (hl),a
            inc de \ cpi
            jp pe,$-6
            ret
CopyUpXOR:
          dec a \ jr nz,CopyUpErase
            ld a,(de)
            xor (hl)
            ld (hl),a
            inc de \ cpi
            jp pe,$-6
            ret
CopyUpErase:
          dec a \ jr nz,FireCycle
            ld a,(de)
            cpl
            and (hl)
            ld (hl),a
            inc de \ cpi
            jp pe,$-7
            ret
FireCycle:
    dec a \ jr nz,FireCycle2
    ld a,e
    ld de,12
    ex de,hl
    add hl,de
    ld bc,2F4h
    or a
    jr z,BlackFireLoop    
FireLoop:
    call Random
    cpl
    and (hl)            ;change to AND for t'other method
    ld (de),a
    inc de
    cpi
    jp pe,FireLoop
    ret
BlackFireLoop:
    call Random
    or (hl)            ;change to AND for t'other method
    ld (de),a
    inc de
    cpi
    jp pe,BlackFireLoop
    ret

FireCycle2:
    dec a \ jr nz,CA2D
    push de
    push hl
    call ParseNextFullArg
;Y,X
    ld h,b
    ld l,c
    add hl,hl
    add hl,bc
    add hl,hl
    add hl,hl
    pop bc
    add hl,bc
    push hl
    call ParseNextFullArg
    pop hl
    add hl,bc
    push hl
;HL is now the start location
;Width,Height:
    call ParseNextFullArg
    ld a,c
    push af
    call ParseNextFullArg
    pop af
    ld b,a
    pop hl
    pop de
;b is width
;c is height
;e is the particle type
    ld d,c
    ld a,12
    sub b
    ld c,a
    ld a,e \ or a
    ld a,d
    ld de,12
    ex de,hl
    add hl,de
;a=height
;b is width
;c=12-b
    jr z,BlackFireLoop2
FireLoop2:
    push af
    push bc
    call Random
    cpl
    and (hl)
    ld (de),a
    inc de
    inc hl
    djnz FireLoop2+2
    add hl,bc
    ex de,hl
    add hl,bc
    ex de,hl
    pop bc
    pop af
    dec a
    jr nz,FireLoop2
    ret
BlackFireLoop2:
    push af
    push bc
    call Random
    or (hl)
    ld (de),a
    inc de
    inc hl
    djnz BlackFireLoop2+2
    add hl,bc
    ex de,hl
    add hl,bc
    ex de,hl
    pop bc
    pop af
    dec a
    jr nz,BlackFireLoop2
    ret
CA2D:
   dec a \ ret nz
 jr $ ;
   push de
   call ParseNextFullArg
   pop de
   di
   exx
;D'E' is the death rule
;B'C' is the birth rule
;62 high
   ld hl,(BufPtr)
   ld de,86ECh
   push de
   ld bc,768
   ldir
   pop ix
   ld iy,(BufPtr)
   ld bc,12
   add iy,bc
   ld b,62
CA2DOverLoop:
   push bc
   ld bc,94*256
   ld d,c
   ld e,c
   ld h,80h
CA2DLoop:
   ld l,0
   bit 0,e
   jr z,$+3
   inc l
   bit 2,e
   jr z,$+3
   inc l
   bit 0,c
   jr z,$+3
   inc l
   bit 1,c
   jr z,$+3
   inc l
   bit 2,c
   jr z,$+3
   inc l
   bit 0,d
   jr z,$+3
   inc l
   bit 1,d
   jr z,$+3
   inc l
   bit 2,d
   jr z,$+3
   inc l

   sla c
   sla e
   sla d
   ld a,(ix)
   and h
   jr z,$+3
   inc c
   ld a,(ix+12)
   and h
   jr z,$+3
   inc e
   ld a,(ix+24)
   and h
   jr z,$+3
   inc d

   ld a,h
   rlca
   ex af,af'
   rrc h
   jr nc,$+6
   inc iy \ inc ix
   ld a,l
   exx
   ld hl,1
   inc a
   dec a
   jr z,$+6
   add hl,hl
   jp $-4

;D'E' is the death rule
;B'C' is the birth rule
   ld a,l
   and e
   jr nz,Death
   ld a,h
   and d
   jr nz,Death
   ld a,l
   and c
   jr nz,Birth
   ld a,h
   and b
   jr z,Survive
Birth:
   ex af,af'
   jr c,BackBirth
   or (iy)
   jp Survive-3
BackBirth:
   or (iy-1)
   jp Death-6
BackDeath:
   and (iy-1)
   ld (iy-1),a
   jp Survive
Death:
   ex af,af'
   cpl
   jr c,BackDeath
   and (iy)
   ld (iy),a
Survive:
   exx
   dec b
   jp nz,CA2DLoop
   pop bc
   inc iy
   inc ix
   dec b
   jp nz,CA2DOverLoop
   ld iy,89F0h
   ret

FirePattern:
 .db 1,2,4,8,16,32,64,128
Random:         ;feel free to give me a smaller rand routine that is pretty random x.x
    push hl
    push de
    ld hl,(randseed)
    ld a,r
    ld h,a
    add a,(hl)
    inc hl
    rrca
    add a,(hl)
    inc hl
    rrca
    xor (hl)
    inc hl
    rrca
    rrca
    ld l,a
    ld (randseed),hl
    and 7
    ld de,FirePattern
    add a,e
    ld e,a
    jr nc,$+3
    inc d
    ld a,(de)
    pop de
    pop hl
    ret
HorizontalToken:
         call ParseFullArg   
         ld a,b \ or a \ ret nz
         ld a,c
         sub 64
         ret nc
         push bc
         ld c,1
         ld a,(hl)
         cp 2Bh
         call z,ParseNextFullArg
         ld d,c
         cp 2Bh
         push de
         ld bc,(BufPtr)
         call z,ParseNextFullArg
         pop de
NoMethodArgA6:
          pop hl
          push bc
          ld b,h
          ld c,l
          add hl,hl \ add hl,bc
          add hl,hl \ add hl,hl
          ld a,h \ sub 3
          ret nc
          ld a,d
          pop bc
          add hl,bc
          ld b,12
          or a \ jr z,SetSmallMem
          dec a
          jr nz,InvertMem
            dec a
SetSmallMem:
            ld (hl),a \ inc hl
            djnz $-2
            ret
InvertMem:
            ld a,(hl) \ cpl
            ld (hl),a \ inc hl
            djnz $-4
            ret
VerticalToken:
          call ParseFullArg   
          ld a,b \ or a \ ret nz
          ld a,c \ sub 96 \ ret nc
          ld a,c \ and 7
          ld b,a \ inc b
          ld a,1
            rrca
            djnz $-1
          srl c \ srl c \ srl c
          ld b,0
;          ld hl,(BufPtr) \ add hl,bc
          push af
;          push hl
          push bc
          ld a,(hl)\ cp 2Bh
          ld c,1
          call z,ParseNextFullArg
          ld b,c
          push bc
          ld bc,(BufPtr)
          cp 2Bh
          call z,ParseNextFullArg
          pop af
          pop hl
          add hl,bc
          pop bc
          ld c,b
;=======================================
;     C is the mask
;     A is the method:
;        0=Off
;        1=On
;        2=Invert
;     HL is where to start
;=======================================
          ld b,64
          ld de,12
DrawVertOn:
          dec a \ jr nz,DrawVertInv
            ld a,c
            or (hl)
            ld (hl),a
            add hl,de
            djnz $-4
            ret
DrawVertInv:
          dec a \ jr nz,DrawVertOff
            ld a,c
            xor (hl)
            ld (hl),a
            add hl,de
            djnz $-4
            ret
DrawVertOff:
            ld a,c
            cpl \ ld c,a            
            ld a,c
            and (hl)
            ld (hl),a
            add hl,de
            djnz $-4
            ret
ShadeToken:
          call ParseFullArg   
          ld a,c
          add a,$D9
          jr nc,$+3
            xor a
          dec a
          out (16),a
          ret
StorePicToken:
       call ParseFullArg
       ld b,c
       ld c,60h
       push bc
       cp 2Bh
       ld bc,(BufPtr)
       call z,ParseNextFullArg
       pop hl
       push bc
       ld (8479h),hl
       xor a
       ld (847Bh),a
       call FindSym
       jr c,$+5
       bcall(4FC6h)
       ld hl,768
       ld a,7
       push hl
       bcall(4E70h)
       inc de
       inc de
       pop bc
       pop hl
       ldir
       ret
RecallPicToken:
       call ParseFullArg
       push bc
       cp 2Bh
       ld c,0
       call z,ParseNextFullArg
       ld b,c
       push bc
       ld bc,(BufPtr)
       cp 2Bh
       call z,ParseNextFullArg
       pop af
       ex af,af'
       ld d,b
       ld e,c
       pop bc
       push de
;de buffer to store to
;bc is pic num
;A' is the method to copy with
       ld b,c
       ld c,60h
       call SearchVarBC
       pop hl
       ret c
       push hl
       ld a,b
       ld b,0
       push af
       call GetVarInfoVarFound
       dec bc
       ld a,b
       inc bc
       sub 3
       jr c,$+5
         ld bc,768
       pop af
       ld de,86ECh
       push bc
       push de
       call ReadArc
       pop hl
       pop bc
       pop de
       ex af,af'
       or a
       jp z,BufCopy+3
       ex de,hl
       dec a
       jp z,BufAND+3
       dec a
       jp z,BufXOR+3
       dec a
       jp z,BufOR+3
       dec a
       ret z
       dec a
       jp z,BufErase+3
       ret
RandToken:
g_Rand:
          ld hl,(randSeed)
          ld b,h \ ld c,l
          add hl,hl
          ld hl,(randSeed)
          ld a,r \ ld d,a
          ld a,r \ ld e,a
          add hl,de
          ld a,r \ ld d,a
          ld a,r \ ld e,a
          add hl,de
          ld (randSeed),hl
          ret
BBTokens:
        ld a,(hl)           ;7E
        inc hl              ;23
        ld (progPtr),hl     ;227298
     cp $B0
     jr c,length
     cp $CB
     jr nc,length
     cp $BB
     jr c,$+3
     dec a
     sub $AC
     add a,a
     inc a
     ex de,hl
     ld l,a
     ld h,91h
     ld c,(hl)
     inc l
     ld b,(hl)
     ex de,hl
     ld a,(hl)
     inc hl
     call VarPointer
     ret nc
     ld (progPtr),de
     ld d,b
     ld e,c
     ld c,(hl)
     inc hl
     ld b,(hl)
     set 5,(iy+33)
     ret
length:
     cp 2Bh \ jr nz,inString
       ld a,(hl)
       cp $AE
       jr nz,FindVarInfo
         call ParseNextFullArg
         push bc
         call ParseNextFullArg
         push bc
         call ParseNextFullArg
         push bc
         ld bc,3Fh
         cp 2Bh \ call z,ParseNextFullArg
         ld a,c
         pop de
         pop bc
         pop hl
         call SearchLine
         ld (ThetaPrimeVar),hl
         ld b,d \ ld c,e
         ret
;HL is start address
;BC is the line number
;E is the NewLine byte
FindvarInfo:
       call GetVarInfo2
       ld (ThetaPrimeVar),hl
       ret nc
       ld bc,-1
       ret
inString:
     cp 15 \ jr nz,conj
       call ParseNextFullArg
       push bc
       call ParseNextFullArg
       cp 2Bh
       ld h,b \ ld l,c
       push hl \ push af
       call nz,GetGrammerStr
       pop af
       call z,ParseNextFullArg
       ld (ThetaPrimeVar),bc
       pop de
       pop hl
       push bc
       call SearchString
       pop bc
       jr c,$+4
         ld h,b \ ld l,c
       or a \ sbc hl,bc
       ld b,h \ ld c,l
       ret
conj:
;n = f(x) = 440*(12th root (2^(x-48))
;A=1, B=3, C=4, D=6, E=8, F=9, and G=11
;Sharp is add 1
;flat is minus 1
        cp 37 \ jr nz,subToken
          ei
          ld a,(hl)
          cp $AE
          jr nz,GrammerSound
            call ParseNextFullArg
            push bc
            inc hl \ ld a,(hl)
            cp $AE \ push af
            call ParseNextFullArg
            pop af
            jr nz,SoundData
              ld h,b \ ld l,c \ pop bc
p_FreqOut:
	xor	a
__FreqOutLoop1:
	push	bc
        xor     %00000011
	ld	e,a
__FreqOutLoop2:
	ld	a,h
	or	l
	jr	z,__FreqOutDone
	cpd
	jp	pe,__FreqOutLoop2
	ld	a,e
        scf
__FreqOutDone:
	pop	bc
	out	($00),a
	ret	nc
	jr	__FreqOutLoop1
__FreqOutEnd:
SoundData:
          push bc
          call ParseNextFullArg
          pop hl \ pop de
          ld a,b \ or c \ ret z
;HL points to the data:
;DE is the time
;BC is the number of elements
SoundLoop:
            push de \ push bc
            ld c,(hl) \ inc hl
            ld b,(hl) \ push hl
            ex de,hl
            call p_FreqOut
            pop hl \ pop bc \ pop de
            cpi
            jp pe,SoundLoop
            ret
GrammerSound:
 call ParseFullArg
 push bc
 call ParseNextFullArg
 ld h,b
 ld l,c
 add hl,hl
 add hl,bc
 add hl,hl
 add hl,hl
 add hl,hl
 pop bc
 add hl,bc
 add hl,bc
 ld bc,FrequencyLUT
 add hl,bc
 ld c,(hl)
 inc hl
 ld b,(hl)
 push bc
 call ParseNextFullArg
 ld d,b
 ld e,c
 pop bc
NoteLoop:
 ld a,d
 or e
 ret z
 push de
 ld hl,4096
 call p_FreqOut
 pop de
 dec de
 jp NoteLoop
subToken:
        cp 12 \ jr nz,ANOVAsubset
          call ParseFullArg
          push bc
          call ParseNextFullArg
          push bc
          ld hl,(progPtr)
          inc hl
          ld (progPtr),hl
          call GetVarInfo
          jp c,Pop2Exit
          or a \ jp nz,Pop2Exit
          ld hl,(progPtr)
          ld (965Dh),hl
          ex de,hl
          ld c,(hl) \ inc hl
          ld b,(hl) \ inc hl
          ld (TempWord1),hl
          ld h,b \ ld l,c
          pop bc
          sbc hl,bc
          pop de
          ret c
          sbc hl,de
          jr nc,DelGoodSize
            ex de,hl
            add hl,de
            ld h,a \ cp l \ ret z
            ex de,hl
            ld hl,0
DelGoodSize:
          add hl,bc
          push de
          ld de,(TempWord1)
          ex de,hl
          dec hl \ ld (hl),d
          dec hl \ ld (hl),e
          inc hl \ inc hl
          add hl,bc
          pop de
          push hl
          ld a,d \ or e
          jr z,$+5
          bcall(4357h)
          ld hl,(965Dh)
          ld (progPtr),hl
          pop bc
          ret
ANOVAsubset:
     cp 59h \ jp nz,DelvarToken
     call ParseFullArg
     ld a,c \ inc a
     push af
     call ParseNextFullArg      ;location of buffer
     ld h,b \ ld l,c
     pop bc
     djnz NegativeXVelo
GravityUpdate:
; jr $
     ld c,(hl) \ inc hl
     ld b,(hl) \ inc hl
     ld e,(hl) \ inc hl
     ld d,(hl) \ inc hl
     ld (TempWord1),de
;BC is the number of items
;(TempWord1)=(X,Y) accel
;HL points to the data
GravityUpdateLoop:
     push bc
     ld e,(hl) \ inc hl
     ld d,(hl)
     ld a,(TempWord1)
     add a,e \ ld e,a
     jr nc,$+3
     inc d
     ld (hl),d \ dec hl
     ld (hl),e \ inc hl
     inc hl

     ld c,(hl) \ inc hl
     ld b,(hl)
     ex de,hl
     add hl,bc
     ex de,hl
     ld (hl),d \ dec hl
     ld (hl),e \ inc hl
     inc hl


     ld e,(hl) \ inc hl
     ld d,(hl)
     ld a,(TempWord1+1)
     add a,e \ ld e,a
     jr nc,$+3
     inc d
     ld (hl),d \ dec hl
     ld (hl),e \ inc hl
     inc hl

     ld c,(hl) \ inc hl
     ld b,(hl)
     ex de,hl
     add hl,bc
     ex de,hl
     ld (hl),d \ dec hl
     ld (hl),e \ inc hl
     pop bc
     cpi
     jp pe,GravityUpdateLoop
     ret
NegativeXVelo:
     djnz NegativeYVelo
       push hl
       call ParseNextFullArg
       ld h,b \ ld l,c
       add hl,hl
       add hl,hl
       add hl,hl
       inc hl \ inc hl
       inc hl \ inc hl
       pop bc
       add hl,bc
       ld c,(hl) \ inc hl
       ld b,(hl)
       xor a
       sub c \ ld c,a
       sbc a,a
       sub b \ ld b,a
       ld (hl),b \ dec hl
       ld (hl),c
       ret
NegativeYVelo:
     djnz GetCoords
       inc hl \ inc hl
       inc hl \ inc hl
       jr NegativeXVelo+2
GetCoords:
     djnz SetVelocity
       inc hl \ inc hl
       inc hl \ inc hl
       inc hl \ inc hl
       push hl
       call ParseNextFullArg
       ld h,b \ ld l,c
       add hl,hl
       add hl,hl
       add hl,hl
       pop bc
       add hl,bc
       ld a,(hl) \ inc hl
       ld c,(hl) \ inc hl
       ld b,0
       rlca
       jr nc,$+3
       inc bc
       inc hl \ inc hl
       ld a,(hl) \ inc hl
       ld e,(hl) \ inc hl
       ld d,0
       rlca
       jr nc,$+3
       inc de
       ld (ThetaPrimevar),de
       ret
SetVelocity:
     djnz SetAccel
       inc hl \ inc hl
       inc hl \ inc hl
       push hl
       call ParseNextFullArg
       ld h,b \ ld l,c
       add hl,hl \ add hl,hl \ add hl,hl
       pop bc \ add hl,bc \ push hl
       call ParseNextFullArg
       pop hl
       ld (hl),c \ inc hl
       ld (hl),b \ inc hl
       inc hl \ inc hl
       push hl
       call ParseNextFullArg
       pop hl
       ld (hl),c \ inc hl
       ld (hl),b
       ret
SetAccel:
     djnz SetPos
       inc hl \ inc hl
       push hl
       call ParseNextFullArg
       push bc
       call ParseNextFullArg
       pop de \ pop hl
       ld (hl),c \ inc hl
       ld (hl),e
       ret
SetPos:
     djnz DelvarToken-1
     inc hl \ inc hl
     jr SetVelocity+2
     ret
DelvarToken:
        cp 54h \ jr nz,UnArchiveToken
          call GetVarInfo \ ret c
          bcall(4FC6h)
          ret
UnArchiveToken:
        cp 69h \ jr nz,ArchiveToken
          call GetVarInfo \ ret c
          or a \ ret z
          bcall(4FD8h)
          call FindVar
          ex de,hl
          ld e,(hl) \ inc hl
          ld d,(hl) \ inc hl
          ex de,hl \ ld c,e \ ld b,d
          ld (ThetaPrimeVar),hl
          ret
ArchiveToken:
        cp 68h \ jr nz,AsmToken
          call GetVarInfo \ ret c
          or a \ ret nz
          bcall(4FD8h)
          ret
AsmToken:
        cp 6Ah \ jr nz,expr
; jr $
          push bc
          call GetVarName
          ex de,hl
          ld de,8478h
          ldir
          xor a
          ld (de),a
          ld hl,9D95h
          ld (TempWord1),hl
          pop hl \ ld (TempWord2),hl
          call FindVar
          ld a,b
          ld (TempWord3),a
          ex de,hl
          ld c,(hl) \ inc hl
          ld b,(hl) \ inc hl
          ld a,(hl) \ inc hl \ cp $BB
          ret nz
NotASMHeader:
          ld a,(hl) \ inc hl \ cp $6D
          jr nz,CheckUnsquishedHex
StartASMProg:
            dec bc \ dec bc
;BC is size of the data
;HL points to the bytes to copy
;(TempWord3) is the flash 
            push hl \ push bc
            ld h,b \ ld l,c
            bcall(42FDh)              ;EnoughMem
            jp c,ErrMEM
            ex de,hl
;HL # bytes
;DE addr
            ld de,9D95h
            push de
            bcall(42F7h)
            pop de \ pop bc \ pop hl
            ld a,(TempWord3) \ or a
            jr nz,$+3
            add hl,bc
            push bc
            call ReadArc
            pop de
            jr CallProg-7
CheckUnsquishedHex:
          cp 6Ch \ jr nz,NotASMHeader
 jr NotASMHeader
;===============================================================
;If unsquished, do this
;DE=Size
;(progPtr) adjusted
;===============================================================
;          ld de,9D95h \ push de
;          bcall(4E79h)
;          pop hl \ or a \ ex de,hl \ sbc hl,de
;          ex de,hl
          ld hl,(progPtr)
          add hl,de
          ld (progPtr),hl
;===============================================================
CallProg:
          ld bc,(TempWord2)
          push de
          ld de,AfterRet \ push de
          ld de,(TempWord1) \ push de
;          add hl,de
          ret
;          call 9D95h
AfterRET:
          ld hl,(progPtr)
          pop de
          or a
          sbc hl,de
          ld (progPtr),hl
          ld hl,9D95h
;Delmem: HL address
;        DE # of bytes
          bcall(4357h)
          ret
expr:
        cp 2Ah \ jr nz,AsmPrgm
          call ParseFullArg
g_expr:
          ld hl,(progPtr) \ push hl
          ld (progPtr),bc
          call ParseCondition
          pop hl
          ld (progPtr),hl
          ret
AsmPrgm:
        cp 6Ch \ jr nz,OMNom
          push bc
          ld b,h \ ld c,l
          call ConvHexTo86ECh
          ex de,hl
          ld (progPtr),hl
          pop bc
          jp 86ECh
OMNom:
;        cp 5 \ jr nz,BBrandInt
;          dec hl \ dec hl \ dec hl
;          ld a,(hl) \ cp 4Dh \ ret nz
;          dec hl
;          ld a,(hl) \ cp 4Fh \ ret nz
;          call ParseFullArg
;          ld a,c \ and 3
;          add a,12
;          out (16),a
;          ret
BBrandInt:
        cp 10 \ jr nz,BBLCM
          call ParseFullArg
          push bc
          push bc
          call ParseNextFullArg
          ld h,b \ ld l,c
          pop bc
          or a \ sbc hl,bc \ ld b,h \ ld c,l
          ld hl,(randSeed)
          ld a,r \ ld d,a
          ld a,r \ ld e,a
          add hl,de
          ld (randSeed),hl
          call HL_Div_BC
          pop hl \ add hl,de
          ld b,h \ ld c,l
          ret
BBLCM:
        cp 8 \ jr nz,BBGCD
          call ParseFullArg   
          push bc          
          call ParseNextFullArg 
          pop de
LCM_BC_DE:
          push de
          call DE_Times_BC
          pop de
          push hl
          ex de,hl
          call GCDHL_BC
          pop hl
          call HL_Div_BC
          ld b,h \ ld c,l
          ret          
BBGCD:
        cp 9
        ret nz
          call ParseFullArg   
          push bc          
          call ParseNextFullArg 
          pop hl
;===============================================================
GCDHL_BC:
;===============================================================
;Inputs:
;     hl,bc
;Outputs:
;     a is 0
;     bc is the Greatest Common Divisor
;     de is 0
;Destroys:
;     hl
;===============================================================
          or a \ sbc hl,bc
          ret z
          add hl,bc
          jr nc,$+8
            ld a,h
            ld h,b
            ld b,a
            ld a,l
            ld l,c
            ld c,a
          call HL_Div_BC
          or d \ or e \ ret z
          ld h,b \ ld l,c
          ld b,d \ ld c,e
          jr $-10
CircleToken:
          call ParseFullArg   
          push bc
          call ParseNextFullArg 
          pop de
          ld d,c
          push de
          call ParseNextFullArg 
          push bc
          cp 2Bh
          ld c,1
          call z,ParseNextFullArg 
          push bc
          cp 2Bh
          call z,ParseNextFullArg
          ld a,c
          pop bc
          ld b,a
          ld (TempWord1),bc
          ld a,(hl)
          cp 2Bh
          jr z,CircToBuf
          pop bc
          pop de
          jp Circle
CircToBuf:
     di
     ld hl,(BufPtr)
     push hl
     call ParseNextFullArg
     ld (BufPtr),bc
     pop hl
     pop bc
     pop de
     push hl
     call Circle
     pop hl
     ld (BufPtr),hl
     ret
PauseToken:
          ld a,(hl)
          call EndOArg
          push bc
          jr nz,NotBASICPause
            ld h,9

            ld bc,1
            call g_Pause
            ld a,h
            call CheckKey
            jr z,$-10

            ld bc,1
            call g_Pause
            ld a,h
            call CheckKey
            jr nz,$-10

            pop bc
            ret
NotBASICPause:
          ld a,(hl) \ cp $CE \ jr nz,Pause
          bit 2,(iy+33)
          res 2,(iy+33)
          inc hl
          jr z,Pauseif
          jr PauseNotIf
Pause:
          call ParseFullArg
          pop de
g_Pause:
          push de
          call CheckStatus
          push af
          res 2,(iy+33)
PauseMainLoop:
          ld de,411
PauseSubLoop:
            bit 2,(iy+34)
            call z,CheckStatus
            call z,ONErr
            dec de \ ld a,d \ or e \ jr nz,PauseSubLoop
          dec bc \ ld a,b \ or c \ jr nz,PauseMainLoop
          pop af \ ld a,b
          adc a,a
          out (20),a
          pop bc \ ret
PauseIf:
        call PauseIfLoop
        jr nz,PauseIf
        pop bc \ ret
PauseNotIf:
        call PauseIfLoop
        jr z,PauseNotIf
        pop bc \ ret
PauseIfLoop:
        ld (progPtr),hl \ push hl
        call ParseCondition
        or a \ sbc hl,hl \ sbc hl,bc
        pop hl
        ret
PxlTokens:
          sub $A0
PxlTestToken:
          push af
          ld a,(hl)
          cp $AE
          jr z,PxlTestBox
          call ParseFullArg   
          push bc
          call ParseNextFullArg 
          cp 2Bh
          ld a,c
          pop bc
          ld b,a
          pop de
          jr nz,PlotPixel
            ld hl,(BufPtr)
            push hl
            push de
            push bc
            call ParseNextFullArg
            ld (BufPtr),bc
            pop bc
            pop de
            call PlotPixel
            pop hl
            ld (BufPtr),hl
            ret
PlotPixel:
          call GetPixelLoc
          bit 4,(iy+34)
          ld bc,0
          jr c,$+6
          jr z,$+3
          inc c
          ret
          ld e,a
          and (hl)
          jr z,$+4
          ld c,1
          ld a,e
          dec d
          jr nz,$+5
            or (hl) \ ld (hl),a
            ret
          dec d
          jr nz,$+6
            cpl \ and (hl) \ ld (hl),a
            ret
          dec d
          ret nz
           xor (hl) \ ld (hl),a \ ret
PxlTestBox:
prgmToken:
          ld (TempWord1),bc
          ld a,(hl) \ inc hl
          call VarPointer
          push hl \ push af
          call ParseFullArg  
g_Call:
          ld de,(965Bh)
          ld hl,(progPtr)     ;2A7298
          or a \ sbc hl,de
          push hl             ;E5
          ex de,hl \ sbc hl,bc
          push hl
          ld (progPtr),bc     ;ED437298
          ld bc,(TempWord1)
          call ParserNext    
          pop hl
          pop de              ;D1
          push hl
          ld hl,(965Bh)
          add hl,de
          ld (progPtr),hl     ;227298
          pop de
          ld hl,(965Bh)
          sbc hl,de
          ex de,hl
          pop af \ pop hl
          ret nc
            ld (hl),e \ inc hl
            ld (hl),d
          ret                 ;C9
DispToken:
          ld a,(hl)
          cp 11
          jr z,GrayBufOnly
          cp $AE
          jr z,BlackBufOnly
          call ParseFullArg
          ld (BufPtr),bc
          ld (GrayBufPtr),bc
          ret
GrayBufOnly:
          call ParseNextFullArg
          ld (GrayBufPtr),bc
          ret
BlackBufOnly:
          call ParseNextFullArg
          ld (BufPtr),bc
          ret
TextToken:
          ld a,(hl)
          cp 4 \ jr z,RC
          cp 3Eh \ jr z,RC
          cp 3Fh \ jr nz,NoRC
RC:
          ld bc,(textRow)
          ld l,b \ ld b,0
          ld h,b
          ld (ThetaPrimeVar),hl
          ret
NoRC:
          res 0,(iy+33)
          cp 10
          jr nz,$+11
SlowText:
            set 0,(iy+33)
            inc hl
            ld (progPtr),hl
            ld a,(hl)
          cp $AE
          jp nz,FindingTextStr
            inc hl
            ld (progPtr),hl
            call LoadTextCoordinates
            call ParseNextFullArg 
            push bc
            push de
            ld a,(hl)
            cp 2Bh
            ld c,10
            call z,ParseNextFullArg+3
            ld hl,8483h
            ld (hl),0
            ld (TempWord1),hl
            pop de
            pop hl
     bit 5,(iy+34)
     jr z,DrawNumber
       bit 7,h
       jr z,DrawNumber
       ld a,l \ cpl \ ld l,a
       ld a,h \ cpl \ ld h,a
       inc hl
       push de \ push hl \ push bc
       ld a,1Ah \ call PutSC
       pop bc \ pop hl \ pop de
DrawNumber:
     ld a,c
     or a
     ret z
     dec a
     ret z
DispNumBase32:
;Inputs:
;     C is the base (use 2 to 36)
;     DEHL is the number to display
;
     ld b,32
     xor a
       add hl,hl
       rl e \ rl d
       rla
       cp c
       jr c,$+4
         inc l
         sub c
       djnz $-11
     push bc
     push de
     push hl
     add a,30h
     cp 3Ah
     jr c,$+4
     add a,7
     ld hl,(TempWord1)
     dec l
     ld (TempWord1),hl
     ld (hl),a
     pop hl
     pop de
     pop bc
     ld a,h
     or l \ or d \ or e
     jr nz,DispNumBase32
     ld hl,(TempWord1)
     jp GPutS
;===============================================================
PutSM:
;===============================================================
;Inputs:
;     hl points to the string to display
;     bc is the size of the string
;===============================================================
        ld a,b \ or c \ ret z
        push bc
        push hl
        ld a,(hl)
        call PutSC
        pop hl
        pop bc
        cpi
        jp pe,PutSM+3
        ret
FindingTextStr:
          call LoadTextCoordinates
          ret nz
          inc hl
          ld a,(hl)
          cp $AE
          jr nz,$+12
            ld (progPtr),hl
            call ParseNextFullArg
            ld a,c
            jp PutSC
          cp 11
          jr nz,$+13
            ld (progPtr),hl
            call ParseNextFullArg
            ld h,b \ ld l,c
            jp GPutS
     call ParseNextFullArg 
     push bc
     set 0,(iy+35)
     cp 2Bh
     jr nz,$+6
       call ParseNextFullArg 
       xor a
     pop hl
     jr z,$+7
PutTokenText:
;    HL points to the string
     res 0,(iy+35)
     ld bc,-1
TokenTextLoop:
     ld a,(hl)
     bit 0,(iy+35)
     jr nz,$+11
     cp 4
     ret z
     cp 3Fh
     ret z
     cp 2Ah
     ret z
     push  hl
     push bc
     bcall(4594h)
     pop hl
     or a
     sbc hl,bc
     jr nc,$+7
       add hl,bc
       ld b,h
       ld c,l
       ld l,0
     pop de
     push hl
     ld a,(de)
     call Is_2_Byte
     jr nz,$+3
     inc de
     push de
     ld hl,848Eh
     call PutSM
     pop hl
     pop bc
     inc bc
     cpi
     jp pe,TokenTextLoop
     ret
;===============================================================
LoadTextCoordinates:
;===============================================================
          ld a,(hl)
          cp 11
          jr nz,$+6
            ld (progPtr),hl
            ret
          ld bc,(textRow)
          call ParseFullArg
          ld a,c
          ld (textRow),a
          ld bc,(textCol)
          call ParseNextFullArg 
          ld a,c
          ld (textCol),a
          ld a,(hl)
          cp 2Bh
          ret
;===============================================================
PtOff:
          call ParseFullArg
          ld a,c \ and 7
          res 0,(iy+33)
          bit 3,c
          jr z,$+6
           set 0,(iy+33)
          push af
           call ParseNextFullArg 
           bit 0,(iy+33)
           jr z,$+8
             call ConvHexTo86ECh
             ld bc,86ECh
          push bc
           call ParseNextFullArg 
          push bc
           call ParseNextFullArg 
          pop de
          ld d,c
          push de
          cp 2Bh
          ld c,1
           call z,ParseNextFullArg 
;           push bc
           cp 2Bh
           ld c,8
           call z,ParseNextFullArg 
;           pop hl
           ld l,1
           ld h,c
           pop bc
           ld a,c \ cp 64 \ jp nc,Pop2Exit
           add a,h \ dec a \ sub 64
           jr c,HeightIsFinePtOff
             ld d,a \ ld a,h \ sub d \ ld h,a \ dec h
HeightIsFinePtOff:
           pop de
           ld a,b
           sub 97 \ jr nc,BadSprite
           ld a,l \ add a,a \ rlca \ rla                             ;hehe
           add a,b \ sub 97
           jr nc,BadSprite
           pop af
           push hl
           push af
           ld hl,(progPtr)
           ld a,(hl)
           cp 2Bh
           pop hl \ ld a,h
           pop hl
           jp nz,DrawPixelCoordSprite
             push hl
             ld hl,(BufPtr)
             ex (sp),hl
             push hl \ push de \ push bc \ push af
             call ParseNextFullArg
             ld (BufPtr),bc
             pop af \ pop bc \ pop de \ pop hl
             call DrawPixelCoordSprite
             pop hl
             ld (BufPtr),hl
             ret
BadSprite:
           pop af \ ret
;===============================================================
DrawPixelCoordSprite:
;===============================================================
;Inputs:
;     A is the method:
;        0=Overwrite
;        1=AND
;        2=XOR
;        3=OR
;        4=DataSwap.......Does nothing
;        5=Erase
;     B is the X-coordinate
;     C is the Y-Coordinate
;     DE points to the sprite
;     H is the height
;     L is the width     ;not added yet
;===============================================================
     di
     ex af,af'
     push hl
     ld a,b
     ld b,0
     ld h,b \ ld l,c
     add hl,hl \ add hl,bc
     add hl,hl \ add hl,hl
     push hl
     ld c,a
     srl c \ srl c \ srl c
     ld b,0
     ld hl,(BufPtr)
     add hl,bc
     pop bc

     add hl,bc
     push hl
     and 7
     ld (TempWord1),a
     exx
     pop hl
     ld bc,11
     exx
     pop bc
     ex af,af'
;===============================================================
;HL'=location to draw to
;B=height
;C is not needed
;A=method
;DE=sprite location

     or a
     jr nz,DrawSpriteAND-3
DrawSpriteOverwrite:
       exx
       ld de,$FF00
       call ShiftDE
       ld (TempWord3),de
       exx
DrawSpriteOverwriteLoop:
       ld a,(de)
       inc de
       exx
       ld d,0 \ ld e,a
       call ShiftDE
       push de
       ld de,(TempWord3)
       ld a,(hl)
       and e
       pop de
       or e \ ld (hl),a
       inc hl

       push de
       ld de,(TempWord3)
       ld a,(hl)
       and d
       pop de

       or d \ ld (hl),a
       add hl,bc
       exx
       djnz DrawSpriteOverWriteLoop
       ret

     dec a
     jr nz,DrawSpriteXOR-3
DrawSpriteAND:
       ld a,(de)
       inc de
       exx
       ld d,255 \ ld e,a
       call ShiftDE
       ld a,e
       and (hl) \ ld (hl),a
       inc hl
       ld a,d
       and (hl) \ ld (hl),a
       add hl,bc
       exx
       djnz DrawSpriteAND
       ret

     dec a
     jr nz,DrawSpriteOR-3
DrawSpriteXOR:
       ld a,(de)
       inc de
       exx
       ld d,0 \ ld e,a
       call ShiftDE
       ld a,e
       xor (hl) \ ld (hl),a
       inc hl
       ld a,d
       xor (hl) \ ld (hl),a
       add hl,bc
       exx
       djnz DrawSpriteXOR
       ret

     dec a
     jr nz,DrawSpriteSwap-3
DrawSpriteOR:
       ld a,(de)
       inc de
       exx
       ld d,0 \ ld e,a
       call ShiftDE
       ld a,e
       or (hl) \ ld (hl),a
       inc hl
       ld a,d
       or (hl) \ ld (hl),a
       add hl,bc
       exx
       djnz DrawSpriteOR
       ret

       dec a
       jr nz,DrawSpriteErase
DrawSpriteSwap:
         ret
DrawSpriteErase:
       ld a,(de)
       cpl
       inc de
       exx
       ld d,255 \ ld e,a
       call ShiftDE
       ld a,e
       and (hl) \ ld (hl),a
       inc hl
       ld a,d
       and (hl) \ ld (hl),a
       add hl,bc
       exx
       djnz DrawSpriteErase
       ret
ShiftDE:
     ld a,(TempWord1)
     or a \ ret z
     ld b,a
       rr e \ rr d
       jr nc,$+4
         set 7,e
       djnz $-8
     ret
LineToken:
          ld a,(hl)
          cp $AE
          jr nz,NLinePrime
;b,e need to be y
;c,d need to be x
           call ParseNextFullArg+3
           push bc
           call ParseNextFullArg 
           pop de
           ld b,e
           push bc
           call ParseNextFullArg 
           push bc
           call ParseNextFullArg 
           pop de
           ld b,e
           push bc
           cp 2Bh
           ld c,1
           call z,ParseNextFullArg 
           cp 2Bh
           ld a,c
           jr z,LineToBufSub
           pop de
           pop hl
           jp DrawLine
;======================================
NLinePrime:
;======================================
     call ParseFullArg
     push bc
     call ParseNextFullArg
     push bc
     call ParseNextFullArg
     pop hl \ pop de
     ld h,c
     push de \ push hl
     call ParseNextFullArg
     pop hl \ pop de
     ld d,c
     push de \ push hl
     call ParseNextFullArg
     ld a,(hl)
     cp 2Bh
     ld a,c
     pop bc \ pop de
     jp nz,DrawRectToGraph
RectToBufSub:
     di
     push de
     push bc
     push af
     ld hl,(BufPtr)
     push hl
     call ParseNextFullArg
     ld (BufPtr),bc
     pop hl
     pop af
     pop bc
     pop de
     push hl
     call DrawRectToGraph
     pop hl
     ld (BufPtr),hl
     ret
LineToBufSub:
     di
     push af
     ld hl,(BufPtr)
     push hl
     call ParseNextFullArg
     ld (BufPtr),bc
     pop hl
     pop af
     pop de
     pop bc
     push hl
     call DrawLine
     pop hl
     ld (BufPtr),hl
     ret

;======================================
LeftParantheses:
;Read a byte
          call ParseFullArg
          ld h,b
          ld l,c
          ld c,(hl)
          ld b,0
          ret
LeftBracket:
;Read a word (little endian)
          call ParseFullArg
          ld h,b
          ld l,c
          ld c,(hl)
          inc hl
          ld b,(hl)
          ret
iPart:
;Write a word (little endian)
          call ParseFullArg
          push bc
           call ParseNextFullArg 
          pop hl
          ld e,(hl)
          ld (hl),c
          inc hl
          ld d,(hl)
          ld (hl),b
          ld b,d
          ld c,e
          ret
int:
;Write a byte
          call ParseFullArg
          push bc
           call ParseNextFullArg 
          pop hl
          ld e,(hl)
          ld (hl),c
          ld c,e
          ld b,0
          ret
GetToken:
          ld a,(hl)
          cp $AE
            jp z,GetByte
NotGetByte:
          call GetVarName
          ex de,hl
          ld de,8478h
          ldir
          xor a
          ld (de),a
          call FindVar
VarTokenStepIn:
          jr nc,$+6
            ld bc,0
            ret
          inc de
          inc de
          ld c,a
          ld (ThetaPrimeVar),bc
          ld b,d
          ld c,e
          ret
RepeatToken:
          push hl
;          ld de,(965Bh) \ sbc hl,de
          ex de,hl
          pop hl
          call EndOfLine
;DE is the offset to the condition
          ld (progPtr),hl
          bit 2,(iy+33)
          res 2,(iy+33)
          jr nz,NotRepeatLoop
RepeatLoop:
            call RepeatLooper
            jr z,RepeatLoop
ExitRepeat:
            ld (progPtr),hl
            ret
NotRepeatLoop:
            call RepeatLooper
            jr nz,NotRepeatLoop
            jr ExitRepeat
RepeatLooper:
            push de
            call ParserNext
            ld hl,(progPtr)
            pop de
            push de
            push hl
;            ld hl,(965Bh) \ add hl,de
;            ld (progPtr),hl
            ld (progPtr),de
;            pop hl \ push hl
            push bc
            call ParseCondition
            ld a,b \ or c
Pop3Exit:
            pop bc
Pop2Exit:
            pop hl
Pop1Exit:
            pop de
            ret
WhileToken:
;         ld de,(965Bh)
;         sbc hl,de
         bit 2,(iy+33)
         res 2,(iy+33)
         jr nz,NotWhileLoop
WhileLoop:
         push hl
;         ld de,(965Bh) \ add hl,de
         ld (progPtr),hl     ;227298
         call ParseCondition
         ld a,b \ or c
         jr z,EndWhileLoop
         call ParserNext
         pop hl
         jr WhileLoop
NotWhileLoop:
         push hl
;         ld de,(965Bh) \ add hl,de
         ld (progPtr),hl     ;227298
         call ParseCondition
         ld a,b \ or c
         jr nz,EndWhileLoop
         call ParserNext
         pop hl
         jr NotWhileLoop
EndWhileLoop:
          pop de              ;D1
          call FindEndToken  
          ld (progPtr),hl     ;227298
          ret                 ;C9
EndToken:
          pop de              ;D1
          ret                 ;C9
StopToken:
BreakProgram:
          xor a
          push af
          xor a
          out (0),a
          pop af
          ld hl,(progPtr)
          dec hl            ;2B
          ld (965Dh),hl     ;225D96
          ld sp,(SPSave)    ;ED7B8698
          di
          im 1
          or a \ ret z
          ld b,a
          ld a,(9652h)
          cp 5
          ld a,b
          jr nz,$+4
            or 128
          bcall(44D7h)
          ret               ;C9
ErrorJump:
        bit 3,(iy+33)
        ret nz
        push bc
        push de
        push hl
        ld hl,(progPtr)
        ld (ErrorLoc),hl
        set 3,(iy+33)
        ld hl,(parseError)
        ld a,h \ or l
        ld a,(8595h)
        call z,GramHandl
        jr z,GramHandled
        ld c,a \ ld b,0
        ld de,(progPtr)     ;
        push de             ;
        ld (progPtr),hl     ;
        ld hl,(ThetaPrimeVar)
        push hl
        ld hl,(Ans)
        ld (Ans),bc
        call ParserNext     ;
        pop hl
        ld (Ans),hl
        pop hl
        ld (ThetaPrimeVar),hl
        pop hl              ;
        ld (progPtr),hl     ;
GramHandled:
        pop hl
        pop de
        pop bc
        res 3,(iy+33)
        ret
PtOn:
; jr $
          call ParseFullArg
          ld a,c \ and 7
          res 0,(iy+33)
          bit 3,c
; jr nz,$
          jr z,$+6
           set 0,(iy+33)
          push af
          cp 7 \ jr nz,$+9
            ld hl,89F0h+33
            ld a,16
            xor (hl)
            ld (hl),a
           call ParseNextFullArg 
           bit 0,(iy+33)
           jr z,$+8
             call ConvHexTo86ECh
             ld bc,86ECh
          push bc             ;C5
          call ParseNextFullArg 
          ld (TempWord2),bc
          ld b,0              ;0600
          ld h,b              ;60
          ld l,c              ;69
          add hl,hl           ;29
          add hl,bc           ;09
          add hl,hl           ;29
          add hl,hl           ;29
          push hl             ;E5
          call ParseNextFullArg 
          pop hl              ;E1
          add hl,bc           ;09
;          ld bc,(BufPtr)         ;014093
;          add hl,bc           ;09
          push hl             ;E5
          cp 2Bh
          ld c,1
          call z,ParseNextFullArg 
          ld b,c              ;41
          push bc             ;C5
          cp 2Bh
          ld c,1
          call z,ParseNextFullArg 
          pop af              ;F1
          ld b,a              ;47
          ld a,(TempWord2)
          add a,c \ dec a \ sub 64
           jr c,HeightIsFinePtOn
             ld d,a \ ld a,c \ sub d \ ld c,a \ dec c
HeightIsFinePtOn:
          push bc
          ld bc,(BufPtr)
          ld hl,(progPtr)
          ld a,(hl)
          cp 2Bh
          call z,ParseNextFullArg
          ld d,b \ ld e,c
          pop bc
          pop hl              ;E1
          add hl,de
          pop de              ;D1
          ld a,(TempWord2) \ inc a \ sub 64 \ jp nc,BadSprite
          pop af              ;F1
;===========================================================
DrawSpriteXxY:
;===========================================================
;Inputs:
;     A is the method:
;        0=Overwrite
;        1=AND
;        2=XOR
;        3=OR
;        4=Swap
;        5=Erase
;        6=Mask
;        7=Gray
;     B is the width (in bytes)
;     C is the height (in pixels)
;     DE points to the sprite data
;     HL points to the output location
;Outputs:
;     HL is A*12 larger (next sprite down?)
;     DE points to the next byte after the sprite data
;     A is 0
;     B is not changed
;     C is 12-B
;===========================================================
          push af             ;F5
          ld a,c              ;79
          di                  ;F3
          ex af,af'           ;08
          ld a,12             ;3E0C
          sub b               ;90
          ld c,a              ;4F
          pop af              ;F1
OverwriteXxY:
          or a                ;B7
          jr nz,ANDXxY        ;2010
            ex af,af'         ;08
              ex de,hl        ;EB
              push bc         ;C5
                ldi           ;EDA1
                inc bc        ;03
                djnz $-3      ;10FB
              ex de,hl        ;EB
              add hl,bc       ;09
              pop bc          ;C1
              dec a           ;3D
              jr nz,$-11      ;20F3
            ret               ;C9
ANDXxY:
          dec a               ;3D
          jr nz,XORXxY        ;2011
            ex af,af'           ;08
              push bc             ;C5
              push af             ;F5
                ld a,(de)           ;1A
                and (hl)            ;A6
                ld (hl),a           ;77
                inc de              ;13
                inc hl              ;23
                djnz $-5            ;10F9
              add hl,bc           ;09
              pop af              ;F1
              pop bc              ;C1
              dec a               ;3D
              jr nz,$-13          ;20F1
            ret                 ;C9
XORXxY:
          dec a               ;3D
          jr nz,ORXxY         ;2011
            ex af,af'           ;08
              push bc             ;C5
              push af             ;F5
                ld a,(de)           ;1A
                xor (hl)            ;AE
                ld (hl),a           ;77
                inc de              ;13
                inc hl              ;23
                djnz $-5            ;10F9
              add hl,bc           ;09
              pop af              ;F1
              pop bc              ;C1
              dec a               ;3D
              jr nz,$-13          ;20F1
            ret                 ;C9
ORXxY:
          dec a               ;3D
          jr nz,SwapXxY       ;2011
            ex af,af'           ;08
              push bc             ;C5
              push af             ;F5
                ld a,(de)           ;1A
                or (hl)             ;B6
                ld (hl),a           ;77
                inc de              ;13
                inc hl              ;23
                djnz $-5            ;10F9
            add hl,bc           ;09
            pop af              ;F1
            pop bc              ;C1
            dec a               ;3D
            jr nz,$-13          ;20F1
            ret                 ;C9
SwapXxY:
          dec a               ;3D
          jr nz,EraseXxY      ;2011
            ex af,af'           ;08
            ld c,12             ;0E0C
              push bc             ;C5
              push af             ;F5
                ld a,(de)           ;1A
                ldi                 ;EDA0
                dec hl              ;2B
                ld (hl),a           ;77
                inc hl              ;23
                djnz $-6            ;10F8
              add hl,bc           ;09
              pop af              ;F1
              pop bc              ;C1
              dec a               ;3D
              jr nz,$-14          ;20F0
            ret                 ;C9
EraseXxY:
          dec a               ;3D
          jr nz,MaskXxY       ;2011
            ex af,af'           ;08
              push bc             ;C5
              push af             ;F5
                ld a,(de)           ;1A
                cpl                 ;2F
                and (hl)            ;A6
                ld (hl),a           ;77
                inc de              ;13
                inc hl              ;23
                djnz $-6            ;10F8
              add hl,bc           ;09
              pop af              ;F1
              pop bc              ;C1
              dec a               ;3D
              jr nz,$-14          ;20F0
            ret                 ;C9
MaskXxY:
          dec a               ;3D
          jr nz,GrayXxY      ;2011
            ex af,af'           ;08
              push bc             ;C5
              push af             ;F5
              ex de,hl            ;EB
                ld a,(de)           ;1A
                and (hl)            ;2F
                inc hl              ;13
                or (hl)             ;B6
                ld (de),a           ;77
                inc de              ;13
                inc hl              ;23
                djnz $-7            ;10F9
              ex de,hl
              add hl,bc           ;09
              pop af              ;F1
              pop bc              ;C1
              dec a               ;3D
              jr nz,$-17          ;20EF
            ret                 ;C9            
GrayXxY:
            bit 4,(iy+33)       ;FDCB21**
            ld a,55h
            jr z,$+3
            rrca
            ex af,af'           ;08
              push bc             ;C5
              push af             ;F5
                ex af,af'
                ld (hl),a
                ex de,hl
                and (hl)
                inc hl
                or (hl)
                inc hl
                ex de,hl
                push af
                ld a,(hl)
                ex af,af'
                pop af
                ld (hl),a           ;77
                inc hl              ;23
                djnz $-14           ;10F0
              add hl,bc           ;09
              ex af,af'
              rlca
              ex af,af'
              pop af              ;F1
              pop bc              ;C1
              dec a               ;3D
              jr nz,$-25          ;20**
            ret                 ;C9
;===========================================================
QuoteToken:
          push hl             ;E5
          call GetGrammerStr 
          ld (progPtr),hl     ;227298
          ld (ThetaPrimeVar),bc ;ED436A80
          pop bc              ;C1
          ret                 ;C9
GetKeyToken:
        ld a,(hl) \ cp 16
        jr nz,GetKey
          call ParseNextFullArg+3
          ld a,c
CheckKey:
;46 bytes:
;Input:
;     A is the key to test for
;Output:
;     BC is 1 if the key is pressed, 0 if it is not
;     z if the key is pressed, nz if not
     cp 41
     jr nz,$+7
       call CheckStatus
       jr KeyEnd
     dec a \ and 63
     ld b,a
     and 7
     rr b \ rr b \ rr b
     inc b \ inc a
     ld c,a
     ld a,7Fh
       rlca
       djnz $-1
     out (1),a
     ld b,c
     ld a,7Fh
       rlca
       djnz $-1
     ld c,a
     in a,(1)
     cp c
KeyEnd:
     ld c,b
     ret nz
     ld c,1
     ret
;===============================================================
GetKey:
;===============================================================
;Outputs:
;     a is a value from 0 to 56 that is the keypress
;    bc is also the key press
;     d has a bit reset, the rest are set (this is the last key group tested)
;     e is a with a mask of %11111000
;    hl is not modified
;===============================================================
          ld a,-2
          out (1),a
          push af \ pop af
          in a,(1) \ cpl
          ld b,0
          or a \ jr z,JustCheckDaKeys
            ld d,a
            ld c,16 \ cp 15 \ ret z
            ld c,5
            ld a,3 \ and d \ cp 3 \ ret z \ inc c
            ld a,5 \ and d \ cp 5 \ ret z \ inc c
            ld a,10 \ and d \ cp 10 \ ret z \ inc c
            ld a,12 \ and d \ cp 12 \ ret z
JustCheckDaKeys:
          ld c,0
          ld de,$7FFF         ;11FF7F    ;11
KeyLoop:                                 ;
            rlc d             ;CB02      ;8
            ld a,d            ;7A        ;4
            out (1),a         ;D301      ;12
            inc e             ;1C        ;4
            sub 7Fh           ;D67F      ;7
            jr z,CheckOnPress ;28**      ;7|12
            nop               ;00        ;4
            in a,(1)          ;DB01      ;12
            inc a             ;3C        ;4
            jr z,KeyLoop      ;28EC      ;7|12
            dec a             ;3D        ;4
              inc c           ;0C        ;4
              rra             ;1F        ;4
              jr c,$-2        ;38FC      ;7|12
            ld a,e            ;83        ;4
            rlca \ rlca \ rlca;070707    ;12
            add a,c           ;81        ;4
            ld c,a            ;4F        ;4
            cp 41             ;FE41      ;
            ret c             ;D8        ;
CheckOnPress:
            call CheckStatus
            ret nz
            ld c,41 \ ld a,c
            ret               ;C9
IfToken:
          push bc             ;C5
          call ParseCondition ;CD****
          or a                ;B7
          sbc hl,hl           ;ED62
          sbc hl,bc           ;ED42
          pop bc              ;C1
          bit 2,(iy+33)
          jr z,$+7
            res 2,(iy+33)
            ccf
          ret c               ;D8
          ld hl,(progPtr)     ;2A7298
          inc hl              ;23
          ld a,(hl)           ;7E
          push bc             ;C5
          cp $CF              ;FECF
          jr nz,NoThenToken   ;20**
            call FindEndToken  
            ld (progPtr),hl     ;227298

NoThenToken:
          call EndOfLine     
          ld (progPtr),hl     ;227298
          pop bc              ;C1
          ret                 ;C9
VarToken:
        call VarPointer
        ld (progPtr),de
        ld c,(hl)           ;4E
        inc hl              ;23
        ld b,(hl)           ;46
        ex de,hl            ;EB
        ld a,(hl)
        inc hl
        call VarPointer        
        ret nc
        ld (progPtr),de
        ld e,c
        ld d,b
        ld c,(hl)           ;4E
        inc hl              ;23
        ld b,(hl)           ;46
        set 5,(iy+33)
        ret
ParseFullArg:
        bit 5,(iy+33)
        jr nz,$+5
          ld de,0
        res 5,(iy+33)
        ld hl,(progPtr)
        ld a,(hl)
        call EndOArg
        ret z
        cp 29h \ ret z
        call ParseArg     
        jr ParseFullArg
ParseNextFullArg:
          ld hl,(progPtr)
          inc hl
          ld (progPtr),hl
          jr ParseFullArg
ParseCondition:
; jr $
;          call ParseFullArg
          call ParseArg
          ld hl,(progPtr)     ;2A7298
          ld a,3Fh
          cp (hl)
          ret z
;          cp 3Fh \ ret z
;          ld hl,(progPtr)     ;2A7298
;          inc hl              ;23
;          ld (progPtr),hl
          jr ParseCondition
GetNextVarNum:
     inc hl
     ld a,(hl)
     cp $AE \ jr nz,$+7
     set 6,(iy+33) \ ret
     sub 3Ah
     ret nc
     add a,10
     ret nc
     ld a,d
     add a,a
     add a,a
     add a,d
     add a,a
     ld d,a
     ld a,(hl)
     and 15
     add a,d
     ld d,a
     jr GetNextVarNum
StoString:
     ld e,a
     ld d,(hl)
     inc d
     call GetNextVarNum
     dec d
     ld (progPtr),hl
     ld h,b \ ld l,c
     push bc
     push de
     call GetGrammerStr
     pop hl
     bit 6,(iy+33)
     jr z,$+3
       inc bc
     push bc
     ld b,h
     ld c,l
     ld (8479h),hl
     xor a
     ld (847Bh),a
     call SearchVarBC
     jr c,$+5
     bcall(4FC6h)
     pop hl
     push hl
     bcall(4327h)
     inc de
     inc de
     pop bc
     pop hl
     ldir
     bit 6,(iy+33)
     jr z,$+6
       dec de
       ld a,3Fh
       ld (de),a
     res 6,(iy+33)
     ret
StoDisp:
     ld (progPtr),hl
     ld a,c
     ld b,0
     ld d,b
     ld e,b
     ld h,b
     ld l,b
     sub 6
     jr nc,$+4
       ld a,c
       inc b
     ld c,1
     or a
     jr nz,$+4
     dec hl
     dec c
     dec a
     jr nz,$+6
     dec c
     ld hl,%1010101010101010
     dec a
     jr nz,$+5
     ld hl,%1001001001001001
     dec a
     jr nz,$+5
     ld hl,%1000100010001000
     dec a
     jr nz,$+5
     ld hl,%1000001000001000
     dec a
     jr nz,$+5
     ld hl,%1000000000001000
     dec b
     jr z,$+6
       scf
       ex de,hl
       sbc hl,de
     ld (GrayMask),hl
     ld hl,GrayRotate
     ld a,(hl)
     and $FC
     or c
     ld (hl),a
     ret
StoToken:
          ld a,(hl)           ;7E
          inc hl              ;23
          cp $AA \ jp z,StoString
          cp $DE \ jr z,StoDisp
          cp 44
          jr nz,NotOSVar
            push bc
            ld a,(hl)
            ld (8479h),a
            inc hl
            ld (progPtr),hl
            ld hl,0
            ld (847Ah),hl
            ld h,b \ ld l,c
            bcall(4792h)
            rst 10h
            jr nc,$+5
              bcall(430Fh)
            ld a,b
            or a \ jr nz,Archived
            ld bc,9
            ld hl,8483h
            ldir
Archived:
            pop bc
            ret
NotAVar:
        ld (progPtr),hl     ;227298
        ret
NotOSVar:
          call VarPointer
          jr nc,NotAVar
          push hl
          ld a,(de)
          ex de,hl
          inc hl
;HL points to the next parse byte
          call varPointer
          jr c,$+5
          dec hl
          ex de,hl \ pop hl            ;de points to the next byte
          ld (hl),c           ;71
          inc hl              ;23
          ld (hl),b           ;70
          ld (progPtr),de     ;227298
          ret nc
          pop hl
          ld de,(ThetaPrimeVar)
          ld (hl),e           ;73
          inc hl              ;23
          ld (hl),d           ;72
          ret                 ;C9
Return:
          call EndOfLine     
          ld c,l              ;4D
          ld b,h              ;44
          ret                 ;C9
LblToken:
          push hl             ;E5
          call ParseFullArg  
          pop hl              ;E1
          push bc             ;C5
          call GetGrammerStr 
          pop hl              ;E1
          ld de,8483h         ;118384
          push de             ;D5
          ld a,3Ah            ;3E3A
          ld (de),a           ;12
          inc de              ;13
          push bc             ;C5
          ldir                ;EDB0
           dec de              ;1B
           ld a,3Fh            ;3E3F
           ld (de),a           ;12
    ld hl,(progPtr)
    ld a,(hl)
    cp 2Bh
    jr nz,RegularLabel
      inc hl
      ld (progPtr),hl
      call GetVarInfo2
      jr nc,RegularLabel+3
RegularLabel:
          ld hl,(progStart)   ;2A7298
          ld a,3Fh
          pop bc              ;C1
          inc bc              ;03
          pop de              ;D1
          call SearchString  
          ld b,h              ;44
          ld c,l              ;4D
          ret                 ;C9
GotoToken:
          push bc
          call ParseFullArg  
          ld (progPtr),bc     ;ED437298
          pop bc
          ret                 ;C9
DispGraph:
          ld a,(hl)
          ld hl,(BufPtr)
          call EndOArg
          jr z,$+7
            call ParseFullArg
            ld h,b \ ld l,c
          jp GraphToLCD+3  ;CA****
Number:
          jp ConvRStr     
Math:
Sqrt:
     ld a,(hl)
     inc hl
     cp $AE
     push af
     jr nz,$+5
       ld (progPtr),hl
     call ParseFullArg
     ld h,b
     ld l,c
     call SqrtHL
     ld (ThetaPrimeVar),de
     ld e,a
     pop af
     ret z
     ld c,e
     ld b,0
     ret



Cos:
        ld a,64            ;3E40
        jr $+3             ;1805
Sin:
          xor a              ;AF
          push af            ;F5
          call ParseFullArg 
          pop af             ;F1
          add a,c            ;81
 ld d,a
Sine:
 bit 6,a
 jr z,$+5
   cpl
   xor 80h
 and 63
 ld c,a
 ld hl,sinTable
 ld b,0
 add hl,bc
 ld c,(hl)
 rlc d
 ret nc        ;123
 xor a
 sub c
 ld c,a
 sbc a,a
 sub b
 ld b,a
 ret
sinTable:
 .db 0,3,6,9,13,16,19,22,25,28,31,34,37,40,43,46
 .db 49,52,55,58,60,63,66,68,71,74,76,79,81,84,86,88
 .db 91,93,95,97,99,101,103,105,106,108,110,111,113,114,116,117
 .db 118,119,121,122,122,123,124,125,126,126,127,127,127,128,128,128
absToken:
          call ParseFullArg 
          bit 7,b \ ret z
          jr Negative+3
Negative:
          call ParseFullArg 
          xor a \ sub c \ ld c,a
          sbc a,a \ sub b \ ld b,a
          ret                ;C9
Add:
          push bc            ;C5
          call ParseFullArg 
          pop hl             ;E1
          xor a              ;AF
          add hl,bc          ;09
          ld b,h             ;44
          ld c,l             ;4D
          ld h,a             ;67
          adc a,a            ;8F
          ld l,a             ;6F
          ld (ThetaPrimeVar),hl ;226A80          
          ret                ;C9
Subtract:
          push bc            ;C5
          call ParseFullArg 
          pop hl             ;E1
          xor a              ;AF
          sbc hl,bc          ;ED42
          ld b,h             ;44
          ld c,l             ;4D
          sbc hl,hl          ;ED62
          ld (ThetaPrimeVar),hl ;226A80          
          ret                ;C9
Cubed:
          ld d,b
          ld e,c
          call DE_Times_BC
          ex de,hl
          jr Multiply+5
Squared:
          ld d,b
          ld e,c
          jr $+7
Multiply:
          push bc            ;C5
          call ParseFullArg 
          pop de             ;D1
          call DE_Times_BC  
          ld b,h             ;44
          ld c,l             ;4D
          ld (ThetaPrimeVar),de ;ED536A80
          ret                ;C9

Comment:
SkipLine:
          call EndOfLine
          jp ParseArg+3
          ld a,(hl)          ;7E
          cp 93h \ jp z,SlowText
          cp 83h             ;FE83
            jr z,SkipLine     ;CA****
          cp 29h \ jr nz,Divide
          push bc            ;C5
          call ParseNextFullArg 
          pop hl             ;E1
          call HL_SDiv_BC   
          ld b,h             ;44
          ld c,l             ;4D
          ld (ThetaPrimeVar),de ;ED536A80
          ret                ;C9
Divide:
          push bc            ;C5
          call ParseFullArg 
          pop hl             ;E1
          call HL_Div_BC    
          ld b,h             ;44
          ld c,l             ;4D
          ld (ThetaPrimeVar),de ;ED536A80
          ret                ;C9
Logic:
Equals:
          push bc            ;C5
factorialStepIn:
          call ParseFullArg 
          pop hl             ;E1
          xor a              ;AF
          sbc hl,bc          ;ED42
          ld b,a             ;47
          ld c,a             ;4F
          jr nz,$+3          ;2001
            inc c              ;1C
          ret                ;C9
moreLogic:
     push af
     push bc
     call ParseFullArg
     pop hl
     pop af
     ret
notLogic:
     call MoreLogic
     ld a,b \ cpl \ ld b,a
     ld a,c \ cpl \ ld c,a
     ret
andLogic:
     call MoreLogic
     ld a,h \ and b \ ld b,a
     ld a,l \ and c \ ld c,a
     ret
orLogic:
     call MoreLogic
       ld a,h \ or b \ ld b,a
       ld a,l \ or c \ ld c,a
       ret
xorLogic:
     call MoreLogic
       ld a,h \ xor b \ ld b,a
       ld a,l \ xor c \ ld c,a
       ret
Less:
     call MoreLogic
          xor a              ;AF
          sbc hl,bc          ;ED42
          ld b,a             ;47
          adc a,a            ;8F
          ld c,a             ;4F
          ret                ;C9
Greater:
     call MoreLogic
          xor a              ;AF
          scf                ;37
          sbc hl,bc          ;ED42
          ccf                ;3F
          ld b,a             ;47
          adc a,a            ;8F
          ld c,a             ;4F
          ret                ;C9
LessOrEqual:
     call MoreLogic
          xor a              ;AF
          scf                ;37
          sbc hl,bc          ;ED42
          ld b,a             ;47
          adc a,a            ;8F
          ld c,a             ;4F
          ret                ;C9
MoreOrEqual:
     call MoreLogic
          xor a              ;AF
          sbc hl,bc          ;ED42
          ccf                ;3F
          ld b,a             ;47
          adc a,a            ;8F
          ld c,a             ;4F
          ret                ;C9
NotEqual:
     call MoreLogic
          xor a              ;AF
          sbc hl,bc          ;ED42
          ld b,a             ;47
          ld c,a             ;4F
          jr z,$+3           ;2801
            inc c              ;1C
Exit:
        ret                 ;C9
EndOfCommand:
        ld hl,(progPtr)
        inc hl
        ld a,(hl) \ call EndOArg
        jr nz,EndOfCommand+3
        ld (progPtr),hl
        ret
EndOArg:
          cp 4 \ ret z
EndOArgNotSto:
          cp 3Fh \ ret z
;          cp 3Ah \ ret z
          cp 3Eh \ ret z
          cp 2Bh \ ret z
          or a
          ret
;====================================
;====================================
;This section contains calls and data
;used by Grammer.
;====================================
;====================================
;
;===============================================================
FindEndToken:
;===============================================================
;Input:
;     HL is an address
;Outputs:
;     HL points to the byte after the proper End token
;===============================================================
     ld b,1
SearchEndLoop:
       inc hl
       ld a,(hl)
       sub $CF                  ;Then
       jr c,SearchEndLoop       ;**Just to save time
       jr z,AddNewEnd
       dec a
       dec a \ jr z,AddNewEnd   ;While
       dec a \ jr z,AddNewEnd   ;Repeat
       dec a \ jr z,AddNewEnd   ;For
       dec a \ jr nz,SearchEndLoop ;End
       djnz SearchEndLoop
     inc hl
     ret
AddNewEnd:
       inc b
       jr SearchEndLoop
;===============================================================
GetGrammerText:
;===============================================================
;Input:
;    HL points to the start of the string
;Outputs:
;     A is the value of the ending byte of the string
;    BC is the size of the string
;    DE points to the start of the converted string
;    HL points to the ending byte of the string
;     z flag is set
;===============================================================
        ld de,86ECh          ;11EC86
        ld bc,0              ;010000
        push de
TextConvert:
          ld a,(hl)            ;7E
          cp 4
          jr z,TextConvertEnd
          cp 3Fh
          jr z,TextConvertEnd
          cp 2Ah
          jr z,TextConvertEnd
          call TokToASCII+3
          jp TextConvert
     ld de,848Eh
TokToASCII:
;Inputs:
;     HL points to the token
;     DE points to where the token should get converted to
;Outputs:
;     HL is incremented
;     DE points to the byte after the string 
;     BC is the size of the string
     ld bc,0
     push hl
     push bc
     push de
     bcall(4594h)
     pop de
     pop hl
     add hl,bc
     push hl
     ld hl,848Eh
     ldir
     pop bc
     pop hl
     ld a,(hl)            ;7E
     call Is_2_Byte
     jr nz,$+3
       inc hl
     inc hl
     ret
TextConvertEnd:
     inc hl
     pop de
     ret
;===============================================================
GetGrammerStr:
;===============================================================
;Input:
;    HL points to the start of the string
;Outputs:
;     A is the value of the ending byte of the string
;    BC is the size of the string
;    DE is (progEnd)
;    HL points to the ending byte of the string
;     z flag is set
;===============================================================
        ld bc,0              ;010000
          inc hl               ;23
          inc bc               ;03
          ld a,(hl)            ;7E
          cp 4 \ ret z         ;FE04C8
          cp 3Fh \ ret z       ;FE3FC8
          cp 2Ah \ jr nz,$-11  ;FE2A20F3
          inc hl               ;23
          ret                  ;C9
;===============================================================
VarPointer:
;===============================================================
;Inputs:
;     A is the var to return the pointer of
;     hl points to the next byte
;Outputs:
;     A is the lower 8-bits of the pointer
;     BC is not affected
;     DE should be used to update (progPtr)
;     HL points to the var data
;     c flag is reset if A was not a var token

        cp BBh \ jr nz,NotBBvar
        ld d,h \ ld e,l
        ld a,(hl)
        sub 203
        ret nc
        add a,16
        jr nc,$+3
        dec a
        add a,11
        or a
        ret m
        add a,a
        ld hl,9109h
        add a,l
        ld l,a
        inc de
        scf
        ret        
NotBBVar:
        cp 41h              ;FE41
        ccf \ ret nc        ;3FD0
        cp 5Ch              ;FE5C
        ret nc              ;D0
        sub 41h             ;D641
        rlca                ;07
        ld d,90h            ;1680
        ld e,a              ;5F
        ld a,(hl)           ;7E
        cp $AE              ;FEAE           ' token
        jr nz,$+7           ;2005
          ld a,36h            ;3E36
          add a,e             ;83
          ld e,a              ;5F
          inc hl              ;23
        ld a,e              ;7B
        add a,D3h             ;C6D3
        jr nc,$+3           ;3001
          inc d               ;14
        ld e,a              ;5F
        ex de,hl            ;EB
        scf                 ;37
        ret                 ;C9
;===============================================================
EndOfLine:
;===============================================================
;Input:
;     HL is a pointer
;Output:
;     HL points to the next line
;     DE is (progEnd)
;===============================================================
        ld a,3Fh            ;3E3F
        push bc
        ld bc,0
        cpir                 ;
        pop bc
        ret                 ;C9
;===============================================================
IsHexTok:
;===============================================================
;Input:
;     DE points to the byte after the byte to check
;Output:
;     DE is decremented by 1
;      A is the hex value if A is a hex token
;     nc if A is a hex token
;      c if A is not a hex token 
;===============================================================
        ld a,(de)
        inc de
        cp 47h
        ccf \ ret c
        cp 40h
        jr nc,$+8
          cp 3Ah
          ccf \ ret c
          jr $+4
        sub 7
        sub 30h
        ret
;===============================================================
ConvRStr:
;===============================================================
;Input: 
;     DE points to the base 10 number string in RAM. 
;Outputs: 
;     HL is the 16-bit value of the number 
;     DE points to the byte after the number 
;     BC is HL/10 
;     z flag reset (nz)
;     c flag reset (nc)
;Destroys: 
;     A (actually, add 30h and you get the ending token) 
;Size:  35 bytes
;Speed: 106n+109+9c
;       n is the number of digits 
;       c is at most n-2 
;       at most 666 cycles for any 16-bit decimal value 
;===============================================================
     dec hl
     bit 3,(iy+34)
     jp nz,ConvHexStr
     ex de,hl         ;   4 : EB
     ld hl,0          ;  10 : 210000 
ConvLoop:             ; 
     ld a,(de)        ;   7 : 1A 
     sub 30h          ;   7 : D630 
     cp 10            ;   7 : FE0A 
     jr nc,Convtd     ;7|12 : 30**
     inc de           ;   6 : 13 
                      ; 
     ld b,h           ;   4 : 44 
     ld c,l           ;   4 : 4D 
     add hl,hl        ;  11 : 29 
     add hl,hl        ;  11 : 29 
     add hl,bc        ;  11 : 09 
     add hl,hl        ;  11 : 29 
                      ; 
     add a,l          ;   4 : 85 
     ld l,a           ;   4 : 6F 
     jr nc,ConvLoop   ;12|23: 30EE 
     inc h            ; --- : 24 
     jp ConvLoop      ; --- : 18EB
Convtd:
     ld (progPtr),de  ;  20 : ED53****
     ld b,h
     ld c,l
     ret
;===============================================================
HL_Times_BC:
;===============================================================
;Inputs:
;     HL and BC are factors
;Outputs:
;     DEHL is the 32-bit value of the product
;     BC is unchanged
;     A is 0
;===============================================================
        ex de,hl           ;EB
;===============================================================
DE_Times_BC:
;===============================================================
;Inputs:
;     DE and BC are factors
;Outputs:
;     DEHL is the 32-bit value of the product
;     BC is unchanged
;     A is 0
;Speed: Max: 912 cycles     1095 rolled   967 is avg
;       Min: 614  cycles    839 rolled
;===============================================================
;       Mnemonic        ;size hex        cycles        Total
;===============================================================
     ld hl,0            ;3  21000        10             10
     ld a,16            ;2  3E10          7              7
MultLoop:
     add hl,hl          ;1  29           11            176
     rl e \ rl d        ;4  CB03CB02     16            256
     jr nc,$+6          ;2               7|12          192+256
     add hl,bc
     jr nc,$+3
     inc e              ;1               11            
     dec a
     jr nz,MultLoop
     ret
;===============================================================
DE_Div_BC:
;===============================================================
;Performs DE/BC
;Speed:   1498 cycles
;Size:    24 bytes
;Inputs:
;     DE is the numerator
;     BC is the denominator
;Outputs:
;     HL is the quotient
;     DE is the remainder
;     BC is not changed
;     A is 0
;     z flag is set
;     c flag is reset
;===============================================================
        ex de,hl           ;EB
;===============================================================
HL_Div_BC:
;===============================================================
;Performs HL/BC
;Speed:   1494 cycles
;Size:    23 bytes
;Inputs:
;     HL is the numerator
;     BC is the denominator
;Outputs:
;     HL is the quotient
;     DE is the remainder
;     BC is not changed
;     A is 0
;     z flag is set
;     c flag is reset
;===============================================================
        ld a,16              ;3E10       7        7
        ld de,0              ;110000    10       10
Div16Loop:
          add hl,hl          ;29        11      176
          ex de,hl           ;EB         4       64
          adc hl,hl          ;ED6A      15      240
          or a               ;B7         4       64
          sbc hl,bc          ;ED42      15      240
          jr c,$+5           ;3803      23|23   368  (I feel  special ^^)
            inc e            ;1C        --
            jr EndDiv16Loop  ;1801      --
          add hl,bc          ;09        --
EndDiv16Loop:
          ex de,hl           ;EB         4       64
          dec a              ;3D         4       64
          jr nz,Div16Loop    ;20EF    7+15*12   187
          ret                ;C9        10       10
;===============================================================
HL_Times_A:
;===============================================================
;Speed:  346+6x cycles where x is the number of set bits in "a"
;Size:   14 bytes
;Inputs:
;     HL and A are factors
;Outputs:
;     A is unchanged
;     B is 0
;     C is unchanged
;     DE is the original HL value
;     HL is the product
;===============================================================
        ex de,hl           ;EB
;===============================================================
DE_Times_A:
;===============================================================
;Inputs:
;     DE and A are factors
;Outputs:
;     A is not changed
;     B is 0
;     C is not changed
;     DE is not changed
;     HL is the product
;Time:
;     342+6x
;
     ld b,8          ;7           7
     ld hl,0         ;10         10
       add hl,hl     ;11*8       88
       rlca          ;4*8        32
       jr nc,$+3     ;(12|18)*8  96+6x
         add hl,de   ;--         --
       djnz $-5      ;13*7+8     99
     ret             ;10         10
;===============================================================
IsHLAtEOF:
;===============================================================
;Input:
;     HL is an address
;Outputs:
;     de is (progEnd)
;     c flag is set if HL is not at or past the end of the code
;     nc if hl is at or past the end of the code
;===============================================================
        ld de,(progEnd)     ;ED5B7498
        or a                ;B7
        sbc hl,de           ;ED52
        add hl,de           ;19
        ret                 ;C9
;===============================================================
SearchString:
;===============================================================
;Inputs:
;     BC-size o' string
;     DE-points to search string
;     HL-start of search
;     (progEnd) contains the end of the file
;Outputs:
;     c flag set if there was a match, nc if no match was found
;     HL points to the match if there was one
;     DE is not changed
;     BC is not changed
;Destroys:
;     A
;===============================================================
          ld (TempWord1),bc
          ld (TempWord2),de
SearchStringLoop:
          ld de,(TempWord2)
          ld bc,(TempWord1)
            ld a,(de)           ;1A
            inc de              ;13
            cpi                 ;EDA1
            jr nz,SearchStringLoop
            jp po,MatchedString
            jr SearchStringLoop+8
MatchedString:
          ld bc,(TempWord1)
          ld de,(TempWord2)
          scf                 ;37
          ret                 ;C9
;===============================================================
CheckStatus:
;===============================================================
;Speed:  89 cycles
;Size:   13 bytes
;Outputs:
;     z is set if ON is being pressed
;     c is set if 15MHz mode is used
;===============================================================
          push bc             ;C5        11
          push af             ;F5        11
          in a,(4)            ;DB04      11
          and 8               ;E608       7      Check [on]
          in a,(20)           ;DB20      11
          rra                 ;1F         4      c if 15MHz
          pop bc              ;C1        10
          ld a,b              ;78         4
          pop bc              ;C1        10
          ret                 ;C9        10
;===============================================================
GraphToLCD:
;===============================================================
     ld hl,(BufPtr)           ;214093
     ld ix,(GrayBufPtr)
;===============================================================
BufferToLCD:
;===============================================================
;Input:
;     HL points to the buffer to copy to the LCD
;Outputs:
;
;===============================================================
     di
setrow:
     LCDDelay()
     ld a,$80
     out (16),a
     exx
     ld hl,(GrayMask)
     add hl,hl
     jr nc,$+4
       set 4,l
     ld (GrayMask),hl
     ld bc,(GrayRotate)
     ld a,3
     and c
     ld c,a
     exx
     ld de,12
     LCDDelay()
     ld a,$20
col:
     push af
;     LCDDelay()
     pop af
     out (10h),a
     push af
     ld b,64
row:
;(checker AND gray) OR black
;
     exx
     add hl,hl
     jr nc,$+4
       set 4,l
     ld a,h
     exx
     ld c,a
     ld a,(ix)
     xor (hl)
     and c
     xor (hl)
;     rlc c
;     ld a,(ix)
;     and c
;     or (hl)

     add hl,de
     add ix,de
     bit 1,(iy+34)
     jr z,$+3
       cpl
     ex af,af'
     LCDDelay()
     ex af,af'
     out ($11),a

     exx
     ld b,c
     inc b
     dec b
     jr z,RotateDone
RotateMask:
     add hl,hl
     jr nc,$+4
       set 4,l
       ld a,h
     djnz RotateMask
RotateDone:
     exx
     djnz row



     pop af
     inc a
     dec h
     dec h
     dec h
     inc hl
     dec ixh
     dec ixh
     dec ixh
     inc ix

     cp $2c
     jp nz,col
     ret
;===============================================================
DrawRectToGraph:
;===============================================================
;Inputs:
;     A is the type of rectangle to draw
;        0 =White
;        1 =Black
;        2 =XOR
;        3 =Black border
;        4 =White border
;        5 =XOR border
;        6 =Black border, white inside
;        7 =Black border, XOR inside
;        8 =White border, black inside
;        9 =White border, XOR inside
;        10=Shift Up
;        11=Shift Down
;     B is the height
;     C is the Y pixel coordinate
;     D is the width in pixels
;     E is is the X pixel coordinate
;===============================================================
;RectData   equ 84A2h
     di
     ex af,af'
;Check if coords are negative
     ld a,c
     or a
     jp p,$+9
       add a,b
       ret nc
       ret z
       ld b,a
       ld c,0

     ld a,e
     or a
     jp p,$+9
       add a,d
       ret nc
       ret z
       ld d,a
       ld e,0
;Check dimensions
     ld a,b
     or a
     ret z
     jp p,$+6
       neg
       ld b,a
     add a,c
     sub 64
     jr c,$+6
       neg
       add a,b
       ld b,a

     ld a,d
     or a
     ret z
     jp p,$+6
       neg
       ld d,a
     add a,e
     sub 96
     jr c,$+6
       neg
       add a,d
       ld d,a
     ld a,c
     cp 64
     ret nc
     ld a,e
     cp 96
     ret nc
MakePattern:
     push bc
     ld hl,RectData
     ld b,24
     xor a
     ld (hl),a
     inc l
     djnz $-2
     ld hl,RectData
     ld c,RectData+12
     ld a,e
     sub 8
     jr c,$+6
       inc l
       inc c
       jr $-6
     add a,8
     ld b,a
     inc b
     ld e,a
     ld a,d
     add a, e
     ld e,a
     ld a,1
     rrca
     djnz $-1
     ld b,l
     push af
     ld l,c
     or (hl)
     ld (hl),a
     ld l,b
     pop af
     dec a
     scf
     adc a,a
     ld (hl),a
     ld a,e
     sub 8
     jr c,$+10
     jr z,$+10
       inc l
       ld (hl),-1
       inc c
       jr $-10
     add a,8

     ld b,a
     or a
     ld a,1
     jr z,$+5
     rrca
     djnz $-1

     ld b,l
     push af
     ld l,c
     or (hl)
     ld (hl),a
     ld l,b
     pop af
     dec a
     cpl
     and (hl)
     ld (hl),a
     pop bc
     ld a,b
     ld b,0
     ld h,b
     ld l,c
     add hl,hl
     add hl,bc
     add hl,hl
     add hl,hl
     ld bc,(BufPtr)
     add hl,bc
     ld b,a
     ex af,af'
     .db $CB,$67,$28,$10,$D6,$10,$F5,$0E,$18,$11
     .dw RectData
     .db $1A,$2F,$12,$13,$0D,$20,$F9,$F1

     or a
     jr nz,$+13h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$2F,$A6,$77,$13,$23,$0D,$20,$F7,$10,$F0,$C9

     dec a
     jr nz,$+12h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$F1,$C9

     dec a
     jr nz,$+12h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23
     .db $0D,$20,$F8,$10,$F1,$C9

     dec a
     jr nz,$+26h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$05,$C8
     .db $05,$28,$0F,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$F1,$04,$18,$DC

     dec a
     jr nz,$+28h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$10,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$10,$F0,$04,$18,$DA

     dec a
     jr nz,$+26h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE
     .db $77,$13,$23,$0D,$20,$F8,$05,$C8,$05,$28,$0F,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8
     .db $10,$F1,$04,$18,$DC

     dec a
     jr nz,$+36h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$05,$C8,$05
     .db $28,$1F,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A
     .db $B6,$77,$13,$23,$0D,$20,$F8,$10,$E1,$04,$18,$CC

     .db $3D,$20,$33,$0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13
     .db $23,$0D,$20,$F8,$05,$C8,$05,$28,$1E,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$E1
     .db $0E,$0C,$11
     .dw RectData+12
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$E2,$04,$18,$CD,$3D,$20,$34,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$1E,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$B6
     .db $77,$13,$23,$0D,$20,$F8,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$10,$E2,$04,$18
     .db $CC,$3D,$20,$35,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$1F,$E5
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$A6,$AE,$77,$13
     .db $23,$0D,$20,$F7,$10,$E1,$04,$18,$CB,$3D,$20,$37,$05,$C8,$F3,$E5,$D9,$01,$0C,$00,$E1,$09,$D9,$0E
     .db $0C,$11
     .dw RectData
     .db $D5,$D9,$D1,$D9,$1A,$2F,$A6,$D9,$47,$1A,$A6,$B0,$13,$23,$D9,$77,$13,$23,$0D,$20
     .db $EF,$10,$E4,$0E,$0C,$11
     .dw RectData
     .db $1A,$2F,$A6,$77,$13,$23,$0D,$20,$F7,$FB,$C9

     .db $3D,$20,$40,$F3,$C5
     .db $11,$0C,$00,$19,$10,$FD,$2B,$E5,$D9,$11,$F4,$FF,$E1,$19,$D9,$C1,$05,$C8,$0E,$0C,$11
     .dw RectData+11
     .db $D5
     .db $D9,$D1,$D9,$1A,$2F,$A6,$D9,$47,$1A,$A6,$B0,$1B,$2B,$D9,$77,$1B,$2B,$0D,$20,$EF,$10,$E4,$0E,$0C
     .db $11
     .dw RectData+11
     .db $1A,$2F,$A6,$77,$1B,$2B,$0D,$20,$F7,$FB,$C9

     dec a
     ret z
     dec a
     ret z
 jr $
     exx
     ld de,0
     ld c,8
     exx
PxlTestRect:
     dec a
     jr nz,PxlTestBorder
     ld c,12
     ld de,RectData
PxlTstRectLoop:
       call PxlTestWithMask
       djnz PxlTstRectLoop-5
       exx
       ld b,d
       ld c,e
       ret
PxlTestBorder:
     dec a
     ret nz
     ld c,12
     ld de,RectData
     call PxlTestWithMask
     dec b
     jr z,PxlTestBorder-4
     dec b
     jr z,PxlTestBrdrEnd
     ld c,12
     ld de,RectData+12
PxlTstBrdrLoop:
       call PxlTestWithMask
       djnz PxlTstBrdrLoop-5
PxlTestBrdrEnd:
     ld de,RectData
     ld c,12
     call PxlTestWithMask
     exx
     ld b,d
     ld c,e
     ret
PxlTestWithMask:
     ld a,(de)
     and (hl)
     exx
     ld b,c
     add a,a
     jr nc,$+3
     inc de
     jr z,$+4
     djnz $-6
     exx
     inc de
     inc hl
     dec c
     jr nz,PxlTestWithMask
     ret
PutSS:
      ld d,a \ jr GPutS+2
GPutSS:
      ld (textRow),bc
;===============================================================
GPutS:
;===============================================================
;Inputs:
;     HL points to a zero terminated string to display
;     (textRow) is the pixel row to draw at
;     (textCol) is the text column to draw at (0 to 23)
;Outputs:
;     HL points to the ending byte
;     BC is the size of the string
;     A is 0
;     z flag is set
;     c flag reset
;Destroys:
;     DE
;===============================================================
       ld d,0
       ld bc,0
       ld a,(hl) \ cp d \ ret z
       push de
       inc bc \ push bc
       inc hl
       push hl
       call PutSC
       pop hl
       pop bc
       pop de
       jr GPutS+5
;===============================================================
PutSC:
;===============================================================
;Inputs:
;     a is the char to draw
;     (textRow) is the pixel row to draw at
;     (textCol) is the text column to draw at (0 to 23)
;===============================================================
        ld b,a
        ld a,(GrayRotate)
        and 18h
        jp z,$+18
        cp 8
        jp z,VPutC
        cp 10h
        jp z,VPutSC
        cp 18h
        jp z,OmniCalcFont
        push bc
        ld bc,(textRow)
        ld a,b
        cp 24
        ld a,c
        jr c,$+6
          ld b,0
          add a,6
        cp 3Bh
        jr c,$+8
          sub 3Ch
          jr nc,$+4
            add a,6
        ld c,a
        inc b
        ld (textRow),bc
        dec b
        ld hl,(FontPointer)
        pop af
;===============================================================
PutFS:
;===============================================================
        push bc
        push hl
        ld b,0
        ld c,a
        ld h,b
        ld l,c
        add hl,hl
        add hl,bc
        pop de
        add hl,de
        pop bc
        push hl
        ld a,b
        ld b,0
        ld h,b
        ld l,c
        add hl,hl
        add hl,bc
        add hl,hl
        add hl,hl
        rra
        push af
        ld c,a
        add hl,bc
        ld bc,(BufPtr)
        add hl,bc
        ld bc,060Ch
;==========================================
;Added in for slow text
        bit 0,(iy+33)
        jr z,SkipSlow
        push bc \ push hl
        call GraphToLCD
        pop hl \ pop bc
        ld a,(TextPauseTime)
;        bit 1,(iy+33)
;        jr nz,$+3
        ei
        halt \ dec a
        jr nz,$-2
        di
SkipSlow:
;==========================================
        pop af
        pop de
        jr c,PutRight
;===============================================================
PutLeft:
;===============================================================
        ld a,(hl)
        and 0Fh
        ld (hl),a
        ld a,(de)
        bit 0,(iy+34)
        jr z,$+3
        cpl
        bit 0,b
        jr z,$+7
          rlca \ rlca \ rlca \ rlca
          inc de
        and $F0
        or (hl)
        ld (hl),a
        ld a,b
        ld b,0
        add hl,bc
        ld b,a
        djnz PutLeft
        ret
;===============================================================
PutRight:
;===============================================================
        ld a,(hl)
        and $F0
        ld (hl),a
        ld a,(de)
        bit 0,(iy+34)
        jr z,$+3
        cpl
        bit 0,b
        jr nz,$+7
          rlca \ rlca \ rlca \ rlca
          dec de
        inc de
        and 0Fh
        or (hl)
        ld (hl),a
        ld a,b
        ld b,0
        add hl,bc
        ld b,a
        djnz PutRight
        ret
SqrtHL:
;Inputs:
;     HL is the number to find the square root of
;Outputs:
;      A is the square root, rounded down
;     BC is the rounded square root
;     DE is the remainder. In other words, HL-A^2
;     HL is 0
;Size  : 45 bytes
;Speed : 1370-2x where x is the number of bits in the result. 
;        +4 if it rounds up
;        +4 if it rounds to a value <128
;        The speed ranges from 1356 to 1378 cycles.
;===============================================================
     ld b,8           ; 7      7
     xor a            ; 4      4
     ld d,a           ; 4      4
     ld e,a           ; 4      4
sqrt16Loop:           ;
     add hl,hl        ;11     88
     rl e             ; 8     64
     rl d             ; 8     64
     add hl,hl        ;11     88
     rl e             ; 8     64
     rl d             ; 8     64
     rla              ; 4     32
     push hl          ;11     88
     ld h,0           ; 7     56
     ld l,a           ; 4     32
     add hl,hl        ;11     88
     inc l            ; 4     32
     ex de,hl         ; 4     32
     sbc hl,de        ;15    120
     jr c,$+6         ;23|21 184-2x
       inc a          ;--
       jp $+4         ;--  2 cycles faster than jr
       add hl,de      ;--
     ex de,hl         ; 4     32
     pop hl           ;10     80
     djnz sqrt16Loop  ;13|8   99
     ld c,a
     dec d
     inc d
     jr nz,$+4
       cp e
       ret nc
     inc c
     ret              ;10     10
;===============================================================
FontSet:
;===============================================================
;00~7F
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$8C,$EC,$80,$00,$00,$00,$00,$00,$00
.db $24,$44,$20,$0A,$4A,$00,$00,$EA,$E0,$00,$4E,$40,$00,$04,$00,$00,$E4,$44,$E4,$2C,$00,$EC,$EC,$C0

.db $65,$5C,$40,$62,$A2,$00,$C2,$4E,$00,$02,$48,$E0,$69,$96,$00,$AC,$88,$00,$E4,$40,$00,$68,$60,$E0
.db $2E,$4E,$80,$C2,$C0,$E0,$06,$00,$00,$E8,$C8,$E0,$42,$F2,$40,$AD,$DD,$A0,$4E,$44,$40,$44,$4E,$40

.db $00,$00,$00,$44,$40,$40,$AA,$A0,$00,$00,$00,$00,$00,$00,$00,$A2,$48,$A0,$4A,$4A,$50,$88,$80,$00
.db $24,$44,$20,$84,$44,$80,$00,$40,$00,$04,$E4,$00,$00,$44,$80,$00,$E0,$00,$00,$00,$80,$22,$48,$80

;FontNumbers
.db $4A,$AA,$40,$4C,$44,$E0,$C2,$48,$E0,$C2,$42,$C0,$AA,$E2,$20,$E8,$C2,$C0,$68,$EA,$E0,$E2,$44,$40,$EA,$EA,$E0,$EA,$E2,$20

;3Ah~3Fh
.db $04,$04,$00,$04,$04,$80,$24,$84,$20,$0E,$0E,$00,$84,$24,$80,$C2,$40,$40

.db $00,$00,$00,$4A,$EA,$A0,$CA,$CA,$C0,$68,$88,$60,$CA,$AA,$C0,$E8,$C8,$E0,$E8,$C8,$80,$68,$AA,$60
.db $AA,$EA,$A0,$E4,$44,$E0,$62,$2A,$40,$AA,$CA,$A0,$88,$88,$E0,$AE,$AA,$A0,$CA,$AA,$A0,$EA,$AA,$E0
.db $CA,$C8,$80,$EA,$AE,$60,$CA,$CA,$A0,$68,$42,$C0,$E4,$44,$40,$AA,$AA,$E0,$AA,$AA,$40,$AA,$AE,$A0
.db $AA,$4A,$A0,$AA,$44,$40,$E2,$48,$E0,$4A,$EA,$40,$88,$42,$20,$C4,$44,$C0,$4A,$00,$00,$00,$00,$E0
.db $84,$00,$00,$06,$AA,$60,$88,$CA,$C0,$06,$88,$60,$22,$6A,$60,$04,$AC,$60,$48,$C8,$80,$06,$A6,$2C
.db $88,$CA,$A0,$40,$44,$40,$20,$22,$A4,$8A,$CA,$A0,$88,$88,$40,$0A,$EA,$A0,$0C,$AA,$A0,$04,$AA,$40
.db $0C,$AC,$80,$06,$A6,$22,$0A,$C8,$80,$0C,$84,$C0,$4E,$44,$20,$0A,$AA,$E0,$0A,$AA,$40,$0A,$AE,$A0
.db $0A,$44,$A0,$0A,$A6,$24,$0E,$24,$E0,$64,$84,$60,$44,$44,$40,$C4,$24,$C0,$05,$A0,$00,$E0,$E0,$E0

;FontNumbers2
.db $04,$AA,$A4,$04,$C4,$4E,$0C,$24,$8E,$0C,$24,$2C,$0A,$AE,$22,$0E,$8C,$2C,$06,$8E,$AE,$0E,$24,$44
.db $0E,$AE,$AE,$0E,$AE,$22

;Accented A
.db $24,$AE,$A0,$84,$AE,$A0,$00,$00,$00,$A4,$AE,$A0

;Accented a
.db $24,$06,$A5,$42,$06,$A5,$4A,$06,$A5,$A0,$6A,$60

;Accented E
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

;Accented e
.db $48,$4A,$C6,$42,$4A,$C6,$4A,$4A,$C6,$A0,$4A,$C6

;Accented I
.db $24,$0E,$4E,$84,$0E,$4E,$4A,$0E,$4E,$A0,$E4,$E0

;Accented i
.db $24,$04,$44,$84,$04,$44,$4A,$04,$44,$A0,$44,$40

;Bombs... er, accented O
.db $24,$69,$96,$84,$69,$96,$4A,$69,$96,$A0,$69,$96

;Lowercase bombs
.db $24,$06,$96,$84,$06,$96,$4A,$06,$96,$A0,$06,$96

;Accented U
.db $24,$AA,$A6,$84,$AA,$A6,$4A,$AA,$A6,$A0,$AA,$A6

;Accented u
.db $24,$0A,$A6,$84,$0A,$A6,$4A,$0A,$A6,$A0,$0A,$A6

;Accented C,c,N,n
.db $4A,$8A,$48,$06,$88,$6C,$5A,$0C,$AA,$5A,$0C,$AA

;Other Puntuation
.db $24,$00,$00,$84,$00,$00,$A0,$00,$00,$40,$48,$60

;Upside-Down Exclamation Point Identical to lowercase i
;Change to something else?
.db $00,$00,$00

;Greek
.db $05,$AA,$50,$25,$65,$A0,$05,$A2,$20,$00,$4A,$E0,$34,$27,$96,$68,$E8,$60

;[
.db $64,$44,$60

;Greek (continued)
.db $84,$25,$90,$0A,$AD,$80,$0F,$55,$90,$25,$56,$48,$F4,$24,$F0
.db $07,$55,$40,$07,$A2,$10
;Idunno howta do these
.db $4E,$AE,$40,$69,$99,$69

;CC~CF
.db $E0,$A4,$A0,$E0,$A6,$24,$52,$50,$00,$00,$00,$A0,$26,$E6,$20

;D0~D5
.db $44,$40,$00,$22,$48,$80,$00,$60,$00,$C4,$8C,$00,$EA,$E0,$00,$E4,$2C,$00

;D6
.db $00,$00,$00

;D7~DF
.db $40,$44,$20,$04,$CA,$C8,$8A,$4A,$20,$E9,$AE,$A8,$69,$E8,$60,$00,$44,$60,$9D,$FB,$90,$A5,$55,$A0,$4E,$FE,$40

;Overwrite Cursor
.db $FF,$FF,$FF,$FB,$1B,$BF,$FB,$51,$5F,$FF,$95,$9F

;Insert Cursor
.db $00,$00,$0F,$4E,$EE,$0F,$4A,$EA,$0F,$06,$A6,$0F

;E8~EF
.db $00,$84,$20,$00,$C6,$20,$00,$E6,$20,$00,$8C,$E0,$25,$D5,$20,$4A,$AA,$40,$4E,$44,$40

;F0~F4
.db $44,$4E,$40,$5A,$5A,$5A,$27,$A6,$3E,$4E,$44,$00,$69,$A9,$A0

;male/female
.db $73,$5E,$AE,$EA,$E4,$E4

;BlockEater Down	$F7
.db $6F,$96,$90
;BlockEater Left        $F8
.db $6F,$16,$90
;BlockEater Right       $F9
.db $6F,$86,$90
;BlockEater Up          $FA
.db $69,$96,$90

;FB~FE
.db $09,$AC,$E0,$08,$53,$70,$EC,$A1,$00,$73,$58,$00

;FF
.db $A5,$A5,$A5
;===============================================================
vFont:
;===============================================================
.db $01,$00,$80,$01,$00,$00,$01,$00,$00,$01,$00,$00,$04,$05,$00,$00,$00,$00,$01,$00,$00,$01,$00,$00
.db $08,$03,$40,$80,$80,$80,$80,$80,$40,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00
.db $00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00
.db $00,$01,$00,$00,$01,$00,$00,$08,$06,$00,$10,$F8,$20,$F8,$40,$00,$00,$01,$00,$00,$08,$04,$00,$00
.db $00,$E0,$00,$00,$00,$00,$01,$00,$00,$08,$06,$00,$20,$10,$F8,$10,$20,$00,$00,$01,$00,$00,$01,$00
.db $00,$01,$00,$00,$08,$05,$00,$00,$00,$00,$00,$00,$00,$00,$08,$03,$40,$40,$40,$40,$40,$00,$40,$00
.db $08,$05,$50,$50,$50,$00,$00,$00,$00,$00,$01,$00,$00,$01,$00,$00,$08,$04,$A0,$20,$20,$40,$80,$80
.db $A0,$00,$01,$00,$00,$08,$02,$00,$80,$80,$80,$00,$00,$00,$00,$08,$03,$40,$80,$80,$80,$80,$80,$40
.db $00,$08,$03,$80,$40,$40,$40,$40,$40,$80,$00,$01,$00,$00,$01,$00,$00,$08,$03,$00,$00,$00,$00,$00
.db $40,$40,$80,$08,$05,$00,$00,$00,$00,$F0,$00,$00,$00,$08,$02,$00,$00,$00,$00,$00,$00,$80,$00,$08
.db $04,$20,$20,$20,$40,$80,$80,$80,$00,$08,$06,$70,$88,$98,$A8,$C8,$88,$70,$00,$08,$04,$40,$C0,$40
.db $40,$40,$40,$E0,$00,$08,$05,$60,$90,$10,$20,$40,$80,$F0,$00,$08,$05,$60,$90,$10,$20,$10,$90,$60
.db $00,$08,$06,$10,$30,$50,$90,$F8,$10,$10,$00,$08,$05,$F0,$80,$E0,$10,$10,$90,$60,$00,$08,$05,$30
.db $40,$80,$E0,$90,$90,$60,$00,$08,$05,$F0,$10,$20,$20,$20,$20,$20,$00,$08,$05,$60,$90,$90,$60,$90
.db $90,$60,$00,$08,$05,$60,$90,$90,$70,$10,$20,$40,$00,$08,$02,$00,$80,$00,$00,$00,$80,$00,$00,$08
.db $03,$00,$40,$00,$00,$00,$40,$80,$00,$08,$05,$10,$20,$40,$80,$40,$20,$10,$00,$08,$05,$00,$00,$F0
.db $00,$F0,$00,$00,$00,$08,$05,$80,$40,$20,$10,$20,$40,$80,$00,$08,$05,$60,$90,$10,$20,$20,$00,$20
.db $00,$08,$08,$7E,$81,$99,$A5,$9E,$00,$00,$00,$08,$05,$60,$90,$90,$F0,$90,$90,$90,$00,$08,$05,$E0
.db $90,$90,$E0,$90,$90,$E0,$00,$08,$05,$60,$90,$80,$80,$80,$90,$60,$00,$08,$05,$E0,$90,$90,$90,$90
.db $90,$E0,$00,$08,$05,$F0,$80,$80,$E0,$80,$80,$F0,$00,$08,$05,$F0,$80,$80,$E0,$80,$80,$80,$00,$08
.db $05,$60,$90,$80,$80,$B0,$90,$60,$00,$08,$05,$90,$90,$90,$F0,$90,$90,$90,$00,$08,$04,$E0,$40,$40
.db $40,$40,$40,$E0,$00,$08,$05,$70,$20,$20,$20,$20,$A0,$40,$00,$08,$05,$90,$90,$A0,$C0,$A0,$90,$90
.db $00,$08,$05,$80,$80,$80,$80,$80,$80,$F0,$00,$08,$06,$88,$D8,$A8,$88,$88,$88,$88,$00,$08,$05,$90
.db $D0,$D0,$B0,$B0,$90,$90,$00,$08,$05,$60,$90,$90,$90,$90,$90,$60,$00,$08,$05,$E0,$90,$90,$E0,$80
.db $80,$80,$00,$08,$05,$60,$90,$90,$90,$90,$60,$30,$00,$08,$05,$E0,$90,$90,$E0,$90,$90,$90,$00,$08
.db $05,$60,$90,$80,$60,$10,$90,$60,$00,$08,$04,$E0,$40,$40,$40,$40,$40,$40,$00,$08,$05,$90,$90,$90
.db $90,$90,$90,$60,$00,$08,$04,$A0,$A0,$A0,$A0,$A0,$A0,$40,$00,$08,$06,$88,$88,$88,$88,$A8,$A8,$50
.db $00,$08,$04,$A0,$A0,$A0,$40,$A0,$A0,$A0,$00,$08,$05,$90,$90,$90,$70,$10,$10,$60,$00,$08,$06,$F8
.db $08,$10,$20,$40,$80,$F8,$00,$08,$05,$60,$D0,$90,$F0,$90,$B0,$60,$00,$08,$04,$80,$80,$80,$40,$20
.db $20,$20,$00,$08,$03,$C0,$40,$40,$40,$40,$40,$C0,$00,$08,$06,$00,$20,$50,$88,$00,$00,$00,$00,$08
.db $05,$00,$00,$00,$00,$00,$00,$00,$F0,$08,$03,$80,$40,$00,$00,$00,$00,$00,$00,$08,$05,$00,$00,$60
.db $A0,$A0,$A0,$50,$00,$08,$05,$80,$80,$80,$E0,$90,$90,$E0,$00,$08,$05,$00,$00,$60,$90,$80,$90,$60
.db $00,$08,$05,$10,$10,$10,$70,$90,$90,$70,$00,$08,$05,$00,$00,$60,$90,$F0,$80,$60,$00,$08,$05,$00
.db $60,$90,$80,$C0,$80,$80,$00,$08,$05,$00,$00,$00,$70,$90,$70,$10,$60,$08,$05,$80,$80,$80,$E0,$90
.db $90,$90,$00,$08,$02,$00,$00,$80,$00,$80,$80,$80,$00,$08,$04,$00,$00,$20,$00,$20,$20,$A0,$40,$08
.db $04,$00,$80,$80,$A0,$C0,$A0,$A0,$00,$08,$03,$00,$80,$80,$80,$80,$80,$40,$00,$08,$04,$00,$00,$A0
.db $E0,$A0,$A0,$A0,$00,$08,$05,$00,$00,$A0,$D0,$90,$90,$90,$00,$08,$05,$00,$00,$60,$90,$90,$90,$60
.db $00,$08,$04,$00,$00,$00,$E0,$90,$E0,$80,$80,$08,$05,$00,$00,$60,$A0,$60,$20,$20,$10,$08,$05,$00
.db $00,$A0,$D0,$80,$80,$80,$00,$08,$04,$00,$00,$60,$80,$40,$20,$C0,$00,$08,$04,$00,$40,$40,$E0,$40
.db $40,$20,$00,$08,$05,$00,$00,$90,$90,$90,$90,$60,$00,$08,$04,$00,$00,$A0,$A0,$A0,$A0,$40,$00,$08
.db $04,$00,$00,$A0,$A0,$A0,$E0,$A0,$00,$08,$04,$00,$00,$A0,$A0,$40,$A0,$A0,$00,$08,$05,$00,$00,$90
.db $90,$70,$10,$10,$60,$08,$05,$00,$00,$00,$F0,$20,$40,$F0,$00,$08,$04,$20,$40,$40,$80,$40,$40,$20
.db $00,$08,$02,$80,$80,$80,$80,$80,$80,$80,$00,$08,$04,$80,$40,$40,$20,$40,$40,$80,$00,$08,$05,$50
.db $A0,$00,$00,$00,$00,$00,$00,$08,$05,$00,$F0,$00,$F0,$00,$F0,$00,$00,$01,$00,$00,$01,$00,$00,$01
.db $00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01
.db $00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01
.db $00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01
.db $00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01
.db $00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01
.db $00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$08
.db $05,$60,$90,$80,$80,$80,$90,$60,$C0,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00
.db $01,$00,$00,$08,$05,$40,$00,$40,$40,$80,$90,$60,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00
.db $00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$08,$03,$C0,$80,$80,$80,$80,$80,$C0,$00,$01,$00,$00,$01
.db $00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01
.db $00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$08,$04,$20,$20,$20,$40,$80
.db $80,$80,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$08,$04,$00,$80,$00,$80
.db $80,$A0,$40,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00
.db $00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00
.db $00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$01,$00
.db $00,$01,$00,$00,$08,$05,$50,$A0,$50,$A0,$50,$A0,$50,$00,$01,$00,$00,$01,$00,$00,$01,$00,$00,$08
.db $09,$00,$0E,$06,$0A,$70,$90,$90,$60,$08,$08,$38,$44,$44,$44,$38,$10,$38,$10,$05,$05,$70,$F8,$88
.db $70,$88,$05,$05,$70,$F8,$08,$70,$88,$05,$05,$70,$F8,$80,$70,$88,$05,$05,$70,$F8,$F8,$70,$88,$04
.db $04,$10,$A0,$C0,$E0,$04,$04,$80,$50,$30,$70,$04,$04,$E0,$C0,$A0,$10,$04,$04,$70,$30,$50,$80,$08
.db $04,$A0,$50,$A0,$50,$A0,$50,$A0,$00,$01,$00,$00,$01,$00,$00
;===============================================================
FastCircle:
;===============================================================
     ld l,a
     ld h,-1
     ld (TempWord1),hl
Circle:
;===============================================================
;Input:
;     D = center_x
;     E = center_y
;     C = radius
;     A = method
;Outputs:
;===============================================================
      di
      ld a,c
      or a \ ret z
      ret m
      ld h,c     ;h is radius
      ld l,0
      ld a,c
      ld b,-1
      ld (TempWord3),de
; jr $
DrawLoop:
      ex af,af'
      ld a,(TempWord1+1)
      rlca
      ld (TempWord1+1),a
      jr c,$+8
      call Plot4Pix
      call Plot4Pix
      ex af,af'
      inc l
      inc b \ inc b
      sub b
      dec a
      jp p,$+7      ;sign flag reset
        add a,c
        add a,c
        dec h
        inc b      
      inc a
      ld d,a      
      ld a,h \ sub l
      ld a,d
      jr c,DrawLoop
      ret
Plot4Pix:
      ld de,(TempWord3)
      ld a,h \ ld h,l \ ld l,a
      ld a,d \ add a,h \ ld d,a
      ld a,e \ add a,l \ ld e,a
      call PixelSet
      push de
      ld a,d \ sub h \ sub h \ ld d,a
      call PixelSet
      ld a,e \ sub l \ sub l \ ld e,a
      call PixelSet
      pop de
      ld a,e \ sub l \ sub l \ ld e,a
PixelSet:
;     DE = (x,y)
        ld a,(TempWord1)
        push de
        exx
        pop bc
        ld d,a
        call PlotPixel
        exx
        ret
SetMem:
        ld (hl),a
        cpi
        jp pe,SetMem
        ret
;=================================================================
ConvNumBase:
;=================================================================
;Inputs:
;     C is the base to convert to
;     HL is the number to convert
;Output:
;     A is the number of digits
;     BC is the number of digits
;     DE is 0
;     HL points to the number string
;Notes:
;     This converts HL to a zero terminated string stored in OP4
;     and possibly a few bytes of OP3.
;=================================================================
        xor a
        ld de,84A3h
        ld (de),a
        dec de
          call HL_Div_C
          cp 10
          jr c,$+4
            add a,7
          add a,48
          ld (de),a
          dec de
          ld a,h
          or l
          jr nz,$-15
        ld a,$A2
        sub e
        ld c,a
        inc de
        ex de,hl
        ret
PrimeTest:
     ld de,PrimeNumbers
     bit 0,l
     jr nz,$+10
       ld bc,2
       srl h \ rr l
       ret
     ld bc,3501h
PrimeTestLoop:
     push hl
     push bc
     ld a,(de)
     ld c,a
     call HL_Div_C
     or a \ jr nz,$+5
       pop af \ pop af \ ret
     pop bc \ pop hl
     inc de
     djnz PrimeTestLoop
     scf
     push hl \ push bc
     pop hl \ pop bc
     ret
;=================================================================
HL_Div_C:
;=================================================================
;Inputs:
;     HL is the numerator
;     C is the denominator
;Outputs:
;     A is the remainder
;     B is 0
;     C is not changed
;     DE is not changed
;     HL is the quotient
;=================================================================
       ld b,16
       xor a
         add hl,hl
         rla
         cp c
         jr c,$+4
           inc l
           sub c
         djnz $-7
       ret
;===============================================================
Is_2_Byte:
;===============================================================
          sub $EF \ ret z        ;ef
          add a,34h \ ret z      ;bb
          add a,3Dh \ ret z      ;7E
Is_Var_Name:
;Before calling this, add 82h to a
          sub 2Ch \ ret z        ;AA
          add a,47h \ ret z      ;63
          inc a \ ret z
          inc a \ ret z
          inc a \ ret z
          add a,2 \ ret z
          inc a \ ret z
          inc a \ ret
;===============================================================
DrawLine:
;===============================================================
diaglineflag   equ 6

;     HL is (x1,y1)
;     DE is (x2,y2)

; B=D-H    ;This is the counter
; C=2(D-H) ;This is the counter reset
 di
     ld (TempWord1+1),a
     ld a,e
     or a
     ret m
     ld a,h
     or a
     ret m
     ld a,l
     or a
     ret m

     ld a,d
     or a
     ret m

     sub h
     jp z,VertLine
     jr nc,$+5
       ex de,hl
       neg
     ld b,a
     add a,a
     ld c,a
     res diaglineflag,(iy+35)
;Doesn't use D or E after finding this info
;E=2(E-L)
     ld a,e
     sub l
     jr nc,$+8
       set diaglineflag,(iy+35)
       neg
     add a,a
;swap a,b
     push bc
     ld b,a
     push bc
     push de
     push hl
     ld b,h
     ld c,l
     call GetPixelLoc
     ld de,(TempWord1)
     ld e,a
     ld bc,12
     bit diaglineflag,(iy+35)
     jr z,$+5
     ld bc,-12
     exx
     pop hl
     pop de
     pop bc
     pop af
     
;Now go from H to D
     ccf

DrawLinePixel:
     call c,DrawPixHL
     inc h
     ex af,af'
     exx
     rrc e
     jr nc,$+3
     inc hl
     exx
     ld a,d
     sub h
     ret c
     ex af,af'
     sub b
     ccf
     jr c,DrawLinePixel       ;Could save size by going to LineLoop2
FixX:
;     bit diaglineflag,(iy+35)
;     jr nz,DrawDn
;       inc l
       exx
       add hl,bc
       exx
;       jp DrawUp
;DrawDn:
;       dec l
;       exx
;       add hl,de
;       exx
DrawUp:
     add a,c
     jr c,DrawLinePixel
     call DrawPixHL
     jp FixX
VertLine:
;     HL is (x1,y1)
;     DE is (x2,y2)
     ld a,h
     cp 96
     ret nc
     ld b,h
     ld a,l
     cp 64
     ret nc
     sub e
     jr c,$+3
     ex de,hl
     ld a,e
     cp 64
     jr c,$+4
       ld e,63
     ld a,l
     cp 64
     jr c,$+3
       xor a
     ld c,a
     sub e
     neg
     inc a
     ld de,(TempWord1)
     ld e,a
     call GetPixelLoc
     ld c,a
     ld b,e
     ld e,12
;B is the height
;HL points to a byte
;C is the mask
;E is 12
;D is the draw method
     dec d
     jr nz,$+9
       ld a,(hl)
       or c
       ld (hl),a
       add hl,de
       djnz $-4
       ret
     dec d
     jr nz,$+9
       ld a,(hl)
       xor c
       ld (hl),a
       add hl,de
       djnz $-4
       ret
     ld d,0
     ld a,c
     cpl
     ld c,a
     ld a,(hl)
     and c
     ld (hl),a
     add hl,de
     djnz $-4
     ret
DrawPixHL:
     ex af,af'
     ld a,h
     cp 96
     jr nc,ExtDrPixHL
     ld a,l
     cp 64
     jr nc,ExtDrPixHL
     exx
     ld b,d
     ld a,(hl)
     djnz $+3
     or e
     djnz $+3
     xor e
     djnz $+3
     and e
     ld (hl),a
     ld b,0
     ld a,c
     cp 12
     jr z,$+3
     dec b
     exx
ExtDrPixHL:
     ex af,af'
     ret
RAMCode:
SetLinePixCode:
;	push	af			; Saving A
;	ld	a,(ix+0)
;        cpl
;	xor	c			; Writing pixel to current position
;	nop
;	ld	(ix+0),a
;	pop	af			; Recalling A
;        ret
IncHLmem1Data:
IncHLMem1       equ IncHLmem1Data-RAMCode+SetLinePix
;                   speed    1 page         total
;
     inc l         ;    4    4*16384        65536
     ret nz        ;11| 5    64*5+16320*11  179840
     inc h         ;    4    4*64           256
     ret po        ;11| 5    11*63+5        698
     ld a,h
     in a,(6)      ;   11    11             11
     inc a         ;    4    4              4
     out (6),a     ;   11    11             11
     ld a,h
     ld h,40h      ;    7    7              7
     ret           ;   10    10             10
RamCodeEnd:
;=============================================================================
Conv_OP1:
     ld hl,8478h
ConvDecAtHL:
;Inputs:
;     HL points to the FP number to convert
;Outputs:
;      A is the 8-bit result
;      B is 0
;      C is the value of the last digit
;     DE is the 16-bit result
;     HL is incremented by 9
;Destroys:
     ex de,hl
     ld hl,9
     add hl,de
     push de
     ex de,hl
     ld a,(hl)
     and 80h
     push af
     inc hl
     ld a,(hl)
     sub 80h
     ld de,0
     jr nc,$+17
       ld c,e
       ld b,e
ConvDone:
       pop af
       jr z,$+9
         ld a,e \ cpl \ ld e,a
         ld a,d \ cpl \ ld d,a
         inc de
       pop hl
       ld a,e
       ret
     ld b,a
     inc b
     inc hl
     ld a,(hl)
ConvDecLoop:
     rlca
     rlca
     rlca
     rlca
     push hl
     ld h,d
     ld l,e
     add hl,hl
     add hl,hl
     add hl,de
     add hl,hl
     ex de,hl
     pop hl
     and 15
     add a,e
     ld e,a
     jr nc,$+3
     inc d
     dec b
     jr z,ConvDone
     bit 0,b
     ld a,(hl)
     jr nz,ConvDecLoop+4
     inc hl
     jp ConvDecLoop
GetPixelLoc:
;Input:
;     b is X
;     c is y
;Output:
;     HL points to byte
;     A is the mask
;     nc if not computed, c if computed
       ld a,c
       cp 64 \ ret nc
       ld a,b
       cp 96 \ ret nc
       ld l,c
       ld h,0
       ld b,h
       add hl,hl
       add hl,bc
       add hl,hl
       add hl,hl
       ld b,a
       rrca \ rrca \ rrca
       and 0Fh
       ld c,a
       ld a,b
       ld b,0
       add hl,bc
       ld bc,(BufPtr)
       add hl,bc
       and 7
       ld b,a
       inc b
       ld a,1
         rrca
         djnz $-1
       scf
       ret
ConvHexTo86ECh:
;168x+73 cycles (at most) :D
;154x+31 cycles at least
;An 8x8 sprite now takes 1263~1417 cycles to convert
       ld d,b
       ld e,c
       ld hl,86ECh
ConvHexLoop7:
;     HL points to where to convert
;     DE is where to convert from
        ld a,(de)
        inc de
        cp 47h
        ret nc
        cp 40h
        jr nc,$+7
        cp 3Ah
        ret nc
        jr $+4
        sub 7
        rld

        ld a,(de)
        inc de
        cp 47h
        ret nc
        cp 40h
        jr nc,$+7
        cp 3Ah
        ret nc
        jr $+4
        sub 7
        rld
        inc hl
        jp ConvHexLoop7
HexTok:
       call GetHexAtDE
       call GetHexAtDE
       cpi
       jp pe,HexTok
       ret
GetHexAtDE:
       ld a,(de)
       cp 3Ah
       jr c,$+4
         sub 7
       inc de
       rld
       ret

;interrupt:
;     exx \ ex af,af'
;     push af
;     push bc
;     push de
;     push hl
;;     xor a \ out (3),a
;     set 1,(iy+33)
;     ld hl,(progPtr)
;     push hl
;     .db 21h                ;first byte of ld hl,**
;IprogPtr:
;     .dw 0
;     ld a,h \ or l
;     jr z,EndExec
;       ld (progPtr),hl
;       ld (IprogPtr2-interrupt+interruptLoc),hl
;       sbc hl,hl \ ld (IprogPtr-interrupt+interruptLoc),hl
;       call ParserNext
;       .db 21h              ;first byte of ld hl,**
;IprogPtr2:
;       .dw 0
;       ld (IprogPtr-interrupt+interruptLoc),hl
;EndExec:
;;     bit 3,(iy+33)
;;     jr z,CursorDone
;;       
;CursorDone:
;     pop hl
;     ld (progPtr),hl
;     pop hl
;     pop de
;     pop bc
;     res 1,(iy+33)
;;     ld a,intmask \ out (3),a
;     pop af
;     jp 3Ah
;     ex af,af'
;     exx
;     ei
;     ret
;interrupt_end:
IsConditional:
     cp $D8 \ ret z      ;pause
     cp $CE \ ret z      ;if
     cp $D1 \ ret z      ;while
     cp $D2 \ ret        ;repeat
SetUpData:
;===================================
;Set interrupt up
;===================================
;     di
;     bcall(4A20h)
;     ld hl,interrupt
;     ld de,interruptLoc
;     ld bc,interrupt_end - interrupt
;     ldir
;
;     ld hl,8000h
;     ld de,8001h
;     ld bc,256
;     ld (hl),8Ah
;     ldir
;;     ld a,intmask \ out (3),a
;     ld a,80h
;     ld i,a
;     im 2
;     xor a
;=================================
        bcall(4570h)
        ld a,r \ ld h,a
        ld a,r \ ld l,a
        ld a,r \ add a,l \ ld l,a
        ld a,r \ adc a,h \ ld h,a
        LD (randSeed),hl
        ld de,SetLinePix
        ld bc,RAMCodeEnd-SetLinePixCode
        ld hl,SetLinePixCode
        ldir
        ld hl,GraphBuf \ ld (BufPtr),hl
        ld (GrayBufPtr),hl
        ld hl,PBuf
        ld (PBufPtr),hl
        ld hl,766
        ld (PBuf),hl
        ld a,3
        ld (OutputLogic),a
        ld (TextPauseTime),a
        pop hl
        ld (SPSave),sp      ;ED738698
        push hl
        ld hl,FontSet       ;21****
        ld (FontPointer),hl ;228A98
        ld hl,0
        ld (8A11h),hl
        ld (8A12h),hl
        ld (8000h),hl
        ld (8006h),hl
        ld (800Bh),hl
        ld hl,5555h
        ld (GrayMask),hl
        ret
CompatCall:
        ld de,SetLinePix
        ld bc,RAMCodeEnd-SetLinePixCode
        ld hl,SetLinePixCode
        ldir
        jp IsOP1GrammerProg
EraseParticle:
       ld c,(hl) \ inc hl
       ld b,(hl)
;pixel off       
       push bc
       call GetPixelLoc
;       ld b,a
;       jr nc,$+5
;       cpl \ and (hl) \ ld (hl),a
;       ld a,b
       pop bc
       ret
;===============================================================
TokenSet:
;===============================================================
LoadTSA:
        di
        push af \ push bc \ push de \ push hl
        push ix \ pop hl
        ld c,(hl) \ inc hl
        ld b,(hl) \ inc hl
        ld de,TSA
        ldir
        pop hl \ pop de \ pop bc
;        bit 1,(iy+33)
;        jr nz,$+3
;          ei
        pop af
        ret
IsOP1GrammerProg:
        ld hl,GramHeader
IsOP1HeaderMatch:
;Inputs:
;     OP1 is the name of the program
;     HL points to the null terminated header code (up to 11 bytes) to compare to
;Outputs:
;      A is the flash page the data is on
;     BC is the size of the program
;     HL points to the data
;     z is set if the header matches
;     nz if it isn't
        ld (TempWord2),hl
        ld ix,ReadArcData
        call LoadTSA
;        call OP1NameLength
;        push hl
        call FindVar
        ld a,b
;       pop bc
        ld b,0
        ld (TempWord3),a
        ex de,hl
        or a \ jr nz,GetArchSize
          ld c,(hl) \ inc hl
          ld b,(hl) \ inc hl \ push bc
          ld (TempWord4),bc
          ld (TempWord5),hl
          ld de,9670h \ push de \ ld bc,126
          ldir \ pop hl \ pop bc
          jr CheckHeader
GetArchSize:
;        push af
;        in a,(6) \ ld (TempWord1+1),a
;        pop af
        add hl,bc
        ld c,10
        add hl,bc
;        out (6),a
        bit 7,h
        jr z,$+7
         res 7,h \ set 6,h
         inc a
;        call nz,IncHLMem1+4
        ld de,966Eh
        ld bc,128
        push de
        push hl
        call TSA
        pop hl \ inc hl \ inc hl
        ld (TempWord5),hl
        pop de \ ex de,hl
        ld c,(hl) \ inc hl
        ld b,(hl) \ inc hl
        ld (TempWord4),bc
CheckHeader:
        ld de,(TempWord2)
;HL points to header data
;DE points to compare header
;BC is size of the var
        push af
        push bc
        ld bc,126
   ld a,(de)
   or a
   jr z,NotHeader-1
   inc e
   cpi
   jr nz,NotHeader-1
   jp pe,$-9
   pop bc
NotHeader:
        pop hl
        ld a,h
        ex de,hl
;z flag set if it is a Grammer Program
        ret
ReadArc:
        ld ix,ReadArcData
        call LoadTSA
        jp TSA
ReadArcData:
     .dw ReadArcEnd-ReadArc-2
     or a
     jr nz,$+5
       ldir
       ret
     push af \ in a,(6)
     ld (TempWord1),a
     pop af
     out (6),a
ArcReadLoop        equ $-ReadArcData+TSA+2
     dec hl
     call IncHLmem1
     ldi
     jp pe,ArcReadLoop
     push af
     ld a,(TempWord1)
     out (6),a
     pop af
     ret
ReadArcEnd:
FindGVarData:
     ld hl,GVarData
     rst 20h
     call FindVar
     ret nc
     ld hl,3 \ bcall(4E6Ah)
     ret
GrammerHook:
     .db 83h
; jr $ 
     or a
     jr z,$+4
ExitHook3:
       xor a \ ret
     push hl
;     push bc
     ld hl,(8478h)
     ld bc,2305h
     or a
     sbc hl,bc
;     pop bc
     pop hl
     jr nz,ExitHook3
     push hl
     push de
     push bc
     push af
     di
     bcall(4A20h)
     ld hl,2305h
     xor a \ ld (847Ah),a
     ld (8478h),hl
     call FindVar
     ex de,hl
     ld c,(hl) \ inc hl
     ld b,(hl) \ inc hl
     ld a,b \ or c
     ld de,8478h
     jr nz,$+8
       pop hl \ pop hl \ pop hl \ pop hl
       jr ExitHook3
     ldir \ xor a
     ld (de),a
;     ld hl,9652h
     ld a,5 \ ld (8478h),a
     call SetUpData+4
     call IsOP1GrammerProg
     jr nz,EndHook

     ld hl,8478h
     ld de,8478h+44
     ld bc,9 \ ldir
     pop af
     pop bc
     pop de
     pop hl
     call SelectedProg
     or 1 \ ret
EndHook:
     ld hl,9670h             ;location of header
; ION =BB6DC918
; MOS =BB6DC901
; DCS7=BB6DAAC9
; Gram=BB6D55C9
     ld a,(hl) \ cp $BB \ jr nz,HookEnd
     inc hl \ ld a,(hl) \ cp $6D \ jr nz,HookEnd
     inc hl \ ld a,(hl) \ cp $C9 \ jr z,MOSIONErr
     ld a,55h
     cp (hl) \ jr nz,DCSErr
     inc hl \ ld a,(hl) \ cp $C9
HomeRunASM:
     ld hl,(TempWord5) \ ld bc,(TempWord4)
     jr nz,$+6
;===============================================================
     cpi \ cpi
     cpi \ cpi
     ld de,9D94h
     or a \ sbc hl,de
     add hl,de
     jr c,$+3
       add hl,bc
     push hl \ push bc
     ld h,b \ ld l,c
     bcall(42FDh)       ;EnoughMem
     jp c,ErrMEM
     ex de,hl
;HL # bytes
;DE addr
     ld de,9D95h
     push de
     bcall(42F7h)
     pop de \ pop bc \ pop hl
     ld a,(TempWord3)
     push de \ push bc
     call ReadArc
     ld hl,0
     add hl,sp
     ld (SPSave),hl
     call 9D95h
     pop de \ pop hl
;Delmem: HL address
;        DE # of bytes
     bcall(4357h)
;===============================================================
     or 1
     pop hl
     ld a,h
     pop bc
     pop de
     pop hl
     ret
HookEnd:
     xor a
     jr HookEnd-6
MOSIONErr:
     inc hl \ ld a,(hl) \ cp $30 \ jr nz,MirageErr
     ld de,StrION
     jr $+8
MirageErr:
     dec a \ jr nz,HomeRunASM
     ld de,StrMirage
     jp CustomError
DCSErr:
     rlca
     cp (hl) \ jr nz,HomeRunASM
     inc hl \ ld a,(hl) \ cp $C9 \ jr nz,HomeRunASM
     ld de,StrDCS
     jr DCSErr-3
EndHook2:
     .db 21h,$D3,6
     ld (8103h),hl
     ld a,$C9
     ld (8105h),a
     call FindGVarData
     ex de,hl
     ld e,(hl) \ inc hl
     ld d,(hl) \ inc hl
     ld a,(hl) \ ld h,a \ ld l,3Eh
     ld (8101h),hl \ ex de,hl
     pop af
     pop bc
     pop de
     ex (sp),hl
     jp 8101h
GetVarName:
     call ParseFullArg
     ld h,b
     ld l,c
     ld a,(hl) \ and 1Fh
     ld de,8478h
     sub 5 \ jp z,GetGrammerText+3
     dec a \ jp z,GetGrammerText+3
     sub 15 \ jp z,GetGrammerText+3
     dec a \ jp z,GetGrammerText+3
     ld bc,3
     ld d,h \ ld e,l
     add hl,bc
     cp a
     ret
GetVarInfo:
;Returns name in OP1
;A is the flashpage
;HL points to SymEntry
;DE points to size bytes
;BC is the length of the name (for use when finding archived data)
;nc if it exists
;z if it is in RAM
          call GetVarName
          ex de,hl
          ld de,8478h \ push bc
          ldir
          xor a \ ld (de),a
          call FindVar
          ld a,b \ pop bc
          ret c
          or a
          ret
GetvarInfo2:
;Inputs:
;     The next argument to parse points to the name of the var to get info about
;Outputs:
;     A is the ending page (start of data)
;     BC is the size of the var
;     DE points to the SymEntry
;     HL points to the data
;     c is set if the var does not exist
        ld ix,ReadArcData
        call LoadTSA
        call GetVarInfo \ ret c
GetVarInfoVarFound:
        ex de,hl
        or a
        jr nz,InfoIsArched
          ld c,(hl) \ inc hl
          ld b,(hl) \ inc hl
          ret
InfoIsArched:
        add hl,bc
        ld c,9
        add hl,bc
        bit 7,h
        jr z,$+7
          res 7,h \ set 6,h
          inc a
        push de
        ld de,8478h+11
        ld bc,2
        push de
        call TSA
        pop de
        ex de,hl 
        ld c,(hl) \ inc hl
        ld b,(hl) \ inc hl
        ex de,hl
        pop de \ or a
        ret
GramHandl:
     ld hl,(ErrorLoc)
     ld (progPtr),hl
     or a
     jr nz,$+7
       ld a,6
       jp BreakProgram+1
     dec a
     jr nz,$+7
       ld a,14
       jp BreakProgram+1
     dec a
     jr nz,$+7
       ld a,43
       jp BreakProgram+1
     ret
ONErr:
     xor a \ jr ErrMEM+2
ErrMEM:
     ld a,1
     ld (8595h),a
     jp ErrorJump
C_Div_L:
;Inputs:
;     C is the numerator
;     L is the denominator
;Outputs:
;     A is the remainder
;     B is 0
;     C is the result of C/L
;     D,E,H,L are not changed
;
     ld b,8
     xor a
       sla c
       rla
       cp l
       jr c,$+4
         inc c
         sub l
       djnz $-8
     ret
;=====================================================
TileMap1:
;=====================================================
;Inputs:
;     DE=MapLoc
;     BC=TileLoc
;     HL=MapWidth
;     A=TileLogic
;     (TempWord2)=Map X
;     (TempWord3)=Map Y
;=====================================================
     and 7
     ld (TempWord1),a
     push hl
     cp 7 \ jr nz,$+9
       ld hl,89F0h+33
       ld a,16
       xor (hl)
       ld (hl),a
     pop hl
     push bc
     push hl
     push de
     ld bc,(TempWord3)
     call HL_Times_BC
     ld bc,(TempWord2)
     add hl,bc
     pop bc \ add hl,bc
     pop de \ push hl
     ld hl,-12 \ add hl,de
     pop de
     ld (TempWord2),hl
     xor a \ ld (TempWord1+1),a
     pop bc
;DE points to first Map Element
;(TempWord2) is the map width thing
;BC points to the sprite data     
TileMap1loop:
   ld h,12
     ld a,(de) \ inc de
     dec h
     jr nz,DrawNextTile
       ld hl,(TempWord2)
       add hl,de
       ex de,hl
       ld h,12
DrawNextTile:
     push hl
     ld h,0 \ ld l,a
     add hl,hl
     add hl,hl
     add hl,hl
     ld a,(TempWord1)
     cp 7 \ jr nz,$+3
     add hl,hl
     add hl,bc
     ld a,(TempWord1+1)
     call DrawTile
     ld (TempWord1+1),a
     pop hl
     jr nz,TileMap1Loop+2
     ret
DrawTile:
;Input:
;     A is the tile number to draw
;     HL points to the sprite data
;Output:
;     A is incremented by 1
;     BC is not changed
;     DE is not changed
;     HL is not changed
;     z flag set if A is 96
; jr $
     sub 96 \ ret nc
     push af
     push hl
     push de
     push bc
     ex de,hl
;DE points to sprite
     ld hl,(BufPtr)
     ld bc,768
     add hl,bc
     ld bc,-96
     add hl,bc
     add a,12
     jr nc,$-3
     ld c,a
     inc b
     add hl,bc
     ld bc,0108h
     ld a,(TempWord1)
     call DrawSpriteXxY
     pop bc
     pop de
     pop hl
     pop af
     add a,97
     ret
;===============================================================
HL_SDiv_BC:
;===============================================================
;Performs signed HL/BC
;Speed:   1494 cycles
;Size:    23 bytes +31 bytes
;Inputs:
;     HL is the numerator
;     BC is the denominator
;Outputs:
;     HL is the quotient
;     DE is the remainder
;     BC is not changed
;     A is 0
;     z flag is set
;     c flag is reset
;===============================================================
     ld a,h
     xor b
     and 128
     push af
absHL:
     bit 7,h
     jr z,absBC
     ld a,l \ cpl \ ld l,a
     ld a,h \ cpl \ ld h,a
     inc hl
absBC:
     bit 7,b
     jr z,$+9
     ld a,c \ cpl \ ld c,a
     ld a,b \ cpl \ ld b,a
     inc bc
     add hl,hl
       ld a,15
       ld de,0
SDiv_Loop_1:
         add hl,hl
         ex de,hl
         adc hl,hl
         or a
         sbc hl,bc
         jr c,$+5
           inc e
           jr $+3
         add hl,bc
         ex de,hl
         dec a
         jr nz,SDiv_Loop_1
       pop af
       ret z
       ld a,l \ cpl \ ld l,a
       ld a,h \ cpl \ ld h,a
       inc hl
       ret
OmniCalcFont:
;Inputs:
;    B is the char to draw
     ld l,b
     ld h,0
     ld b,h
     ld c,l
     add hl,hl
     add hl,bc
     add hl,hl
     add hl,bc
     ld bc,(FontPointer)
     add hl,bc
     ld de,8478h
     ld b,7
       ld a,(hl)
       rlca
       rlca
       rlca
       ld (de),a
       inc e
       inc hl
       djnz $-7
     ld de,8478h
     ld hl,0706h
     jr VputSCStepIn
VPutSC:
;Inputs:
;    B is the char to draw
     ld a,b
     cp 20h
     ld hl,(FontPointer)
     ld c,b
     ld b,0
     add hl,bc
     add hl,bc
     add hl,bc
     ld de,8478h
     ld b,3
       ld a,(hl)
       and $F0
       ld (de),a
       inc e
       ld a,(hl)
       rrca \ rrca
       rrca \ rrca
       and $F0
       ld (de),a
       inc e
       inc hl
       djnz $-15
     ld de,8478h
     ld hl,0604h
     jr VputSCStepIn
VPutC:
;Inputs:
;    B is the char to draw
       ld hl,(FontPointer)
       ld de,254
         inc e \ inc e
         add hl,de
         ld e,(hl)
         djnz $-4
       ld d,e \ inc hl
       ld e,(hl) \ inc hl
       ex de,hl
VputSCStepIn:
       push hl
       ld bc,(TextRow)
       ld a,b \ add a,l
       cp 97
       jr c,geykley
         ld a,c
         add a,h \ ld c,a
         ld a,l \ ld b,0
geykley:
       ld l,a
       ld a,c
       cp 58
       jr c,gerkeb
         xor a
         ld c,a
gerkeb:
       ld h,l
       ld l,a
CoordAdj:
       ld (TextRow),hl
       pop hl
       ld a,(OutputLogic)
       jp DrawPixelCoordSprite
RoundHL_Div_C:
;Inputs:
;     HL is the numerator
;     C is the denominator
;Outputs:
;     A is twice the remainder of the unrounded value 
;     B is 0
;     C is not changed
;     DE is not changed
;     HL is the rounded quotient
;     c flag set means no rounding was performed
;            reset means the value was rounded
;
       ld b,16
       xor a
         add hl,hl
         rla
         cp c
         jr c,$+4
           inc l
           sub c
         djnz $-7
       add a,a
       cp c
       ret c
       inc hl
       ret
SearchLine:
;Inputs:
;     HL points to the start
;     BC is the number of bytes to search
;     DE is the line number
;     A is the line byte
;Outputs:
;     A is not changed
;     BC is the number of bytes left for the search
;     DE points to the line
;     HL is the length of the line
;===============================================================
     dec de \ inc d \ inc e
     or a
     ld (TempWord1),hl
SearchLoop:
     cpir                       ;21X-5
     jp po,EndSearchLoop+1
     dec e \ jr nz,SearchLoop-3
     dec d \ jr nz,SearchLoop-3
EndSearchLoop:
     scf
     ld de,(TempWord1)
     sbc hl,de
     ret
DEHL_Mul_IXBC:
     push ix
     push bc
     call DEHL_Mul_32Stack
     pop hl
     pop ix
     ret
DEHL_Mul_32Stack:
;Inputs:
;    DEHL
;    Two pushes to the stack (big endian) with the other 32-bit value
;Outputs:
;    AF is the return address
;    HLDEBC is the lower 48-bit result
;    4 bytes at TempWord1 contain the upper 32-bits of the result
;    4 bytes at TempWord3 contain the value of the input stack values
;    The stack contains two pops to perform:
;       First pop is the bits 33 to 48
;       Second pop is the bits 49 to 64
     ld (TempWord1),hl
     ld (TempWord2),de
     pop bc \ pop hl
     ld (TempWord3),hl
     pop hl
     ld (TempWord4),hl
     push bc
     ld a,32
     ld bc,0
     ld d,b \ ld e,b
Mult32StackLoop:
     ld hl,TempWord1
     sla c \ rl b \ rl e \ rl d
     rl (hl) \ inc hl
     rl (hl) \ inc hl
     rl (hl) \ inc hl
     rl (hl)
     jr nc,OverFlowDone
       ld hl,(TempWord3) \ add hl,bc
       ld b,h \ ld c,l
       ld hl,(TempWord4) \ adc hl,de
       ex de,hl
       jr nc,OverFlowDone
         ld hl,TempWord1
         inc (hl) \ jr nz,OverFlowDone
         inc hl \ inc (hl) \ jr nz,OverFlowDone
         inc hl \ inc (hl) \ jr nz,OverFlowDone
         inc hl \ inc (hl)
OverFlowDone:
     dec a
     jr nz,Mult32StackLoop
     pop af
     ld hl,(TempWord2) \ push hl
     ld hl,(TempWord1) \ push hl
     push af
     ret
PrimeNumbers:
 .db 3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97
 .db 101,103,107,109,113,127,131 ,137,139,149,151,157,163,167.173,179,181
 .db 191,193,197,199,211,223,227,229,233,239,241,251
PutIM:
;Inputs:
;     The string to display immediately follows the call
;       The first two bytes are the size, followed by
;       the string data.
;Outputs:
;     All registers are preserved
      ex (sp),hl
      push de \ push bc \ push af
      ld c,(hl) \ inc hl
      ld b,(hl) \ inc hl
      call PutSM
      pop af \ pop bc \ pop de
      ex (sp),hl
      ret
GPutSI:
;     The string to display immediately follows the call
;       The string is zero terminated
;Outputs:
;     All registers are preserved
      ex (sp),hl
      push de \ push bc \ push af
      call GPutS \ inc hl
      pop af \ pop bc \ pop de
      ex (sp),hl
      ret
DrawRectToGraphI:
      ex (sp),hl
      push de \ push bc \ push af
      ld e,(hl) \ inc hl
      ld c,(hl) \ inc hl
      ld b,(hl) \ inc hl
      ld d,(hl) \ inc hl
      ld a,(hl) \ inc hl
      push hl
      call DrawRectToGraph
      pop hl \ pop af \ pop bc \ pop de
      ex (sp),hl
      ret
ParseFullArgI:
      ex (sp),hl
      push de \ push af
      ld (progPtr),hl
      call ParseFullArg
      pop af \ pop de
      ex (sp),hl
      ret
CallI:
      ex (sp),hl
      push de \ push af
      ld c,l \ ld b,h
      call g_Call
      pop af \ pop de
      ex (sp),hl
      ret
CopyZStr:
      ex (sp),hl
      push bc \ push de \ push af
      xor a
      cp (hl) \ jr z,$+6
      ldi
      jr $-5

      pop af \ pop de \ pop bc
      ex (sp),hl
      ret
CreateZVar:
;Inputs:
;     The name of the var directly follows the call and is zero-terminated
;     BC is the size of the var
;Outputs:
;     AF is preserved
;     BC is the size of the var
;     DE points to the var data
;     HL points to the SymEntry
;Notes:
;     This will delete a preexisting variable
      ex (sp),hl
      push af
      push bc
      push hl
      xor a \ ld b,a \ ld c,a
      cpir
      sub c \ ld c,a \ sbc a,a
      sub b \ ld b,a
      pop de
      inc sp \ inc sp
      pop af
      ex (sp),hl
      push af
      dec sp \ dec sp
      call GetVarInfo+3
      jr c,$+5
        bcall(4FC6h)
      pop hl \ push hl
      ld a,(8478h)
      and 1fh
      bcall(4E70h)
      inc de \ inc de
      pop bc \ push bc
      push de \ push hl
        ex de,hl
        call ZeroMem
      pop hl
      pop de
      pop bc
      pop af
      ret
EditorExit:
;'HL points to the name of the program to edit' 
;   ld   hl,_Your_Prgm_Name_ 
;   ld   de,progToEdit 
;   ld   bc,8 
;   ldir 
;   xor   a 
;   ld   (de),a 
;   ld   a,kPrgmEd 
;   B_CALL(_NewContext) 
;;'BC should hold the offset you would like to jump to' 
;   ld   bc,_Your_Offset_ 
;   ld   de,(editTop) 
;   ld   hl,(editTail) 
;   ldir 
;   ld   (editCursor),de 
;   ld   (editTail),hl 
;   ld   h,b 
;   ld   l,c 
;   push   hl 
;;EditorLoop: 
;   ld   de,(editTop) 
;   or   a 
;   sbc   hl,de 
;   jr   z,EditorFound 
;   B_CALL(_BufLeft) 
;   ld   hl,(editCursor) 
;   ld   a,(hl) 
;   cp   tEnter 
;   jr   z,EditorFound 
;   pop   hl 
;   inc   hl 
;   push   hl 
;   jr   EditorLoop 
;EditorFound: 
;   B_CALL(_BufRight) 
;   B_CALL(_DispEOW) 
;   pop   hl 
;   ld   a,h 
;   or   l 
;   jr   z,EditorMon 
;EditorScroll: 
;   dec   hl 
;   ld   a,h 
;   or   l 
;   jr   z,EditorMon 
;   push   hl 
;   B_CALL(_CursorRight) 
;   pop   hl 
;   jr   EditorScroll 
;EditorMon: 
;   res   2,(iy+50) 
;   res   7,(iy+20) 
;   res   3,(iy+5) 
;   B_JUMP(_Mon) 
;===============================================================
FindVar:
;===============================================================
     ld de,8478h
     ld a,(de)
     and 1Fh
     ld (de),a
     sub 5
     jp z,ChkFindVar+3
     dec a
     jp z,ChkFindVar+3
     sub 15
     jp nc,ChkFindVar+3
;===============================================================
FindSym:
;===============================================================
 ld de,8479h
FindVarSymAtDE: 
 ex de,hl 
FindVarSymAtHL: 
 ld c,(hl) 
 inc hl 
 ld b,(hl) 
SearchVarBC:
 ld hl,$FE60 
SearchForVarLoop: 
  ld a,c 
  cp (hl) 
  dec hl 
  jr nz,$+6             ;2004 is the hex code. I believe this is correct... It skips the next 4 bytes 
   ld a,b 
   cp (hl) 
   jr z,$+16            ;280E This skips the next 14 bytes if z is set. 
  ld de,-8 
  add hl,de 
  ex de,hl 
  ld hl,(9830h) 
  sbc hl,de 
  ex de,hl 
  ld a,d 
  or a 
  ccf 
  jr nz,SearchForVarLoop      ;20E7 
 ld c,3
 inc hl
 inc hl
 ld b,(hl)
 inc hl
 ld d,(hl)
 inc hl
 ld e,(hl)
 inc hl
 inc hl
 inc hl
 ld a,(hl)
 ret
;===============================================================
ChkFindVar:
;===============================================================
;Inputs:
;     OP1 contains the var name to search for
;Outputs:
;     A is the type
;     B is the flashpage
;     C is the name length
;     DE points to the size bytes
;     HL points to the symentry
;Notes:
;     Use to search programs, appvar, groups
;===============================================================
     ld de,8478h
ChkFindVarAtDE:
     ld bc,9
     ld a,(de)
     and 1Fh
     ld (de),a
     ld hl,OP2-1
     cp 5
     jr nz,$+4
     ld (hl),6
     cp 6
     jr nz,$+4
     ld (hl),5
     ex de,hl
     ld a,b
     push hl
     cpir
     jr z,$+3
       dec c
     ld a,7
     sub c
     ld (OP2-2),a
     pop hl
     ld hl,(9830h)
CompareOverLoop:
     ld de,8478h
CompareLoop:
     ld bc,(982Eh)
     or a
     sbc hl,bc
     add hl,bc
     ccf
     ret z
     ld a,(de)
     ld bc,-6
     cp (hl)
     jr z,TypeMatch
     ld a,(OP2-1)
     cp (hl)
     jr z,TypeMatch
       add hl,bc
       ld c,(hl)
       inc c
       inc b
       or a
       sbc hl,bc
       jr CompareLoop
NotMatch:
   pop af
   or a
   sbc hl,bc
   jr CompareOverLoop
TypeMatch:
     add hl,bc
     push hl
     ld a,(OP2-2)
     ld c,(hl)
     dec hl
     inc b
     cp c
     jr nz,NotMatch
     inc de
CompareName:
     ld a,(de)
     inc de
     cpd
     jr nz,NotMatch
     jp pe,CompareName
FoundVar:
     pop hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ld e,(hl)
     inc hl
     inc hl
     inc hl
     ld a,(hl)
     ret
tokenHook:
     .db $83
     ld a,b
     or a
     ret nz
     push hl
     ld hl,(84D3h)
     inc hl
     inc hl
     ld a,3Ah
     cp (hl)
     jr nz,ChkByte2-2
     inc hl
     ld a,30h
     cp (hl)
     jr nz,ChkByte2-2
     inc hl
     ld a,3Eh
     cp (hl)
     jr nz,ChkByte2-2

     ld hl,TokenTable
     ld b,0
TokenSearchLoop:
       ld a,e
       cp (hl)
       inc hl
       jr z,ChkByte2
NotTokenMatch:
       inc hl
       ld c,(hl)
       inc c
       add hl,bc
       ld a,(hl)
       or a
       jr nz,TokenSearchLoop
     pop hl
     ret
ChkByte2:
     ld a,d
     cp (hl)
     jr nz,NotTokenMatch
     ex (sp),hl
     pop hl
     ld de,8478h
     push de
     inc hl
     ld c,(hl)
     inc c \ inc c
     dec hl
     ldir
     pop hl
     ret
NoChange:
TokenTable:
 .db $06,0,8,5,"lFactor"
 .db $28,0,7,"Insert("
 .db $36,0,7,"ClrPart"
 .db $38,0,7,"RunPart"
 .db $3A,0,8,"AddPart("
 .db $3C,0,9,"PartType("
 .db $44,0,5,"Misc("
 .db $58,0,1,5Fh
 .db $BE,0,5,"call "
 .db $38,1,5,"Rect("
 .db $3C,1,5,"Tile("
 .db $3E,1,7,"Sprite("
 .db $40,1,8,"TileMap("
 .db $48,1,9,"Contrast("
 .db $4E,1,9,"ShiftBuf("
 .db $62,1,7,"WriteB("
 .db $70,1,4,"Inv("
 .db $72,1,7,"WriteW("
 .db $A6,1,4,"For "
 .db $B4,1,7,"GetInc("
 .db $BC,1,7,"SetBuf("
 .db $C0,1,8,"SetFont("
 .db $CE,1,8,"MakeVar("
 .db $D0,1,8,"FindVar("
 .db $7E,1,2,"2^"
 .db 0
;===================================================
CommandJumpTable:
 .dw ErrBadToken      ; $00
 .dw ErrBadToken      ; $01
 .dw ErrBadToken      ; $02
 .dw FracToken        ; $03
 .dw StoToken         ; $04
 .dw ErrBadToken      ; $05
 .dw SetData          ; $06
 .dw Ret              ; $07
 .dw LeftBracket      ; $08
 .dw Ret              ; $09
 .dw ErrBadToken      ; $0A
 .dw ErrBadToken      ; $0B
 .dw ErrBadToken      ; $0C
 .dw Squared          ; $0D
 .dw ErrBadToken      ; $0E
 .dw ErrBadToken      ; $0F
 .dw LeftParantheses  ; $10
 .dw Ret              ; $11
 .dw ErrBadToken      ; $12
 .dw PxlTestToken     ; $13
 .dw Augment          ; $14
 .dw ErrBadToken      ; $15
 .dw ErrBadToken      ; $16
 .dw ErrBadToken      ; $17
 .dw ErrBadToken      ; $18
 .dw MaxToken         ; $19
 .dw MinToken         ; $1A
 .dw RToPr            ; $1B
 .dw RToPTheta        ; $1C
 .dw PToRX            ; $1D
 .dw PToRy            ; $1E
 .dw ErrBadToken      ; $1F
 .dw ErrBadToken      ; $20
 .dw ErrBadToken      ; $21
 .dw SolveSet         ; $22
 .dw ErrBadToken      ; $23
 .dw ErrBadToken      ; $24
 .dw ErrBadToken      ; $25
 .dw ErrBadToken      ; $26
 .dw ErrBadToken      ; $27
 .dw ErrBadToken      ; $28
 .dw Incptr           ; $29
 .dw QuoteToken       ; $2A
 .dw Ret              ; $2B
 .dw OSVarToken       ; $2C
 .dw factorialToken   ; $2D
 .dw ErrBadToken      ; $2E
 .dw ErrBadToken      ; $2F
 .dw ConvRStr         ; $30
 .dw ConvRStr         ; $31
 .dw ConvRStr         ; $32
 .dw ConvRStr         ; $33
 .dw ConvRStr         ; $34
 .dw ConvRStr         ; $35
 .dw ConvRStr         ; $36
 .dw ConvRStr         ; $37
 .dw ConvRStr         ; $38
 .dw ConvRStr         ; $39
 .dw SkipLine         ; $3A
 .dw Base2Num         ; $3B
 .dw orLogic          ; $3C
 .dw xorLogic         ; $3D
 .dw Ret              ; $3E
 .dw NewLine          ; $3F
 .dw andLogic         ; $40
 .dw VarToken         ; $41
 .dw VarToken         ; $42
 .dw VarToken         ; $43
 .dw VarToken         ; $44
 .dw VarToken         ; $45
 .dw VarToken         ; $46
 .dw VarToken         ; $47
 .dw VarToken         ; $48
 .dw VarToken         ; $49
 .dw VarToken         ; $4A
 .dw VarToken         ; $4B
 .dw VarToken         ; $4C
 .dw VarToken         ; $4D
 .dw VarToken         ; $4E
 .dw VarToken         ; $4F
 .dw VarToken         ; $50
 .dw VarToken         ; $51
 .dw VarToken         ; $52
 .dw VarToken         ; $53
 .dw VarToken         ; $54
 .dw VarToken         ; $55
 .dw VarToken         ; $56
 .dw VarToken         ; $57
 .dw VarToken         ; $58
 .dw VarToken         ; $59
 .dw VarToken         ; $5A
 .dw VarToken         ; $5B
 .dw VarName          ; $5C
 .dw VarName          ; $5D
 .dw VarName          ; $5E
 .dw prgmToken        ; $5F
 .dw VarName          ; $60
 .dw VarName          ; $61
 .dw VarName          ; $62
 .dw ErrBadToken      ; $63
 .dw ErrBadToken      ; $64
 .dw ErrBadToken      ; $65
 .dw ErrBadToken      ; $66
 .dw ErrBadToken      ; $67
 .dw ErrBadToken      ; $68
 .dw ErrBadToken      ; $69
 .dw Equals           ; $6A
 .dw Less             ; $6B
 .dw Greater          ; $6C
 .dw LessOrEqual      ; $6D
 .dw MoreOrEqual      ; $6E
 .dw NotEqual         ; $6F
 .dw Add              ; $70
 .dw Subtract         ; $71
 .dw AnsToken         ; $72
 .dw FixToken         ; $73
 .dw ErrBadToken      ; $74
 .dw FullToken        ; $75
 .dw FuncToken        ; $76
 .dw ErrBadToken      ; $77
 .dw ErrBadToken      ; $78
 .dw ErrBadToken      ; $79
 .dw ErrBadToken      ; $7A
 .dw ErrBadToken      ; $7B
 .dw ErrBadToken      ; $7C
 .dw ErrBadToken      ; $7D
 .dw ErrBadToken      ; $7E
 .dw ErrBadToken      ; $7F
 .dw ErrBadToken      ; $80
 .dw ErrBadToken      ; $81
 .dw Multiply         ; $82
 .dw Skipline+6       ; $83
 .dw ErrBadToken      ; $84
 .dw ClrDrawToken     ; $85
 .dw ErrBadToken      ; $86
 .dw ErrBadToken      ; $87
 .dw ErrBadToken      ; $88
 .dw ErrBadToken      ; $89
 .dw ErrBadToken      ; $8A
 .dw ErrBadToken      ; $8B
 .dw ErrBadToken      ; $8C
 .dw ErrBadToken      ; $8D
 .dw ErrBadToken      ; $8E
 .dw ErrBadToken      ; $8F
 .dw ErrBadToken      ; $90
 .dw ErrBadToken      ; $91
 .dw ErrBadToken      ; $92
 .dw TextToken        ; $93
 .dw ErrBadToken      ; $94
 .dw nCrToken         ; $95
 .dw ErrBadToken      ; $96
 .dw ErrBadToken      ; $97
 .dw StorePicToken    ; $98
 .dw RecallPicToken   ; $99
 .dw ErrBadToken      ; $9A
 .dw ErrBadToken      ; $9B
 .dw LineToken        ; $9C
 .dw VerticalToken    ; $9D
 .dw PtOn             ; $9E
 .dw PtOff            ; $9F
 .dw PtChange         ; $A0
 .dw PxlTokens        ; $A1
 .dw PxlTokens        ; $A2
 .dw PxlTokens        ; $A3
 .dw ShadeToken       ; $A4
 .dw CircleToken      ; $A5
 .dw HorizontalToken  ; $A6
 .dw TangentToken     ; $A7
 .dw ErrBadToken      ; $A8
 .dw ErrBadToken      ; $A9
 .dw VarName          ; $AA
 .dw RandToken        ; $AB
 .dw PiToken          ; $AC
 .dw GetKeyToken      ; $AD
 .dw Incptr           ; $AE
 .dw ErrBadToken      ; $AF
 .dw Negative         ; $B0
 .dw int              ; $B1
 .dw absToken         ; $B2
 .dw ErrBadToken      ; $B3
 .dw ErrBadToken      ; $B4
 .dw ErrBadToken      ; $B5
 .dw ErrBadToken      ; $B6
 .dw ErrBadToken      ; $B7
 .dw notLogic         ; $B8
 .dw iPart            ; $B9
 .dw ErrBadToken      ; $BA
 .dw BBTokens         ; $BB
 .dw Sqrt             ; $BC
 .dw ErrBadToken      ; $BD
 .dw LnToken          ; $BE
 .dw PowerOf2         ; $BF
 .dw ErrBadToken      ; $C0
 .dw ErrBadToken      ; $C1
 .dw Sin              ; $C2
 .dw ErrBadToken      ; $C3
 .dw Cos              ; $C4
 .dw ErrBadToken      ; $C5
 .dw ErrBadToken      ; $C6
 .dw ErrBadToken      ; $C7
 .dw ErrBadToken      ; $C8
 .dw ErrBadToken      ; $C9
 .dw ErrBadToken      ; $CA
 .dw ErrBadToken      ; $CB
 .dw ErrBadToken      ; $CC
 .dw ErrBadToken      ; $CD
 .dw IfToken          ; $CE
 .dw ParserNext       ; $CF
 .dw ErrBadToken      ; $D0
 .dw WhileToken       ; $D1
 .dw RepeatToken      ; $D2
 .dw ForToken         ; $D3
 .dw EndToken         ; $D4
 .dw Return           ; $D5
 .dw LblToken         ; $D6
 .dw GotoToken        ; $D7
 .dw PauseToken       ; $D8
 .dw StopToken        ; $D9
 .dw ISToken          ; $DA
 .dw ErrBadToken      ; $DB
 .dw InputToken       ; $DC
 .dw ErrBadToken      ; $DD
 .dw DispToken        ; $DE
 .dw DispGraph        ; $DF
 .dw OutputToken      ; $E0
 .dw ClrHomeToken     ; $E1
 .dw FillToken        ; $E2
 .dw ErrBadToken      ; $E3
 .dw ErrBadToken      ; $E4
 .dw ErrBadToken      ; $E5
 .dw ErrBadToken      ; $E6
 .dw SendToken        ; $E7
 .dw GetToken         ; $E8
 .dw ErrBadToken      ; $E9
 .dw ErrBadToken      ; $EA
 .dw ExecLine         ; $EB
 .dw Byte             ; $EC
 .dw Word             ; $ED
 .dw ErrBadToken      ; $EE
 .dw ErrBadToken      ; $EF
 .dw ErrBadToken      ; $F0
 .dw ErrBadToken      ; $F1
 .dw ErrBadToken      ; $F2
 .dw ErrBadToken      ; $F3
 .dw ErrBadToken      ; $F4
 .dw ErrBadToken      ; $F5
 .dw ErrBadToken      ; $F6
 .dw ErrBadToken      ; $F7
 .dw ErrBadToken      ; $F8
 .dw ErrBadToken      ; $F9
 .dw ErrBadToken      ; $FA
 .dw ErrBadToken      ; $FB
 .dw ErrBadToken      ; $FC
 .dw ErrBadToken      ; $FD
 .dw ErrBadToken      ; $FE
 .dw ErrBadToken      ; $FF
ExecLine:
     call ParseFullArg
     push bc
     cp 2Bh
     ld bc,(ProgStart)
     call z,ParseNextFullArg
     push bc
     ld bc,32768
     cp 2Bh
     call z,ParseNextFullArg
     push bc
     cp 2Bh
     ld bc,63
     call z,ParseNextFullArg
     ld a,c
     pop bc
     pop hl
     pop de
     call SearchLine
     ld b,d
     ld c,e
     jp g_expr
     
       

Byte:
 ld b,0
 ld c,(hl)
 inc hl
 ld (progPtr),hl
 ret
Word:
 ld c,(hl)
 inc hl
 ld b,(hl)
 inc hl
 ld (progPtr),hl
 ret
PowerOf2:
 call ParseFullArg
 ld a,c
 ld hl,0
 ld d,h
 ld e,h
 cp 32
 jr nc,Po2End
 inc l
 or a
 jr z,Po2End
 ld b,a
   add hl,hl
   rl e
   rl d
   djnz $-5
Po2End:
 ld b,h
 ld c,l
 ret
; xor a
; or d \ or e \ or b
; ld d,a
; ld e,a
; ld b,a
; ld a,c
; ld c,b
; ret nz
; add a,a
; ld c,a
; sub 32
; ld hl,Po2LUT
; jr c,$+11
;   add a,l
;   jr nc,$+3
;   inc h
;   ld c,d
;   ld e,(hl)
;   inc hl
;   ld d,(hl)
;   ret
; add hl,bc
; ld c,(hl)
; inc hl
; ld b,(hl)
; ret
;Po2LUT:
; .dw 1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768
FrequencyLUT:
 .dw 2100,1990,1870,1770,1670,1580,1490,1400,1320,1250,1180,1110,1050,996,940,887,837,790,746,704,665,627,592,559,527,498,470,444,419,395,373,352,332,314,296,279,264,249,235,222,209,198,186,176,166,157,148,140,132,124,117,111,105,99,93,88,83,78,74,70,66,62,59,55,52,49,47,44,42,39,37,35,33,31,29,28,26,25,23,22,21,20,19,18,17,16,15,14,13,12,11,10,10,9,9,8,8,7,7
; .dw 8192,12288,16384,24576,32796,49194,65535
; .dw 2,3,4,6,8,12,16

Base2Num:
   ld bc,0
   ld d,b
   ld e,c
Base2Loop:
   ld a,(hl)
   sub 30h
   jr c,ExitBase2Loop
   sub 2
   jr nc,ExitBase2Loop
   rrca
   rl c
   rl b
   rl e
   rl d
   inc hl
   jp Base2Loop      ;It saves 2 cycles using JP D:
ExitBase2Loop:
   set 5,(iy+33)
   ld (progPtr),hl
   ret
LnToken:
     ld a,(hl)
     cp $B0
     push bc
     jr z,JumpBack
       call ParseFullArg
       ld d,b \ ld e,c
       ld bc,0
       ld a,3Fh
       cpir
       dec de
       ld a,d \ or e
       jr nz,$-7
       ld (progPtr),hl
       pop bc
       ret
JumpBack:
     call ParseNextFullArg
     ld d,b \ ld e,c
     dec hl
     ld bc,0
     inc de
     ld a,3Fh
     cpdr
     dec de
     ld a,d \ or e
     jr nz,$-7
     ld (progPtr),hl
     pop bc
p_GetByte:
GetByte:
     ld d,3
     ld bc,-1
     xor a
     out (0),a
     in a,(0)
     xor d
     ret z
     ld bc,0800h
GetByteLoop:
     in a,(0)
     bit 1,a
     jr nz,GetByteLoop
     out (0),a
     rra
     rl c
     djnz GetByteLoop
     ret
p_SendByte:
SendByte:
;E is the byte to send
;BC is the wait length
     ld a,3
     out (0),a
     ld d,a
CountSend:
       in a,(0)
       and d
       jr nz,SendByteLoop-2
       dec bc
       ld a,b
       or c
       jr nz,CountSend
       dec bc
       ret
     ld b,8
SendByteLoop:
;E is the byte to send
;D is the mask
     xor a
     rlc e
     jr c,$+3
     inc a
     out (0),a
     djnz SendByteLoop
     xor a
     out (0),a
     ld c,a
     ret
SetHeaderMenu:
       bit 2,(iy+34)
       jr nz,SetASMHeader
       bit 3,(iy+34)
       ld hl,GramHeader
       jr z,SetHeader
       ld hl,NullHeader
       jr SetHeader
SetASMHeader:
       bit 3,(iy+34)
       ld hl,GramASMHeader
       jr z,SetHeader
       ld hl,ASMHeader
SetHeader:
       ld (8000h),hl
       ret
;VarTypes:
; .db 5,0,0      ;Program
; .db 21,0,0     ;Appvar
; .db 22,0,0     ;TempProg
; .db 4,255,0    ;string
; .db 7,255,0    ;pic
; .db 8,255,0    ;gdb
; .db 23,0,0     ;group
; .db 2,255,0    ;matrix
; .db 3,255,0    ;equation
; .db 0,0,0      ;real num
; .db 12,0,0     ;complex num
; .db 1,255,0    ;list
GramHeader:
     .db 3Ah,30h,3Eh
NullHeader:
     .db 0
GramASMHeader:
     .db $BB,6Dh,55h,$C9,0
ASMHeader:
     .db $BB,6Dh,0
ZeroProg:
 .db 5,0
ZeroAVar:
 .db 21,0
GramTempName:
 .db 16h,"GramTemp"
GVarData:
 .db 15h,"GVarData"
StrMirage:
 .db "MirageOS prg",0
StrION:
 .db "ION program",0
StrDCS:
 .db "DCS program",0
StrVersion:
 .db "Grammer v2.22.05.12",0
ChooseProgText:
 .db "Select a program:"
Str8Space:
 .db "        ",0

.echo "Page 0 bytes left: ", $8000 - $
.end
;c is bc>hl
;z is bc=hl
; or a
; sbc hl,bc
; add hl,bc

;hl = minor buffer, de = major buffer, c = mask
;mask is 110110110
;ld a,(de) \ xor (hl) \ and c \ xor (hl)